#include "BMIlib.h"
#include "boost/multi_array.hpp"
#include "boost/numeric/ublas/matrix.hpp"
#include <math.h>
/*

class LSMParameters
{
  public:
    
      float connect13,connect23,connect33,connect43,connect53,connect63,connect73,connect83,connect93,connect103,connect113,connect123,connect133,connect143,connect153;
      //connectivity in hidden layer
      float connect3;
      //connectivity between hidden and output layer
      float connect34,connect35,connect36,connect37;
      //spike parameters
      int taumE,taumI,taurpI,taurpE,threshold,resetE,resetI;
      float delay,taurI,taudI,taurEE,taudEE,taurEI,taudEI;
      //noise parameters
      int munoise;
      float sigmanoise,lamb;
      // connection strengths
      float jie,jii,jistim,jei,jee,jestim,jjestim;
      int fromcortex,fromth;
      //Weight gain is defined for train weight between hidden layer and output layer
      float deltaw1,deltaw2;
      //Weight gain is defined for train in hidden layer
      float deltaw3,deltaw4;
      //hidden layer composition
      int NE1,fNE,NE;
      int NI1,fNI,NI;
      //simulation parameters
      int tsimul,trial,electrode,ref_electrode;
      float dt; 
      
      LSMParameters();
      ~LSMParameters();
};

void LSMCalibration(LSMParameters param, dataset bmiData);

void LSMRunning(int curr_stim, int curr_trial, LSMParameters param, std::vector< std::vector< float > >* outputLayer, dataset bmiData);//,int s, sockaddr_in si_me, sockaddr_in si_other);

float gammln(float xx);//random function for generating random connections

float ran1(long *idum);//random function for generating random connections

float gasdev(long *idum);//random function that can be used  to replace with other above-mentioned random functions

float poidev(float xm, long *idum);//random function that generate the input spike train with "poidev" command 

double gaussrand();*/

void LSMRunningFake(int curr_stim,std::vector< std::vector< float > >* outputLayer);

/////////////////////////
#define MN256_BIAS_ADDR "/dev/stdin"
#define MN256_ADDR  "/dev/stdin"
#define MN256_CLOCK_HZ 10000000 //(f=10 MHz -> dt=100ns)

#define OFF_SINGLE_SPIKE 0
#define OFF_BRD_SPIKE 133120
#define OFF_SET_NONPLASTIC 133632
#define OFF_SET_PLASTIC_LATCH 788992
#define OFF_SET_PLASTIC_HL 1051136

#define SET_SYN 65536
#define RESET_SYN 0

#define RECURRENT_NONPLASTIC 0 
#define ER_NONPLASTIC 131072
#define W0_NONPLASTIC 262144
#define W1_NONPLASTIC 393216
#define BRD_NONPLASTIC 524288

#define RECURRENT_PLASTIC 0
#define BRD_PLASTIC 131072

#define LOW_STATE_PLASTIC 0
#define HIGH_STATE_PLASTIC 65536

#define NEURONS 256
#define PLASTIC_SYN 256
#define NONPLASTIC_SYN 256

#define START_DELAY 0 //9000//in clock cycle

typedef struct spike
{
  unsigned int dTclock;
  unsigned int command;
};

int resetMN256(int handle);

int initMN256(int classes,int neuronPerClass,int Input,int handle);

int trainMN256(matrix2Di trial, int label, int binSize,int classes,int handle);

int configureMN256(matrix2Di W,matrix2Di EI,int classes,int neuronPerClass,int Input,int handle);

int runMN256(matrix2Di trial,int binSize, int handle);

int setNonPlastic(int syn,int neur, int sr,int latch,int handle);

int setPlasticLatch(int syn,int neur,int sr,int latch,int handle);

int setPlasticHL(int syn, int neur, int hl,int handle);

int sendSpike(int syn, int neur,int handle);

int sendSpikeBR(int syn,int handle);

int ms2clock(int ms);

void sendStimToNM256(int curr_stim,std::vector< std::vector< float > >* outputLayer);

///////////missmatch functions//////////////
/*
void divideDataset(dataset* Dataset,PyObject *pValue,int hiddenNeurons,double train_fraction=0.8,double thr=0,double gain=1);

void trainNetwork(PyObject *pValue,PyObject *NN,int neuronsPerClass,int n_epochs=10);

void read(PyObject *pValue);

void create(int input,PyObject *pValue);*/