#include<iostream>
#include<stdio.h> 
#include<string.h> 
#include<stdlib.h> 
#include<unistd.h>
#include<arpa/inet.h>
#include<sys/socket.h>
#include <math.h>
#include <ctime>
#include <cstdlib>
#include <fcntl.h>
#include <Python.h>
#include "boost/multi_array.hpp"
#include "boost/numeric/ublas/matrix.hpp"
#include "boost/numeric/ublas/io.hpp"
#include "arrayobject.h"
#include "UDPlib.h"
#include "NM256lib.h" 

using namespace std;
using namespace boost;
using namespace boost::numeric::ublas;

#define RECEIVE_MEM 65535


const int PORT_OTHER = 9103;   //Port of the other PC
const int  PORT_ME = 9103;   //My port
const char*  IP_OTHER = "10.255.36.196"; //IP adress of the other PC


int main()
{
  struct sockaddr_in si_me, si_other;
  int s,bins,trials,channels,stim;
  int numTestTrial,numTrainTrial,maxSteps,deltaTms=200,interTms=2000,ONTrial=1;;
  bool flag;
  string fileNameTrain="trainData.mat";   
  string fileNameTest="testData.mat";
  std::vector<double> Force(2);
  std::vector<double> position(2);
  std::vector<double> velocity(2);
  std::vector<double>::iterator its;
  std::vector<std::vector<double> >::iterator it;
  int rangeX[2]={-10,10};
  int rangeY[2]={-10,10};
  double zero[2]={0,0};
  int sensoryResolution=2;
  int neuronPerClass=10;
  double xxmass=10,yymass=10;
  double xxdamp=4,yydamp=4;
  double xxstiff=8,yystiff=8;
//   idx4D curr_stim,curr_trial;
  int curr_region,curr_trial;
  short electrodeMap[]={10,5,11,8};
  std::string ACKstring ("ACK");
  std::string TXString;
  int stimElectrode;
  double forceWeight,gainFactor,radius=2;
  short ans;
  int binSizeMs=1; 
  PyObject *pName, *pModule, *pDict;
  PyObject *pFuncInputMatrix,*pFuncOutputMatrix, *pFuncGain,*pFuncData,*pFuncTrain,*pFuncTest, *pFuncTestTot,*pFuncClass;
  PyObject *pArgsInputMatrix,*pArgsOutputMatrix, *pArgsTrain,*pArgsTest,*pArgsData,*pArgsTestTot;
  PyObject *inputWeight,*outputWeight,*outClass,*NN,*inputMN256,*outputGain,*outActivity;
  // open nm256 chip and bias
  int mn256_handle=open(MN256_ADDR, O_RDWR);
  int mn256_bias_handle=open(MN256_BIAS_ADDR, O_RDWR);
  std::srand (std::time(0));
  dataset bmiData(0,0,0,0,"rat");

  // Initialize the Python Interpreter
  Py_Initialize();
  /////////////////////udp parameters/////////////////////
  
  initUDP(&si_me,&si_other,&s,IP_OTHER,PORT_OTHER,PORT_ME);
  
  ////////////////////import dataset//////////////////////
  
  
  cout << "Please enter the maximum convergence steps: ";
  cin >> maxSteps;
  cout << "How many output neurons do you wanna assign to each stimulation? ";
  cin >> neuronPerClass;
  cout << "Do you wanna load or import dataset? [load=1/import=0] ";
  cin >> ans;
  TXString=(static_cast<ostringstream*>( &(ostringstream() << ans ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  if(ans)
  {
    loadData(&bmiData);
    stim=bmiData.data.shape()[3];
  }
  else
  {
    cout << endl << "Waiting for incoming data..." << endl ;
    importDatasetSize(s,si_me,si_other,&bins,&trials,&channels,&stim);
  // //   dataset bmiDataTrain(bins,numTrainTrial,channels,stim,fileNameTrain); //create training dataset object
  // //   dataset bmiDataTest(bins,numTestTrial,channels,stim,fileNameTest); //create training dataset object
  // //   importDataset2(s,si_me,si_other, &bmiDataTrain, &bmiDataTest); 
    bmiData.changeSize(bins,trials,channels,stim);
    importDataset(s,si_me,si_other, &bmiData); 
  }
 // cout<<"Dataset dimension: "<<bmiData.data.shape()[0]<<"x"<<bmiData.data.shape()[1]<<"x"<<bmiData.data.shape()[2]<<"x"<<bmiData.data.shape()[3]<<endl;
  
  cout << "Please enter how many trials you wanna assign to the test set ( dataset is composed by "<<bmiData.trials<<" trials) : ";
  cin >> numTestTrial;
  numTrainTrial=trials-numTestTrial;
  int spikeCount;
  int hiddenNeurons=NEURONS-(neuronPerClass*bmiData.stim);
  std::string data;
  std::string label;
      
  
  ////////////////NN training////////////////////////
  
  cout << "Do you wanna perform the NN training? [yes=1/no=0] ";
  cin >> ans;
  if(ans)
  {
   
    cout << "Do you wanna perform the training on chip? [yes=1/no=0] ";
    cin >> ans;
    if(ans)
    {
//       resetMN256(mn256_handle);
      cout<<"MN256 RESETTED!"<<endl;
//       initMN256(stim,neuronPerClass,channels-1,mn256_handle);
      cout<<"MN256 INITIALIZED!"<<endl;
      matrix2Di trial(channels-1,bins);
      trial.clear();
      //training loop
      for(int j=0;j<numTrainTrial;j++)
      {
	for(int l=0;l<bmiData.stim;l++)
	{
	  for(int i=0;i<bmiData.bins;i++)
	  {
	    for(int k=0;k<bmiData.channels-1;k++)
	    {
// 	      trial(k,i)=bmiDataTrain.data[i][j][k][l]; //extract single trial
	    }
	  }
	  //train trial by trial the mn256
	  cout<<"Num Trial: "<<j+1<<"; Num stim: "<<l+1<<endl; 
// 	  trainMN256(trial,l,binSizeMs,stim,mn256_handle);
	  //maybe here we need such ms pause to let the mn256 free to evolve
	}
      }
      cout<<"END OF TRAINING!"<<endl;
    }
    else
    {
      //python training code
      
      
      //reconfigure dataset
      for(int l=0;l<bmiData.stim;l++)
      {
	for(int i=0;i<bmiData.trials;i++)
	{
	  for(int j=0;j<bmiData.channels;j++)
	  {
	    spikeCount=0;
	    for(int k=0;k<bmiData.bins;k++)
	    {
	      spikeCount=spikeCount+bmiData.data[k][i][j][l];
	    }
	    data += (static_cast<ostringstream*>( &(ostringstream() << spikeCount ) )->str() );
	    data += ',';
// 	    data[j+i*bmiData.channels+l*bmiData.trials*bmiData.channels]=(char)(((int)'0')+spikeCount); //da cambiare, quando supero i 9 spike scazza
// 	    cout<<data[j+i*bmiData.channels+l*bmiData.trials*bmiData.channels];
	  }
// 	  label[i+l*bmiData.trials]=(char)(((int)'0')+l);
	  label += (static_cast<ostringstream*>( &(ostringstream() << l ) )->str() );
	  label += ',';
	}
      }
//       data[bmiData.trials*bmiData.stim*bmiData.channels]='\0';
//       label[bmiData.trials*bmiData.stim]='\0';
//       cout<<endl;

      PyRun_SimpleString("import sys");
      PyRun_SimpleString("sys.path.append(\".\")");
      // Build the name object
      pName = PyString_FromString("mn256");
      PyErr_Print();
      // Load the module object
//       cout<<"chiamo il modulo mn256.py"<<endl;
      pModule = PyImport_Import(pName);
      PyErr_Print();
      // pDict is a borrowed reference 
      pDict = PyModule_GetDict(pModule);
      PyErr_Print();
      // pFunc is also a borrowed reference 
      cout<<"Creating Dataset..."<<endl;
      pFuncData = PyDict_GetItemString(pDict, "createDataset");
      PyErr_Print();
      //preparing data to pass as python parameter
      pArgsData = Py_BuildValue ("(ssiid)",data.c_str(),label.c_str(),bmiData.channels,hiddenNeurons,(double)numTrainTrial/(double)bmiData.trials);
      PyErr_Print();
      
      if (PyCallable_Check(pFuncData)) 
      {
	  inputMN256=PyObject_CallObject(pFuncData, pArgsData);
	  
      } else 
      {
	  PyErr_Print();
      }
      
  
      if (inputMN256 != NULL) 
      {
	  cout<<"Dataset created"<<endl;
      }
      else 
      {
	cout<<"Error during dataset generation!"<<endl;
	  PyErr_Print();
      }
  
      //train NN
      cout<<"Training neural network..."<<endl;
      pFuncTrain = PyDict_GetItemString(pDict, "train_mn256");
      PyErr_Print();
      //preparing data to pass as python parameter
      pArgsTrain = Py_BuildValue ("(Oii)",inputMN256,neuronPerClass,10);
      PyErr_Print();
      
      if (PyCallable_Check(pFuncTrain)) 
      {
	  NN=PyObject_CallObject(pFuncTrain, pArgsTrain);
	  
      } 
      else 
      {
	  PyErr_Print();
      }
  
      //////////////////////////////////////////////////////
      //test NN
      cout<<"Testing neural network..."<<endl;
      pFuncTestTot = PyDict_GetItemString(pDict, "perf_mn256");
      PyErr_Print();
      //preparing data to pass as python parameter
      pArgsTestTot = Py_BuildValue ("(OO)",NN,inputMN256);
      PyErr_Print();
      
      if (PyCallable_Check(pFuncTestTot)) 
      {
	  PyObject_CallObject(pFuncTestTot, pArgsTestTot);
      } 
      else 
      {
	  PyErr_Print();
      }
      
      //compute gain factor
      
      cout<<"Computing gain factor..."<<endl;
      pFuncGain = PyDict_GetItemString(pDict, "compute_gain");
      PyErr_Print();
      
      if (PyCallable_Check(pFuncGain)) 
      {
	  outputGain=PyObject_CallObject(pFuncGain, pArgsTestTot);
      }
      else 
      {
	  PyErr_Print();
      }
      gainFactor=PyFloat_AS_DOUBLE(outputGain);
      cout<< "Gain : "<<gainFactor<<endl;
      
      
      ///////////////////////////////////////////////////////
      
      //built weight and Excitatory/inhibitory matrices
      matrix2Di W(NEURONS,PLASTIC_SYN+NONPLASTIC_SYN);
      W.clear();
      
      //read input matrix (static)
      cout<<"Extracting input weight matrix.."<<endl;
      pFuncInputMatrix = PyDict_GetItemString(pDict, "inputMatrix");
      PyErr_Print();
      //preparing data to pass as python parameter
      pArgsInputMatrix = Py_BuildValue ("(O)",inputMN256);
      PyErr_Print();
      
      if (PyCallable_Check(pFuncInputMatrix)) 
      {
	  inputWeight=PyObject_CallObject(pFuncInputMatrix, pArgsInputMatrix);
      } 
      else 
      {
	  PyErr_Print();
      }
      
      if(inputWeight != NULL)
      {
	PyArrayObject* obj = PyArray_GETCONTIGUOUS( (PyArrayObject*) inputWeight );  
	long* dims = obj->dimensions; // not copying data   
	double* data = (double*) obj->data; // not copying data
	int k=0;
	// output vector result
	for( int i=0; i<dims[0]; i++ )
	{
	  for( int j=0; j<dims[1]; j++ )
	  {
	    W(i,j+NONPLASTIC_SYN)=data[k++];
	  }
	}
      }
      //read output matrix(plastic)
      cout<<"Extracting output weight matrix.."<<endl;
      pFuncOutputMatrix = PyDict_GetItemString(pDict, "activityMatrix");
      PyErr_Print();
      //preparing data to pass as python parameter
      pArgsOutputMatrix = Py_BuildValue ("(O)",NN);
      PyErr_Print();
      
      if (PyCallable_Check(pFuncOutputMatrix)) 
      {
	  outputWeight=PyObject_CallObject(pFuncOutputMatrix, pArgsOutputMatrix);
      } 
      else 
      {
	  PyErr_Print();
      }
      if(outputWeight != NULL)
      {
	PyArrayObject* obj = PyArray_GETCONTIGUOUS( (PyArrayObject*) outputWeight );  
	long* dims = obj->dimensions; // not copying data   
	double* data = (double*) obj->data; // not copying data
	int k=0;
	// output vector result
	for( int i=0; i<dims[0]; i++ )
	{
	  for( int j=0; j<dims[1]; j++ )
	  {
	    W(i+hiddenNeurons,j)=data[k++];
	  }
	}
      }
      
      //here's the code to built the W matrix
      matrix2Di EI(W);
      //reset mn256 chip
//       resetMN256(mn256_handle);
      
      //send calibration data to the nm256
//       configureMN256(W,EI,stim,neuronPerClass,channels,mn256_handle);
    }
  }
  

  sensoryField SF(rangeX,rangeY,zero,stim,sensoryResolution);
  forceField motorMap(rangeX,rangeY,zero,xxstiff,yystiff,SF);
 
  
  
  /////////////////send sensory field and motor map to matlab client for visualization///////////////
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << rangeX[0] ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << rangeX[1] ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << rangeY[0] ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << rangeY[1] ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << zero[0] ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << zero[1] ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << SF.resolution ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << xxstiff ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << yystiff ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << radius ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  cout<<"Workspace dimension trasnmitted!"<<endl;
  
  int counter=0;
  for(int y=rangeY[0];y<=rangeY[1];y++)
  {
    for(int x=rangeX[0];x<=rangeX[1];x++)
    {
      counter++;
      TXString.erase();
     
      motorMap.computeForce(double(x),double(y),&Force);
      TXString += (static_cast<ostringstream*>( &(ostringstream() << Force[0] ) )->str() );
      TXString += ' ';
      TXString += (static_cast<ostringstream*>( &(ostringstream() << Force[1] ) )->str() );
      
//       printf("Upload motor map %d%%\n", counter*100/((-rangeY[0]+rangeY[1]+1)*(-rangeX[0]+rangeX[1]+1)) );
      
      sendUDPString( s,si_other,&TXString);
      if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
    }
  }
  
  
  for (it=motorMap.meanForce.begin();it != motorMap.meanForce.end();++it)
  {
    TXString.erase();
    for(its=it->begin();its != it->end();++its)
    {
      TXString += (static_cast<ostringstream*>( &(ostringstream() << *its ) )->str() );
      TXString += ' ';
    }
     sendUDPString( s,si_other,&TXString);
     if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  }
    
  counter=0;
  for(int r=0;r<SF.map.size1();r++)
  {
    TXString.erase();
    for(int c=0;c<SF.map.size2();c++)
    {
      counter++;
      TXString += (static_cast<ostringstream*>( &(ostringstream() << SF.map(r,c) ))->str() );
      TXString += ' ';
      
//       printf("Upload sensory map %lu%%\n", counter*100/(SF.map.size1()*SF.map.size2()) );
    }
    sendUDPString( s,si_other,&TXString);
    if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  }
  
  ////////////////////////BMI running/////////////////////////////
  
  /* 1)decide init position
   * 2)stim the related electrode
   * 3)record the evoked activity
   * 4)run LSM
   * 5)decode output into a force
   * 6)apply the force to the DS
   * 7)move the DS accordingly to the ODE
   * 8)after deltaT acquire current possition and restart from 2)
   */
  dynamicParam DS(xxmass,yymass,xxdamp,yydamp,rangeX,rangeY,zero,radius,deltaTms,interTms);
  motorHandle motorFeeder(rangeX,rangeY);
  initMotor(&motorFeeder);
  //calibration
  cout << "Do you wanna check motor? [yes=1/no=0] ";
  cin >> ans;
  if(ans==1) calibrateMotor(motorFeeder);
  
  while(ONTrial==1)
  {
    TXString="777"; //777 code define the event "start trial"
    sendUDPString( s,si_other,&TXString);
    if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
    
    //set initial condition
    bool pos_ok=false;
    
    while(pos_ok==false)
    {
      cout << "\nInsert initial 'x' position ( x:["<<rangeX[0]<<","<<rangeX[1]<<"] ) -> ";
      cin >> position[0];
      if(position[0]<rangeX[0] || position[0]>rangeX[1])
      {
	cout << "x coordinate out of bounds"<<endl;
	pos_ok=false;
      }
      else
      {
	pos_ok=true;
      }
    }
    
    pos_ok=false;
    while(pos_ok==false)
    {
      cout << "Insert initial 'y' position ( y:["<<rangeY[0]<<","<<rangeY[1]<<"] ) -> ";
      cin >> position[1];
      if(position[1]<rangeY[0] || position[1]>rangeY[1])
      {
	cout << "y coordinate out of bounds"<<endl;
	pos_ok=false;
      }
      else
      {
	pos_ok=true;
      }
    }
    
    moveMotor(position,motorFeeder); //move feeder into initial position
    
    velocity[0]=0;
    velocity[1]=0;
    
    int currStep=0;
    bool targetReached=false;
    
    //start BMI loop
    cout << "Do you wanna use MN256 or Simulated NN? [mn256=1/simNN=0] ";
    cin >> ans;
    while(currStep<maxSteps)
    {
      //stim the related electrode
      long outputClass=-1;
      curr_region=SF.whichRegion(position[0],position[1]);
      stimElectrode=electrodeMap[curr_region];
      cout<<endl<<"timeStep: "<< currStep <<", pos:("<<position[0]<<","<<position[1]<<") -> region:"<< curr_region <<"   electrode:"<<stimElectrode<<endl<<endl;

      ////////////////////////////////////////////////Substitute with the new NN code//////////////////////////////////////////////////////////
      //select evoked activity and runBMI
      std::vector<float> outputLayer;
      outputLayer.resize(bmiData.stim);  

      
      if(ans)
      {
// 	sendStimToNM256(curr_region,&outputLayer);
      }
      else
      {
// 	cout<<"chiamo la funzione our_mn256"<<endl;
	pFuncTest = PyDict_GetItemString(pDict, "out_mn256");
	PyErr_Print();
	//preparing data to pass as python parameter
	pArgsTest = Py_BuildValue ("(OOi)",NN,inputMN256,curr_region);
	PyErr_Print();
	
// 	cout<<"chiamo la funzione classify_mn256"<<endl;
	pFuncClass = PyDict_GetItemString(pDict, "classify_mn256");
	PyErr_Print();
	
	
	if (PyCallable_Check(pFuncTest) && PyCallable_Check(pFuncClass)) 
	{
	    
	    outClass=PyObject_CallObject(pFuncClass, pArgsTest);
	    outputClass=PyInt_AsLong(outClass);
	    cout<< "Stim : "<<curr_region+1 <<"  Output Class: "<<outputClass+1<<endl;
	    outActivity=PyObject_CallObject(pFuncTest, pArgsTest);
	   
	} else 
	{
	    PyErr_Print();
	}
	
	if(outActivity != NULL)
	{
	  PyArrayObject* obj = PyArray_GETCONTIGUOUS( (PyArrayObject*) outActivity );  
	  int ndims = obj->nd;
	  long* dims = obj->dimensions; // not copying data   
	  double* data = (double*) obj->data; // not copying data
	  // output vector result
	  for( int i=0; i<dims[0]; i++ )
	  {
	    outputLayer[i]=data[i];
	  }
	}
      }  
      
      cout << "Output neuron 1 : "<<outputLayer[0]<<endl;
      cout << "Output neuron 2 : "<<outputLayer[1]<<endl;
      cout << "Output neuron 3 : "<<outputLayer[2]<<endl;
      cout << "Output neuron 4 : "<<outputLayer[3]<<endl;
      
      //decode the NN output into a force
      decoder(motorMap,outputLayer,gainFactor/2,&Force);
      
      cout<<"Force -> ["<<Force[0]<<", "<<Force[1]<<"]"<<endl;
      TXString = "888 "; //888 code define the event "Force component"
      TXString += (static_cast<ostringstream*>( &(ostringstream() << Force[0] ) )->str() );
      TXString += ' ';
      TXString += (static_cast<ostringstream*>( &(ostringstream() << Force[1] ) )->str() );
      sendUDPString( s,si_other,&TXString);
      if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
      TXString.clear();
      
      TXString = (static_cast<ostringstream*>( &(ostringstream() << position[0] ) )->str() );
      TXString += ' ';
      TXString += (static_cast<ostringstream*>( &(ostringstream() << position[1] ) )->str() );
      sendUDPString( s,si_other,&TXString);
      if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
      TXString.clear();
      
      //apply force to DS
      targetReached=DynSys(DS,&position,&velocity,Force,motorFeeder,s,si_me,si_other);
      
      currStep++;
      
      if(targetReached) break;
    }
    
    if(targetReached==false)
    {
      TXString="-999"; //-999 code define the event "target NOT reached"
      sendUDPString( s,si_other,&TXString);
      if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
    }
    
    cout << "Do you wanna perform another trial? [yes=1/no=0] ";
    cin >> ONTrial;
  
  } 
  
  stopMotor(motorFeeder);
  TXString="-777"; //-777 code define the event "end of experiment"
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  
  //////////////////// END ///////////////////////////////////////
  Py_Finalize();
  close(mn256_handle);
  close(s);
  printf("Session closed\n");
  
  
  return 0;
}
