#include <iostream>
#include <stdio.h> 
#include <string> 
#include <stdlib.h> 
#include <unistd.h>
#include <math.h>
#include <fstream>
#include <ctime>
#include <stddef.h>
#include <fcntl.h>
#include <Python.h>
#include "NM256lib.h"
#include "boost/multi_array.hpp"
#include <boost/random/mersenne_twister.hpp>
#include <boost/random/uniform_int_distribution.hpp>


#define IA 16807             
#define IM 2147483647
#define AM (1.0/IM)
#define IQ 127773
#define IR 2836
#define NTAB 32
#define NDIV (1+(IM-1)/NTAB)
#define EPS 1.2e-7
#define RNMX (1.0-EPS)

/*
LSMParameters::LSMParameters()
{
      connect13=connect23=connect33=connect43=connect53=connect63=connect73=connect83=connect93=connect103=connect113=connect123=connect133=connect143=connect153=0.39;
      //connectivity in hidden layer
      connect3=0.6;
      //connectivity between hidden and output layer
      connect34=connect35=connect36=connect37=1;
      //spike parameters
      taumE=20;
      taumI=10;
      taurpI=1;
      taurpE=2;
      threshold=18;
      resetE=resetI=11;
      delay=1;
      taurI=0.25;
      taudI=5;
      taurEE=0.4;
      taudEE=2;
      taurEI=0.2;
      taudEI=1;
      //noise parameters
      munoise=1;
      sigmanoise=0.25;
      lamb=0.03;
      // connection strengths
      jie=0.7;
      jii=2.7;
      jistim=0.95;
      jei=1.7;
      jee=0.42;
      jestim=1;
      jjestim=0.43;
      fromcortex=5;
      fromth=5;
      //Weight gain is defined for train weight between hidden layer and output layer
      deltaw1=2;
      deltaw2=0.3;
      //Weight gain is defined for train in hidden layer
      deltaw3=0.025;
      deltaw4=0.000001;
      //hidden layer composition
      NE1=fNE=NE=40;
      NI1=fNI=NI=10;
      //simulation parameters
      tsimul=600;
      trial=1;
      dt=0.05; 
      electrode=16;
      ref_electrode=2;
}

LSMParameters::~LSMParameters()
{

}*/
// /*
// void LSMCalibration(LSMParameters param,dataset bmiData)
// {
//   
// 
//   /************* Output file names ***************
//   
//   // input spike train from input nodes to hidden layer(first column is time of spike train and second column is neuron number that recive spike from input)
//   #define inp1 "input1.txt" 
//   #define inp2 "input2.txt"
//   #define inp3 "input3.txt"
//   #define inp4 "input4.txt"
//   #define inp5 "input5.txt"
//   #define inp6 "input6.txt"
//   #define inp7 "input7.txt"
//   #define inp8 "input8.txt"
//   #define inp9 "input9.txt"
//   #define inp10 "input10.txt"
//   #define inp11 "input11.txt"
//   #define inp12 "input12.txt"
//   #define inp13 "input13.txt"
//   #define inp14 "input14.txt"
//   #define inp15 "input15.txt"
//   
//   // "3" symbols for hidden and "4"-"7" for output neurons
//   //in testspiketimesE3 first column is time of spike and second column is neuron number that have firing activity in hidden layer
//   //in testspiketimesE4-7 first column is time of spike
//   //in testspiketimesE3-7 Separating trials with "123456" phrase 
//   #define testSTE3t "trainspiketimesE3.txt"//output file to show firing activity in hidden layer ("3" is a symbole for hidden layer)
//   #define testSTE4t "trainspiketimesE4.txt"//output file to show firing activity in the first output neuron("4" is a symbole for the first neuron in the output layer)
//   #define testSTE5t "trainspiketimesE5.txt"//output file to show firing activity in the second output neuron ("5" is a symbole for the second neuron in the output layer)
//   #define testSTE6t "trainspiketimesE6.txt"//output file to show firing activity in the third output neuron("6" is a symbole for the third neuron in the output layer)
//   #define testSTE7t "trainspiketimesE7.txt"//output file to show firing activity in the forth output neuron("7" is a symbole for the forth neuron in output layer)
//   
//   //in connectivity matrix first column is number of input electrode and second column is number of neuron in hidden layer 
//   #define cm13 "cmatrix13.txt"//connectiviry matrix between first input and hidden layer
//   #define cm23 "cmatrix23.txt"//connectiviry matrix between second input and hidden layer
//   #define cm33 "cmatrix33.txt"//connectiviry matrix between third input and hidden layer
//   #define cm43 "cmatrix43.txt"//connectiviry matrix between forth input and hidden layer
//   #define cm53 "cmatrix53.txt"//connectiviry matrix between fifth input and hidden layer
//   #define cm63 "cmatrix63.txt"
//   #define cm73 "cmatrix73.txt"
//   #define cm83 "cmatrix83.txt"
//   #define cm93 "cmatrix93.txt"
//   #define cm103 "cmatrix103.txt"
//   #define cm113 "cmatrix113.txt"
//   #define cm123 "cmatrix123.txt"
//   #define cm133 "cmatrix133.txt"
//   #define cm143 "cmatrix143.txt"
//   #define cm153 "cmatrix153.txt"//connectiviry matrix between Fifteenth input and hidden layer
//   
//   
//   #define cm3 "cmatrix3.txt"//connectiviry matrix in hidden layer(first column and second column are number of neuron in hiden layer)
//   #define cm34 "cmatrix34.txt"//connectiviry matrix between hidden layer and first output(first column is 1(first output) and second column is number of neuron in hidden layer )
//   #define cm35 "cmatrix35.txt"//connectiviry matrix between hidden layer and second output(first column is 2(second output) and second column is number of neuron in hidden layer )
//   #define cm36 "cmatrix36.txt"//connectiviry matrix between hidden layer and third output(first column is 3(third output) and second column is number of neuron in hidden layer )
//   #define cm37 "cmatrix37.txt"//connectiviry matrix between hidden layer and forth output(first column is 4(forth output) and second column is number of neuron in hidden layer )
//   
//   //excitatory weights
//   #define jeee3 "conect3.txt"//weight matrix in hidden layer(Fifty first row are excitatory weights between first neuron in hidden layer and Forty-nine other neurons and ....)
//   #define jeee4 "conect4.txt"//weight matrix between hidden layer and first neuron in output layer(excitatory weights between first neuron in output layer and Forty pyramidal neurons in hidden layer)
//   #define jeee5 "conect5.txt"//weight matrix between hidden layer and second neuron in output layer(excitatory weights between second neuron in output layer and Forty pyramidal neurons in hidden layer)
//   #define jeee6 "conect6.txt"//weight matrix between hidden layer and third neuron in output layer(excitatory weights between third neuron in output layer and Forty pyramidal neurons in hidden layer)
//   #define jeee7 "conect7.txt"//weight matrix between hidden layer and forth neuron in output layer(excitatory weights between forth neuron in output layer and Forty pyramidal neurons in hidden layer)
//  //calibration process of the LSM
//   printf("Calibration in progress...\n");
//   
//   
//   /**************Simulation parameters****************
// 
//   float dt=param.dt; // timestep (ms)
//   int  tsimul=param.tsimul; // duration (ms)
// 
// 
//   /****************Synaptic parameters*****************
// 
//   // times (ms)
// 
//   float delay=param.delay;
//   float taurI=param.taurI; /*rise time of i synaptic currents 
//   float taudI=param.taudI;   /*decay time of i synaptic current
// 
//   // E==>E
// 
//   float taurEE=param.taurEE;   /*rise time of e synaptic currents 
//   float taudEE=param.taudEE;    /*decay time of e synaptic current 
// 
//   //E==>I
//   float taurEI=param.taurEI;   /*rise time of e synaptic currents 
//   float taudEI=param.taudEI;    /*decay time of e synaptic current 
// 
//   // connection strengths
// 
//   float jie=param.jie;
//   float jii=param.jii;
//   float jistim=param.jistim;
//   float jei=param.jei;
//   float jee=param.jee;
//   float jestim=param.jestim;
// 
// 
// 
//   /*******basic parameters****
//   int NE=param.NE;
//   int NE1=param.NE1;
//   int fNE=param.fNE;
//   int NI=param.NI;
//   int NI1=param.NI1;
//   int fNI=param.fNI;
//   int neurtosave=NE+NI;
//   int fromcortex=param.fromcortex;
//   int fromth=param.fromth;
//   
//   //connectivity between input and hidden layer
//   float connect13 = param.connect13;
//   float connect23 = param.connect23 ;
//   float connect33 = param.connect33 ;
//   float connect43 = param.connect43 ;
//   float connect53 = param.connect53 ;
//   float connect63 = param.connect63 ;
//   float connect73 = param.connect73 ;
//   float connect83 = param.connect83 ;
//   float connect93 = param.connect93 ;
//   float connect103 = param.connect103 ;
//   float connect113 = param.connect113 ;
//   float connect123 = param.connect123 ;
//   float connect133 = param.connect133 ;
//   float connect143 = param.connect143 ;
//   float connect153 = param.connect153 ;
//   //connectivity in hidden layer
//   float connect3 = param.connect3;
//   //connectivity between hidden and output layer
//   float connect34 = param.connect34 ;
//   float connect35 = param.connect35 ;
//   float connect36 = param.connect36 ;
//   float connect37 = param.connect37 ;
//   //Weight gain is defined for train weight between hidden layer and output layer
//   float deltaw1=param.deltaw1;
//   float deltaw2=param.deltaw2;
//   //Weight gain is defined for train in hidden layer
//   float deltaw3=param.deltaw3;
//   float deltaw4=param.deltaw4;
//   /*******basic parameters****
//   
//   int LOW =0;
//   int HIGH =1000;
//   int taumE=param.taumE;  
//   int taumI=param.taumI;
//   int taurpI=param.taurpI;
//   int taurpE=param.taurpE;
//   int threshold=param.threshold;
//   int resetE=param.resetE;
//   int resetI=param.resetI;
//   int munoise=param.munoise;
//   float sigmanoise=param.sigmanoise;
//   float lamb=param.lamb;
// 
// 
//   int time = param.tsimul;
//   int trail = param.trial;
//   int electrod = param.electrode-1;
// 
// 
//   /********Stimulus variables*************************************
// 
//   float frnoise, frspont,frstim1,frstim2,frstim4,frstim5,frstim,base,num,frstim1m,frstim2m,frstim4m,frstim5m,frstimm,ffrstim11,ffrstim12,ffrstim13,ffrstim14,ffrstim15,ffrstim21,ffrstim22,ffrstim23,ffrstim24,ffrstim25,ffrstim31,ffrstim32,ffrstim33,ffrstim34,ffrstim35,ffrstim41,ffrstim42,ffrstim43,ffrstim44,ffrstim45,ifrstim;
//   int stimbin, noisebin,seed,stim1,stim2,stim4,stim5,stim, noise,stim1m,stim2m,stim4m,stim5m,stimm,fstim11,fstim12,fstim13,fstim14,fstim15,fstim21,fstim22,fstim23,fstim24,fstim25,fstim31,fstim32,fstim33,fstim34,fstim35,fstim41,fstim42,fstim44,fstim43,fstim45,istim;
//   double connect12,connect14,connect15,connect24,connect25,connect45;
//   double connect12m,connect14m,connect15m,connect24m,connect25m,connect45m;
//   /*************Output variables************************
// 
//   FILE *spiketimesE1m,*spiketimesE2m,*spiketimesE4m,*spiketimesE5m,*conect3,*conect4,*conect5,*conect6,*conect7;
//   float lfpt1m,lfpt2m,lfpt4m,lfpt5m,curreccecc1m,curreccecc3m,curreccecc4m,curreccecc5m,curreccecc6m,curreccecc7m,curreccecc8m,curreccecc9m,curreccecc2m, curreccin1m, curreccin2m, curreccin3m, curreccin4m, curreccin5m, curreccin6m, curreccin7m, curreccin8m, curreccin9m, currinecc1m,currinecc2m,currinecc3m,currinecc4m,currinecc5m,currinecc6m,currinecc7m,currinecc8m,currinecc9m, currinin1m,currinin2m,currinin3m,currinin4m,currinin5m,currinin6m,currinin7m,currinin8m,currinin9m,curreccth1m,curreccth2m,curreccth3m,curreccth4m,curreccth5m,curreccth6m,curreccth7m,curreccth8m,curreccth9m, currecclongm, currinth1m, currinth2m, currinth3m, currinth4m, currinth5m, currinth6m, currinth7m, currinth8m, currinth9m, currinlongm;
// 
//   //randomization variables
// 
//   float accaso;
//   long idum;
//   float xm;
//   float gasdev(long *idum);      /** recipes routine for Gaussian 
//   float ran1(long *idum);       /** recipes routine for uniform deviate 
//   float poidev(float xm, long *idum);        /** recipes routine for Poisson 
// 
//   int i,zz1,zz2,zz4,zz5,zz12,zz14,zz25,zz45,zz1m,zz2m,zz4m,zz5m,zz12m,zz14m,zz25m,zz45m,j,zz15,zz24,zz15m,zz24m; //counters
//   int CYCSIZE, tminx, icycle, sub,delaysub;
//   int ineur,nneur,jn1,jn2,jn4,jn5,jn12,jn14,jn25,jn45,jn1m,jn2m,jn4m,jn5m,jn12m,jn14m,jn25m,jn45m,jn15,jn24,jn15m,jn24m,in,ipr,ip;
//   int vi1[NE+NI],vi2[NE+NI],vi4[NE+NI],vi5[NE+NI],vi1m[NE+NI],vi2m[NE+NI],vi4m[NE+NI],vi5m[NE+NI]; 	/* current firing */
//   int tspki1[NE+NI],tspki2[NE+NI],tspki4[NE+NI],tspki5[NE+NI];/* Time of last spike */ 	/* Time of last spike */
//   int tspki1m[NE+NI],tspki2m[NE+NI],tspki4m[NE+NI],tspki5m[NE+NI];
//   int Ncon1[NE+NI],Ncon2[NE+NI],Ncon12[NE+NI],Ncon4[NE+NI],Ncon45[NE+NI],Ncon25[NE+NI],Ncon5[NE+NI],Ncon14[NE+NI],Ncon15[NE+NI],Ncon24[NE+NI];  /* connection number */
//   int Ncon1m[NE+NI],Ncon2m[NE+NI],Ncon12m[NE+NI],Ncon4m[NE+NI],Ncon45m[NE+NI],Ncon25m[NE+NI],Ncon5m[NE+NI],Ncon14m[NE+NI],Ncon15m[NE+NI],Ncon24m[NE+NI]; 
//   int **A1,**A2,**A12,**A4,**A5,**A25,**A45,**A14,**A15,**A24,**A15m,**A24m,**A1m,**A2m,**A12m,**A4m,**A5m,**A25m,**A45m,**A14m;
//   float **hrece1,**hreci1,**hrece2,**hreci2,**hrece12,**hreci12,**hrece4,**hreci4,**hrece5,**hreci5,**hrece15,**hreci15,**hrece24,**hreci24,**hrece45,**hreci45,**hrece25,**hreci25,**hrece14,**hreci14;
//   float **hrece1m,**hreci1m,**hrece2m,**hreci2m,**hrece12m,**hreci12m,**hrece4m,**hreci4m,**hrece5m,**hreci5m,**hrece15m,**hreci15m,**hrece24m,**hreci24m,**hrece45m,**hreci45m,**hrece25m,**hreci25m,**hrece14m,**hreci14m;
//   float hi1[NE+NI],hi4[NE+NI],hi5[NE+NI],hi2[NE+NI]; /*potentials*/
//   float hi1m[NE+NI],hi4m[NE+NI],hi5m[NE+NI],hi2m[NE+NI]; /*potentials*/
//   
// 
//   int fzz3,fzz5,fzz4,fzz6,fzz7; //counters
//   int fjn3,fjn4,fjn5,fjn6,fjn7;
//   int fvi3[NE1+NI1],fvi4,fvi5,fvi6,fvi7; 	/* current firing */
//   int ftspki3[NE1+NI1],ftspki4,ftspki5,ftspki6,ftspki7;/* Time of last spike */ 	/* Time of last spike */
//   int fNcon3[NE1+NI1];  /* connection number */
//   int **fA3;
//   float fhrece4,fhreci4,fhrece5,fhreci5,fhrece6,fhreci6,fhrece7,fhreci7;
//   float **fhrece3,**fhreci3;
//   float fhi3[NE1+NI1],fhi4,fhi5,fhi6,fhi7; /*potentials*/
// 
//   FILE *cmatrix13,*cmatrix23,*cmatrix33,*cmatrix43,*cmatrix53,*cmatrix63,*cmatrix73,*cmatrix83,*cmatrix93,*cmatrix103,*cmatrix113,*cmatrix123,*cmatrix133,*cmatrix143,*cmatrix153,*cmatrix193,*cmatrix3,*cmatrix34,*cmatrix35,*cmatrix36,*cmatrix37;
//   FILE *testspiketimesE3,*testspiketimesE4,*testspiketimesE5,*testspiketimesE6,*testspiketimesE7;
//   FILE *input1,*input2,*input3,*input4,*input5,*input6,*input7,*input8,*input9,*input10,*input11,*input12,*input13,*input14,*input15,*input19;
//   FILE *inputnetwork1,*inputnetwork2;
// 
//   float fsAMPA3[NE1+NI1], fsAMPAk13[NE1+NI1], fsAMPAk23[NE1+NI1], fsAMPArk3[NE1+NI1];
//   float fxAMPA3[NE1+NI1], fxAMPAk13[NE1+NI1], fxAMPAk23[NE1+NI1], fxAMPArk3[NE1+NI1];
//  
//   
//   float fsAMPA34, fsAMPAk134, fsAMPAk234, fsAMPArk34;
//   float fxAMPA34, fxAMPAk134, fxAMPAk234, fxAMPArk34;
//   float fsAMPA35, fsAMPAk135, fsAMPAk235, fsAMPArk35;
//   float fxAMPA35, fxAMPAk135, fxAMPAk235, fxAMPArk35;
//   float fsAMPA36, fsAMPAk136, fsAMPAk236, fsAMPArk36;
//   float fxAMPA36, fxAMPAk136, fxAMPAk236, fxAMPArk36;
//   float fsAMPA37, fsAMPAk137, fsAMPAk237, fsAMPArk37;
//   float fxAMPA37, fxAMPAk137, fxAMPAk237, fxAMPArk37;
//   
//   float fsAMPATH311[NE1+NI1], fsAMPATHk1311[NE1+NI1], fsAMPATHk2311[NE1+NI1], fsAMPATHrk311[NE1+NI1];
//   float fxAMPATH311[NE1+NI1], fxAMPATHk1311[NE1+NI1], fxAMPATHk2311[NE1+NI1], fxAMPATHrk311[NE1+NI1];
// 
//   float fsAMPATH312[NE1+NI1], fsAMPATHk1312[NE1+NI1], fsAMPATHk2312[NE1+NI1], fsAMPATHrk312[NE1+NI1];
//   float fxAMPATH312[NE1+NI1], fxAMPATHk1312[NE1+NI1], fxAMPATHk2312[NE1+NI1], fxAMPATHrk312[NE1+NI1];
// 
//   float fsAMPATH313[NE1+NI1], fsAMPATHk1313[NE1+NI1], fsAMPATHk2313[NE1+NI1], fsAMPATHrk313[NE1+NI1];
//   float fxAMPATH313[NE1+NI1], fxAMPATHk1313[NE1+NI1], fxAMPATHk2313[NE1+NI1], fxAMPATHrk313[NE1+NI1];
// 
//   float fsAMPATH314[NE1+NI1], fsAMPATHk1314[NE1+NI1], fsAMPATHk2314[NE1+NI1], fsAMPATHrk314[NE1+NI1];
//   float fxAMPATH314[NE1+NI1], fxAMPATHk1314[NE1+NI1], fxAMPATHk2314[NE1+NI1], fxAMPATHrk314[NE1+NI1];
// 
//   float fsAMPATH315[NE1+NI1], fsAMPATHk1315[NE1+NI1], fsAMPATHk2315[NE1+NI1], fsAMPATHrk315[NE1+NI1];
//   float fxAMPATH315[NE1+NI1], fxAMPATHk1315[NE1+NI1], fxAMPATHk2315[NE1+NI1], fxAMPATHrk315[NE1+NI1];
// 
//   float fsAMPATH316[NE1+NI1], fsAMPATHk1316[NE1+NI1], fsAMPATHk2316[NE1+NI1], fsAMPATHrk316[NE1+NI1];
//   float fxAMPATH316[NE1+NI1], fxAMPATHk1316[NE1+NI1], fxAMPATHk2316[NE1+NI1], fxAMPATHrk316[NE1+NI1];
// 
//   float fsAMPATH317[NE1+NI1], fsAMPATHk1317[NE1+NI1], fsAMPATHk2317[NE1+NI1], fsAMPATHrk317[NE1+NI1];
//   float fxAMPATH317[NE1+NI1], fxAMPATHk1317[NE1+NI1], fxAMPATHk2317[NE1+NI1], fxAMPATHrk317[NE1+NI1];
// 
// 
//   float fsAMPATH318[NE1+NI1], fsAMPATHk1318[NE1+NI1], fsAMPATHk2318[NE1+NI1], fsAMPATHrk318[NE1+NI1];
//   float fxAMPATH318[NE1+NI1], fxAMPATHk1318[NE1+NI1], fxAMPATHk2318[NE1+NI1], fxAMPATHrk318[NE1+NI1];
// 
//   float fsAMPATH319[NE1+NI1], fsAMPATHk1319[NE1+NI1], fsAMPATHk2319[NE1+NI1], fsAMPATHrk319[NE1+NI1];
//   float fxAMPATH319[NE1+NI1], fxAMPATHk1319[NE1+NI1], fxAMPATHk2319[NE1+NI1], fxAMPATHrk319[NE1+NI1];
// 
// 
//   float fsAMPATH3110[NE1+NI1], fsAMPATHk13110[NE1+NI1], fsAMPATHk23110[NE1+NI1], fsAMPATHrk3110[NE1+NI1];
//   float fxAMPATH3110[NE1+NI1], fxAMPATHk13110[NE1+NI1], fxAMPATHk23110[NE1+NI1], fxAMPATHrk3110[NE1+NI1];
// 
// 
//   float fsAMPATH3111[NE1+NI1], fsAMPATHk13111[NE1+NI1], fsAMPATHk23111[NE1+NI1], fsAMPATHrk3111[NE1+NI1];
//   float fxAMPATH3111[NE1+NI1], fxAMPATHk13111[NE1+NI1], fxAMPATHk23111[NE1+NI1], fxAMPATHrk3111[NE1+NI1];
// 
//   
//   float fsAMPATH3112[NE1+NI1], fsAMPATHk13112[NE1+NI1], fsAMPATHk23112[NE1+NI1], fsAMPATHrk3112[NE1+NI1];
//   float fxAMPATH3112[NE1+NI1], fxAMPATHk13112[NE1+NI1], fxAMPATHk23112[NE1+NI1], fxAMPATHrk3112[NE1+NI1];
// 
// 
//   float fsAMPATH3113[NE1+NI1], fsAMPATHk13113[NE1+NI1], fsAMPATHk23113[NE1+NI1], fsAMPATHrk3113[NE1+NI1];
//   float fxAMPATH3113[NE1+NI1], fxAMPATHk13113[NE1+NI1], fxAMPATHk23113[NE1+NI1], fxAMPATHrk3113[NE1+NI1];
// 
//   float fsAMPATH3114[NE1+NI1], fsAMPATHk13114[NE1+NI1], fsAMPATHk23114[NE1+NI1], fsAMPATHrk3114[NE1+NI1];
//   float fxAMPATH3114[NE1+NI1], fxAMPATHk13114[NE1+NI1], fxAMPATHk23114[NE1+NI1], fxAMPATHrk3114[NE1+NI1];
// 
//   float fsAMPATH3115[NE1+NI1], fsAMPATHk13115[NE1+NI1], fsAMPATHk23115[NE1+NI1], fsAMPATHrk3115[NE1+NI1];
//   float fxAMPATH3115[NE1+NI1], fxAMPATHk13115[NE1+NI1], fxAMPATHk23115[NE1+NI1], fxAMPATHrk3115[NE1+NI1];
// 
//   float fsAMPATH3116[NE1+NI1], fsAMPATHk13116[NE1+NI1], fsAMPATHk23116[NE1+NI1], fsAMPATHrk3116[NE1+NI1];
//   float fxAMPATH3116[NE1+NI1], fxAMPATHk13116[NE1+NI1], fxAMPATHk23116[NE1+NI1], fxAMPATHrk3116[NE1+NI1];
// 
//   float fsAMPATH3117[NE1+NI1], fsAMPATHk13117[NE1+NI1], fsAMPATHk23117[NE1+NI1], fsAMPATHrk3117[NE1+NI1];
//   float fxAMPATH3117[NE1+NI1], fxAMPATHk13117[NE1+NI1], fxAMPATHk23117[NE1+NI1], fxAMPATHrk3117[NE1+NI1];
// 
//   float isAMPATH[NE1+NI1], isAMPATHk1[NE1+NI1], isAMPATHk2[NE1+NI1], isAMPATHrk[NE1+NI1];
//   float ixAMPATH[NE1+NI1], ixAMPATHk1[NE1+NI1], ixAMPATHk2[NE1+NI1], ixAMPATHrk[NE1+NI1];
// 
//   float fsGABA3[NE1+NI1], fsGABAk13[NE1+NI1], fsGABAk23[NE1+NI1], fsGABArk3[NE1+NI1];
//   float fxGABA3[NE1+NI1], fxGABAk13[NE1+NI1], fxGABAk23[NE1+NI1], fxGABArk3[NE1+NI1];
//   
// 
//   float fsGABA34, fsGABAk134, fsGABAk234, fsGABArk34;
//   float fxGABA34, fxGABAk134, fxGABAk234, fxGABArk34;
//   float fsGABA35, fsGABAk135, fsGABAk235, fsGABArk35;
//   float fxGABA35, fxGABAk135, fxGABAk235, fxGABArk35;
//   float fsGABA36, fsGABAk136, fsGABAk236, fsGABArk36;
//   float fxGABA36, fxGABAk136, fxGABAk236, fxGABArk36;
//   float fsGABA37, fsGABAk137, fsGABAk237, fsGABArk37;
//   float fxGABA37, fxGABAk137, fxGABAk237, fxGABArk37;
// 
//   float iIsyn3,fIsyn31,fIsyn32,fIsyn33,fIsyn34,fIsyn4,fIsyn5,fIsyn6,fIsyn7,iIsynk13,fIsynk131,fIsynk132,fIsynk133,fIsynk134,fIsynk14,fIsynk15,fIsynk16,fIsynk17;
//   float ffspk3,ffspk4,ffspk5,ffspk6,ffspk7;
//   float fFE13, fFE23, fFE3,fFE14, fFE24, fFE4,fFE15, fFE25, fFE5,fFE16, fFE26, fFE6,fFE17, fFE27, fFE7;
//   float fFI13, fFI23,fFI3,fFI14, fFI24,fFI4,fFI15, fFI25,fFI5,fFI16, fFI26,fFI6,fFI17, fFI27,fFI7;
//   int ffrE3,ffrE4,ffrE5,ffrE6,ffrE7;
// 
// 
//   
//   float sAMPACC[NE+NI], sAMPACCk1[NE+NI], sAMPACCk2[NE+NI], sAMPACCrk[NE+NI];
//   float xAMPACC[NE+NI], xAMPACCk1[NE+NI], xAMPACCk2[NE+NI], xAMPACCrk[NE+NI];
// 
//   float **hjee,**hjie,**hjei,**hjii;
//   float **fhjee,**fhjie,**fhjei,**fhjii;
// 
// 
//   float Isyn1,Isyn2,Isyn4,Isyn5,Isynk12,Isynk11,Isynk14,Isynk15;
//   float Isyn12,Isyn14,Isyn15,Isyn24,Isyn25,Isyn45;
//   float Isyn1m,Isyn2m,Isyn4m,Isyn5m,Isynk12m,Isynk11m,Isynk14m,Isynk15m;
//   float Isyn12m,Isyn14m,Isyn15m,Isyn24m,Isyn25m,Isyn45m;
//   float Isynk112,Isynk114,Isynk115,Isynk116,Isynk124,Isynk125,Isynk145;
//   float Isynk112m,Isynk114m,Isynk115m,Isynk124m,Isynk125m,Isynk145m;
//   float inriseI, dtriseI, inriseE, inriseEE, inriseEI, dtriseE, dtriseEE, dtriseEI;
//   float indecayI, dtdecayI, indecayE, indecayEE, indecayEI, dtdecayE, dtdecayEE, dtdecayEI;
//   float inmE, inmI,dtmE, dtmI;
//   float fspk1,fspk2,fspk4,fspk5,fspk12,fspk14,fspk25,fspk45,fspk15,fspk24,fh;
//   float fspk15m,fspk24m,fspk1m,fspk2m,fspk4m,fspk5m,fspk12m,fspk14m,fspk25m,fspk45m;
//   float FE11, FE21, FE1,FE12, FE22, FE2,FE14, FE24, FE4,FE15, FE25, FE5;
//   float FI11, FI21,FI1,FI12, FI22,FI2,FI14, FI24,FI4,FI15, FI25,FI5;
//   int   frE1,frE2,frE4,frE5,frEo11,frEo12,frEo13,frEo14,frEo15,frEo21,frEo22,frEo23,frEo24,frEo25,frEo41,frEo42,frEo43,frEo44,frEo45,frEo51,frEo52,frEo53,frEo54,frEo55,fprE1,fprE2,fprE4,fprE5;
//   float FE11m, FE21m, FE1m,FE12m, FE22m, FE2m,FE14m, FE24m, FE4m,FE15m, FE25m, FE5m;
//   float FI11m, FI21m,FI1m,FI12m, FI22m,FI2m,FI14m, FI24m,FI4m,FI15m, FI25m,FI5m;
//   
//   //create 4d matrix//
//   float ****inputtrain;
//   inputtrain=new float***[time];
//   for(int i32=0;i32<time; i32++){
//       inputtrain[i32]=new float**[trail];
//       for(int j32=0;j32<trail; j32++){
// 	  inputtrain[i32][j32]=new float*[electrod];
// 	  for(int k32=0;k32<electrod; k32++){
// 	      inputtrain[i32][j32][k32]=new float[4];
// 		for(int p32=0;p32<4; p32++){
// 		inputtrain[i32][j32][k32][p32]=0;
//   }}}}
//   
//   //fill above structure wit input txt files//
//   for (int i = 0; i <time; i++) {
//       for (int k = 0; k <electrod; k++) {
// 	  for (int j = 0; j <trail; j++) {
// 	    for(int l=0; l< bmiData.stim;l++)
// 	      
// 	     if(k<param.ref_electrode-1)
// 	      {
// 		inputtrain[i][j][k][l]=bmiData.data[i][j][k][l]; // trnasfering data into 3-D matrix    
// 	      }
// 	      else
// 	      {
// 		inputtrain[i][j][k][l]=bmiData.data[i][j][k+1][l]; // trnasfering data into 3-D matrix    
// 	      }
//   }}}
//   
//   
// //    //open input file//
// //   std::fstream file200("inputtrain1.txt", std::ios_base::in);
// //   std::fstream file220("inputtrain2.txt", std::ios_base::in);
// //   std::fstream file230("inputtrain3.txt", std::ios_base::in);
// //   std::fstream file240("inputtrain4.txt", std::ios_base::in);
// // 
// // 
// //  float ****inputtrains;
// //   inputtrains=new float***[time];
// //   for(int i32=0;i32<time; i32++){
// //       inputtrains[i32]=new float**[trail];
// //       for(int j32=0;j32<trail; j32++){
// // 	  inputtrains[i32][j32]=new float*[electrod];
// // 	  for(int k32=0;k32<electrod; k32++){
// // 	      inputtrains[i32][j32][k32]=new float[4];
// // 		for(int p32=0;p32<4; p32++){
// // 		inputtrains[i32][j32][k32][p32]=0;
// //   }}}}
// // 
// //   //fill above structure wit input txt files//
// //   for (int k31 = 0; k31 <electrod; k31++) {
// //     for (int i31 = 0; i31 <time; i31++) {
// // 	  for (int j31 = 0; j31 <trail; j31++) {
// // 	      
// // 	    file200 >> inputtrains[i31][j31][k31][0];
// // 	    file220 >> inputtrains[i31][j31][k31][1];
// // 	    file230 >> inputtrains[i31][j31][k31][2];
// // 	    file240 >> inputtrains[i31][j31][k31][3];
// // 	      
// //   }}}
// //    
// //   //close input file
// //   file200.close();
// //   file220.close();
// //   file230.close();
// //   file240.close();
// // 
// //   
// //   
// //   
// //   //////////77777
// //   cout<<"start data validation..."<<endl;
// //   
// // int error=0;
// // int correct=0;
// //   for (int i31 = 0; i31 <time; i31++) {
// //       for (int k31 = 0; k31 <electrod; k31++) {
// // 	  for (int j31 = 0; j31 <trail; j31++) {
// // 	    for (int l31 = 0; l31 <4; l31++) {
// // 	      if(inputtraino[i31][j31][k31][l31] == inputtrain[i31][j31][k31][l31])
// // 	      {
// // 		correct++;
// // 	      }
// // 	      else
// // 	      {
// // 		error++;
// // 		printf("( %f != %f )",inputtraino[i31][j31][k31][l31],inputtrain[i31][j31][k31][l31] );
// // 	        cout<<i31<<","<<j31<<","<<k31<<","<<l31<<endl;
// // 	      }
// // 	    }
// // 	  }
// //       }
// //   }
// //   cout<<"number of mismatch : "<<error << endl;
// //   cout<<"correct : "<<correct<<endl;
// //   srand(seed);
//   
//   /*    Output random values. */
// 
//   accaso=rand()% (HIGH - LOW + 1) + LOW;
//   
//   conect3=fopen(jeee3,"w");
//   conect4=fopen(jeee4,"w");
//   conect5=fopen(jeee5,"w");
//   conect6=fopen(jeee6,"w");
//   conect7=fopen(jeee7,"w");
// 
//   testspiketimesE3=fopen(testSTE3t, "w");
//   testspiketimesE4=fopen(testSTE4t, "w");
//   testspiketimesE5=fopen(testSTE5t, "w");
//   testspiketimesE6=fopen(testSTE6t, "w");
//   testspiketimesE7=fopen(testSTE7t, "w");
//   
//  
//   input1=fopen(inp1,"w");
//   input2=fopen(inp2,"w");
//   input3=fopen(inp3,"w");
//   input4=fopen(inp4,"w");
//   input5=fopen(inp5,"w");
//   input6=fopen(inp6,"w");
//   input7=fopen(inp7,"w");
//   input8=fopen(inp8,"w");
//   input9=fopen(inp9,"w");
//   input10=fopen(inp10,"w");
//   input11=fopen(inp11,"w");
//   input12=fopen(inp12,"w");
//   input13=fopen(inp13,"w");
//   input14=fopen(inp14,"w");
//   input15=fopen(inp15,"w");
//   
//   cmatrix13=fopen(cm13,"w");
//   cmatrix23=fopen(cm23,"w");
//   cmatrix33=fopen(cm33,"w");
//   cmatrix43=fopen(cm43,"w");
//   cmatrix53=fopen(cm53,"w");
//   cmatrix63=fopen(cm63,"w");
//   cmatrix73=fopen(cm73,"w");
//   cmatrix83=fopen(cm83,"w");
//   cmatrix93=fopen(cm93,"w");
//   cmatrix103=fopen(cm103,"w");
//   cmatrix113=fopen(cm113,"w");
//   cmatrix123=fopen(cm123,"w");
//   cmatrix133=fopen(cm133,"w");
//   cmatrix143=fopen(cm143,"w");
//   cmatrix153=fopen(cm153,"w");
//   
//   cmatrix3=fopen(cm3,"w");
//   cmatrix34=fopen(cm34,"w");
//   cmatrix35=fopen(cm35,"w");
//   cmatrix36=fopen(cm36,"w");
//   cmatrix37=fopen(cm37,"w");
// 
//   CYCSIZE=(int)(delay/dt+1);
//   
//   
//   nneur=NE1+NI1;
// 
//   sub=(int)(1./dt+0.01);
//   delaysub=(int)(delay*sub+0.01);
// 
//   dtriseEE=dt/taurEE; /*convert in time units */
//   dtriseEI=dt/taurEI;
//   dtdecayEE=dt/taudEE;
//   dtdecayEI=dt/taudEI;
//   dtriseI=dt/taurI;
//   dtdecayI=dt/taudI;
//   dtmE=dt/taumE;
//   dtmI=dt/taumI;
// 
//   inriseEE=(1./taurEE);
//   inriseEI=(1./taurEI);
//   inmE=(1./taumE);
//   inriseI=(1./taurI);
//   inmI=(1./taumI);
//   
//   idum=idum+accaso;
// 
//   
// 
// 
// 
//   fhrece3 = new float*[fNE+fNI];
// 
//   for(i=0;i < fNE+fNI; i++){
//    
//      fhrece3[i] = new float[CYCSIZE];
// 
//   }
// 
//    
//   
//   fhreci3 = new float*[fNE+fNI];
// 
//   for(i=0;i < fNE+fNI; i++){
//     
//     fhreci3[i] = new float[CYCSIZE];
//   }
// 
//   
// 
//   
//   fA3 = new int*[fNE+fNI];
//  
// 
//   for(i=0;i < fNE+fNI; i++){
//     
// 	  fA3[i] = new int[fNE+fNI];
// 	
//   }
// 
// 
//    fhjee = new float*[fNE+fNI];  
//   
//    for(i=0;i < fNE+fNI; i++){
//     
// 	fhjee[i] = new float[CYCSIZE];
// 
//    }
// 
// 
//    fhjei = new float*[fNE+fNI];
// 
//    for(i=0;i < fNE+fNI; i++){
//     
// 	fhjei[i] = new float[CYCSIZE];
// 
//    }
//   
// 
// 
//    fhjii = new float*[fNE+fNI];
// 
//    for(i=0;i < fNE+fNI; i++){
//     
// 	fhjii[i] = new float[CYCSIZE];
// 
//    }
// 
// 
//    fhjie = new float*[fNE+fNI];
// 
//    for(i=0;i < fNE+fNI; i++){
//     
// 	fhjie[i] = new float[CYCSIZE];
// 
//    }
// 
// 
//    hjee = new float*[fNE+fNI];
//  
// 
//   for(i=0;i < fNE+fNI; i++){
//     
// 	  hjee[i] = new float[fNE+fNI];
// 	
//   }
// 
// 
//   hjei = new float*[fNE+fNI];
//  
// 
//   for(i=0;i < fNE+fNI; i++){
//     
// 	  hjei[i] = new float[fNE+fNI];
// 	
//   }
// 
// 
// 
//   hjie = new float*[fNE+fNI];
//  
// 
//   for(i=0;i < fNE+fNI; i++){
//     
// 	  hjie[i] = new float[fNE+fNI];
// 	
//   }
// 
// 
//   hjii = new float*[fNE+fNI];
//  
// 
//   for(i=0;i < fNE+fNI; i++){
//     
// 	  hjii[i] = new float[fNE+fNI];
// 	
//   }
// 
// 
//  
//   for(in=0;in<fNE+fNI;in++) {
//     for(ip=0;ip<CYCSIZE;ip++) {
// 
//       fhrece3[in][ip]=0.;
// 	  fhjee[in][ip]=0.;
// 	  fhjei[in][ip]=0.;
// 	  fhjii[in][ip]=0.;
// 	  fhjie[in][ip]=0.;
// 	  fhreci3[in][ip]=0.;
// 	}
// 	fhi3[in]=0.;
// 	}
// 
// 	  fhrece4=0.;
//       fhreci4=0.;
// 	  fhrece5=0.;
//       fhreci5=0.;
// 	  fhrece6=0.;
//       fhreci6=0.;
// 	  fhrece7=0.;
//       fhreci7=0.;
// 	
// 	
// 	fhi4=0.;
//     fhi5=0.;
// 	fhi6=0.;
// 	fhi7=0.;
// 
// 	ftspki4=-1;
// 	ftspki5=-1;
// 	ftspki6=-1;
// 	ftspki7=-1;
// 	
// 
// 	 for (in=0; in<fNE+fNI; in++){
// 
//     ftspki3[in]=-1;
//    
//     fxAMPA3[in]=0;
// 	fxAMPAk13[in]=0;
// 	fxAMPAk23[in]=0;
// 	fxAMPArk3[in]=0;
// 	
// 	
// 
//     fsAMPA3[in]=0;
// 	fsAMPAk13[in]=0;
// 	fsAMPAk23[in]=0;
// 	fsAMPArk3[in]=0;
// 	
// 	
// 
//     fsAMPATH311[in]=0;
//     fxAMPATH311[in]=0;
// 	fsAMPATHk1311[in]=0;
//     fxAMPATHk1311[in]=0;
// 	fsAMPATHk2311[in]=0;
//     fxAMPATHk2311[in]=0;
// 	fsAMPATHrk311[in]=0;
//     fxAMPATHrk311[in]=0;
// 
// 	fsAMPATH312[in]=0;
//     fxAMPATH312[in]=0;
// 	fsAMPATHk1312[in]=0;
//     fxAMPATHk1312[in]=0;
// 	fsAMPATHk2312[in]=0;
//     fxAMPATHk2312[in]=0;
// 	fsAMPATHrk312[in]=0;
//     fxAMPATHrk312[in]=0;
// 
// 	fsAMPATH313[in]=0;
//     fxAMPATH313[in]=0;
// 	fsAMPATHk1313[in]=0;
//     fxAMPATHk1313[in]=0;
// 	fsAMPATHk2313[in]=0;
//     fxAMPATHk2313[in]=0;
// 	fsAMPATHrk313[in]=0;
//     fxAMPATHrk313[in]=0;
// 
// 	fsAMPATH314[in]=0;
//     fxAMPATH314[in]=0;
// 	fsAMPATHk1314[in]=0;
//     fxAMPATHk1314[in]=0;
// 	fsAMPATHk2314[in]=0;
//     fxAMPATHk2314[in]=0;
// 	fsAMPATHrk314[in]=0;
//     fxAMPATHrk314[in]=0;
// 
// 	fsAMPATH315[in]=0;
//     fxAMPATH315[in]=0;
// 	fsAMPATHk1315[in]=0;
//     fxAMPATHk1315[in]=0;
// 	fsAMPATHk2315[in]=0;
//     fxAMPATHk2315[in]=0;
// 	fsAMPATHrk315[in]=0;
//     fxAMPATHrk315[in]=0;
// 	
// 	fsAMPATH316[in]=0;
//     fxAMPATH316[in]=0;
// 	fsAMPATHk1316[in]=0;
//     fxAMPATHk1316[in]=0;
// 	fsAMPATHk2316[in]=0;
//     fxAMPATHk2316[in]=0;
// 	fsAMPATHrk316[in]=0;
//     fxAMPATHrk316[in]=0;
// 
// 	fsAMPATH317[in]=0;
//     fxAMPATH317[in]=0;
// 	fsAMPATHk1317[in]=0;
//     fxAMPATHk1317[in]=0;
// 	fsAMPATHk2317[in]=0;
//     fxAMPATHk2317[in]=0;
// 	fsAMPATHrk317[in]=0;
//     fxAMPATHrk317[in]=0;
// 
// 	fsAMPATH318[in]=0;
//     fxAMPATH318[in]=0;
// 	fsAMPATHk1318[in]=0;
//     fxAMPATHk1318[in]=0;
// 	fsAMPATHk2318[in]=0;
//     fxAMPATHk2318[in]=0;
// 	fsAMPATHrk318[in]=0;
//     fxAMPATHrk318[in]=0;
// 
// 	fsAMPATH319[in]=0;
//     fxAMPATH319[in]=0;
// 	fsAMPATHk1319[in]=0;
//     fxAMPATHk1319[in]=0;
// 	fsAMPATHk2319[in]=0;
//     fxAMPATHk2319[in]=0;
// 	fsAMPATHrk319[in]=0;
//     fxAMPATHrk319[in]=0;
// 	
// 	fsAMPATH3110[in]=0;
//     fxAMPATH3110[in]=0;
// 	fsAMPATHk13110[in]=0;
//     fxAMPATHk13110[in]=0;
// 	fsAMPATHk23110[in]=0;
//     fxAMPATHk23110[in]=0;
// 	fsAMPATHrk3110[in]=0;
//     fxAMPATHrk3110[in]=0;
// 	
// 	fsAMPATH3111[in]=0;
//     fxAMPATH3111[in]=0;
// 	fsAMPATHk13111[in]=0;
//     fxAMPATHk13111[in]=0;
// 	fsAMPATHk23111[in]=0;
//     fxAMPATHk23111[in]=0;
// 	fsAMPATHrk3111[in]=0;
//     fxAMPATHrk3111[in]=0;
// 	
// 	fsAMPATH3112[in]=0;
//     fxAMPATH3112[in]=0;
// 	fsAMPATHk13112[in]=0;
//     fxAMPATHk13112[in]=0;
// 	fsAMPATHk23112[in]=0;
//     fxAMPATHk23112[in]=0;
// 	fsAMPATHrk3112[in]=0;
//     fxAMPATHrk3112[in]=0;
// 
// 
// 	fsAMPATH3113[in]=0;
//     fxAMPATH3113[in]=0;
// 	fsAMPATHk13113[in]=0;
//     fxAMPATHk13113[in]=0;
// 	fsAMPATHk23113[in]=0;
//     fxAMPATHk23113[in]=0;
// 	fsAMPATHrk3113[in]=0;
//     fxAMPATHrk3113[in]=0;
// 	
// 	fsAMPATH3114[in]=0;
//     fxAMPATH3114[in]=0;
// 	fsAMPATHk13114[in]=0;
//     fxAMPATHk13114[in]=0;
// 	fsAMPATHk23114[in]=0;
//     fxAMPATHk23114[in]=0;
// 	fsAMPATHrk3114[in]=0;
//     fxAMPATHrk3114[in]=0;
// 
// 	fsAMPATH3115[in]=0;
//     fxAMPATH3115[in]=0;
// 	fsAMPATHk13115[in]=0;
//     fxAMPATHk13115[in]=0;
// 	fsAMPATHk23115[in]=0;
//     fxAMPATHk23115[in]=0;
// 	fsAMPATHrk3115[in]=0;
//     fxAMPATHrk3115[in]=0;
// 
// 	fsAMPATH3116[in]=0;
//     fxAMPATH3116[in]=0;
// 	fsAMPATHk13116[in]=0;
//     fxAMPATHk13116[in]=0;
// 	fsAMPATHk23116[in]=0;
//     fxAMPATHk23116[in]=0;
// 	fsAMPATHrk3116[in]=0;
//     fxAMPATHrk3116[in]=0;
// 	
// 	fsAMPATH3117[in]=0;
//     fxAMPATH3117[in]=0;
// 	fsAMPATHk13117[in]=0;
//     fxAMPATHk13117[in]=0;
// 	fsAMPATHk23117[in]=0;
//     fxAMPATHk23117[in]=0;
// 	fsAMPATHrk3117[in]=0;
//     fxAMPATHrk3117[in]=0;
// 
// 
// 	isAMPATH[in]=0;
//     ixAMPATH[in]=0;
// 	isAMPATHk1[in]=0;
//     ixAMPATHk1[in]=0;
// 	isAMPATHk2[in]=0;
//     ixAMPATHk2[in]=0;
// 	isAMPATHrk[in]=0;
//     ixAMPATHrk[in]=0;
// 	
// 
// 	xAMPACC[in]=0;
// 	xAMPACCk1[in]=0;
// 	xAMPACCk2[in]=0;
// 	xAMPACCrk[in]=0;
//     sAMPACC[in]=0;
// 	sAMPACCk1[in]=0;
// 	sAMPACCk2[in]=0;
// 	sAMPACCrk[in]=0;
// 
//     fxGABA3[in]=0;
// 	fxGABAk13[in]=0;
// 	fxGABAk23[in]=0;
// 	fxGABArk3[in]=0;
// 	
// 
//     fsGABA3[in]=0;
// 	fsGABAk13[in]=0;
// 	fsGABAk23[in]=0;
// 	fsGABArk3[in]=0;
// 	
// 	 }
// 
// 	fxAMPA34=0;
// 	fxAMPA35=0;
// 	fxAMPAk134=0;
// 	fxAMPAk135=0;
// 	fxAMPAk234=0;
// 	fxAMPAk235=0;
// 	fxAMPArk34=0;
// 	fxAMPArk35=0;
// 
// 	fsAMPA34=0;
// 	fsAMPA35=0;
// 	fsAMPAk134=0;
// 	fsAMPAk135=0;
// 	fsAMPAk234=0;
// 	fsAMPAk235=0;
// 	fsAMPArk34=0;
// 	fsAMPArk35=0;
// 
// 	fxGABA34=0;
// 	fxGABA35=0;
// 	fxGABAk134=0;
// 	fsGABAk134=0;
// 	fxGABAk135=0;
// 	fsGABAk135=0;
// 	fxGABAk234=0;
// 	fsGABAk234=0;
// 	fxGABAk235=0;
// 	fsGABAk235=0;
// 	fxGABArk34=0;
// 	fsGABArk34=0;
// 	fxGABArk35=0;
// 	fsGABArk35=0;
// 	
// 	fsGABA34=0;
// 	fsGABA35=0;
// 
// 
// 	fxAMPA36=0;
// 	fxAMPA37=0;
// 	fxAMPAk136=0;
// 	fxAMPAk137=0;
// 	fxAMPAk236=0;
// 	fxAMPAk237=0;
// 	fxAMPArk36=0;
// 	fxAMPArk37=0;
// 
// 	fsAMPA36=0;
// 	fsAMPA37=0;
// 	fsAMPAk136=0;
// 	fsAMPAk137=0;
// 	fsAMPAk236=0;
// 	fsAMPAk237=0;
// 	fsAMPArk36=0;
// 	fsAMPArk37=0;
// 
// 	fxGABA36=0;
// 	fxGABA37=0;
// 	fxGABAk136=0;
// 	fsGABAk136=0;
// 	fxGABAk137=0;
// 	fsGABAk137=0;
// 	fxGABAk236=0;
// 	fsGABAk236=0;
// 	fxGABAk237=0;
// 	fsGABAk237=0;
// 	fxGABArk36=0;
// 	fsGABArk36=0;
// 	fxGABArk37=0;
// 	fsGABArk37=0;
// 	
// 	fsGABA36=0;
// 	fsGABA37=0;
// 
// 
// 
//     iIsyn3=0;
// 	fIsyn31=0;
// 	fIsyn32=0;
// 	fIsyn33=0;
// 	fIsyn34=0;
//     fIsyn4=0;
// 	fIsyn5=0;
// 	fIsyn6=0;
// 	fIsyn7=0;
// 	
// 
//     iIsynk13=0;
// 	fIsynk131=0;
// 	fIsynk132=0;
// 	fIsynk133=0;
// 	fIsynk134=0;
//     fIsynk14=0;
// 	fIsynk15=0;
// 	fIsynk16=0;
// 	fIsynk17=0;
// 
// 
// 
// 	
//    for(j=0;j< fNE+fNI;j++) {
//     
//     fNcon3[j]=0;
//     
//   }
// 
// 
//   for(i=0;i<fNE+fNI;i++){
// 
//     for(j=0;j<fNE+fNI;j++){
// 
//       fA3[i][j]=0;
//       hjee[i][j]=0;
//       hjei[i][j]=0;
//       hjie[i][j]=0;
//       hjii[i][j]=0;
// 
//   }}
// 
// 
//   for(i=0;i<fNE+fNI;i++){
// 
//     for(j=0;j<fNE+fNI;j++){
// 
//       if(ran1(&idum)< connect3) {
// 
// 	fA3[fNcon3[j]][j]=i;
// 	fNcon3[j]++;
// 	fprintf(cmatrix3,"%i %i\n",i,j);
// 	fflush(cmatrix3);
// 
// 	if (i<fNE && j<fNE){
// 		hjee[fNcon3[j]][j]=jee;}
// 	if (i>fNE && j<fNE){
// 		hjei[fNcon3[j]][j]=jei;}
// 	if (i<fNE && j>fNE){
// 		hjie[fNcon3[j]][j]=jie;}
// 	if (i>fNE && j>fNE){
// 		hjii[fNcon3[j]][j]=jii;}
// 
// 	  }}}
// 
//    
// 	for(i=0;i<fNE;i++){
// 
//       if(ran1(&idum)< connect13) {
// 
// 	fprintf(cmatrix13,"%i %i\n",1,i);
// 	fflush(cmatrix13);
// 
// 	  }
// 
// 	  if(ran1(&idum)< connect23) {
// 
// 	fprintf(cmatrix23,"%i %i\n",2,i);
// 	fflush(cmatrix23);
// 	  }
// 
// 	   if(ran1(&idum)< connect33) {
// 
// 	fprintf(cmatrix33,"%i %i\n",3,i);
// 	fflush(cmatrix33);
// 	  }
// 
// 	    if(ran1(&idum)< connect43) {
// 
// 	fprintf(cmatrix43,"%i %i\n",4,i);
// 	fflush(cmatrix43);
// 	  }
// 
// 		
//       if(ran1(&idum)< connect53) {
// 
// 	fprintf(cmatrix53,"%i %i\n",5,i);
// 	fflush(cmatrix53);
// 
// 	  }
// 	  
// 
//       if(ran1(&idum)< connect63) {
// 
// 	fprintf(cmatrix63,"%i %i\n",6,i);
// 	fflush(cmatrix63);
// 
// 	  }
// 
//       if(ran1(&idum)< connect73) {
// 
// 	fprintf(cmatrix73,"%i %i\n",7,i);
// 	fflush(cmatrix73);
// 
// 	  }
// 
//       if(ran1(&idum)< connect83) {
// 
// 	fprintf(cmatrix83,"%i %i\n",8,i);
// 	fflush(cmatrix83);
// 
// 	  }
// 
//       if(ran1(&idum)< connect93) {
// 
// 	fprintf(cmatrix93,"%i %i\n",9,i);
// 	fflush(cmatrix93);
// 
// 	  }
// 	  
//       if(ran1(&idum)< connect103) {
// 
// 	fprintf(cmatrix103,"%i %i\n",10,i);
// 	fflush(cmatrix103);
// 
// 	  }
// 	  
//       if(ran1(&idum)< connect113) {
// 
// 	fprintf(cmatrix113,"%i %i\n",11,i);
// 	fflush(cmatrix113);
// 
// 	  }
// 
// 	   if(ran1(&idum)< connect123) {
// 
// 	fprintf(cmatrix123,"%i %i\n",12,i);
// 	fflush(cmatrix123);
// 
// 	  }
// 
// 
// 	    if(ran1(&idum)< connect133) {
// 
// 	fprintf(cmatrix133,"%i %i\n",13,i);
// 	fflush(cmatrix133);
// 
// 	  }
// 
// 
// 		 if(ran1(&idum)< connect143) {
// 
// 	fprintf(cmatrix143,"%i %i\n",14,i);
// 	fflush(cmatrix143);
// 
// 	  }
// 
// 
// 		  if(ran1(&idum)< connect153) {
// 
// 	fprintf(cmatrix153,"%i %i\n",15,i);
// 	fflush(cmatrix153);
// 
// 	  }
// 
// 
// 	 
// 	  if(ran1(&idum)< connect34) {
// 
// 	fprintf(cmatrix34,"%i %i\n",1,i);
// 	fflush(cmatrix34);
// 	  }
// 
// 
// 	  if(ran1(&idum)< connect35) {
// 
// 	fprintf(cmatrix35,"%i %i\n",2,i);
// 	fflush(cmatrix35);
// 	  }
// 
// 	  if(ran1(&idum)< connect36) {
// 
// 	fprintf(cmatrix36,"%i %i\n",3,i);
// 	fflush(cmatrix36);
// 	  }
// 
// 
// 	  if(ran1(&idum)< connect37) {
// 
// 	fprintf(cmatrix37,"%i %i\n",4,i);
// 	fflush(cmatrix37);
// 	  }
// 
// 
// 	}
// 
// 	fclose(cmatrix13);
// 	fclose(cmatrix23);
// 	fclose(cmatrix33);
// 	fclose(cmatrix43);
// 	fclose(cmatrix53);
// 	fclose(cmatrix63);
// 	fclose(cmatrix73);
// 	fclose(cmatrix83);
// 	fclose(cmatrix93);
// 	fclose(cmatrix103);
// 	fclose(cmatrix113);
// 	fclose(cmatrix123);
// 	fclose(cmatrix133);
// 	fclose(cmatrix143);
// 	fclose(cmatrix153);
// 	fclose(cmatrix3);
// 	fclose(cmatrix34);
// 	fclose(cmatrix35);
// 	fclose(cmatrix36);
// 	fclose(cmatrix37);
// 
// 
// 
// 
// 	int numLines34 = 0;
// ifstream in50("cmatrix34.txt");
// std::string unused;
// while ( std::getline(in50, unused) ){
// 	++numLines34;}
// 
// int numLines35 = 0;
// ifstream in60("cmatrix35.txt");
// std::string unused2;
// while ( std::getline(in60, unused2) ){
// 	++numLines35;}
// 
// int numLines36 = 0;
// ifstream in30("cmatrix36.txt");
// std::string unused3;
// while ( std::getline(in30, unused3) ){
// 	++numLines36;}
// 
// 
// int numLines37 = 0;
// ifstream in40("cmatrix37.txt");
// std::string unused4;
// while ( std::getline(in40, unused4) ){
// 	++numLines37;}
// 
// 
// int result[4][1];
// result[0][0]=numLines34;
// result[1][0]=numLines35;
// result[2][0]=numLines36;
// result[3][0]=numLines37;
// 
// 
// int minimum=result[0][0];
// for (int yy=0;yy<4;yy++){
// 	if (result[yy][0]<minimum){
// 		minimum=result[yy][0];}}
// 
// 
// 
//   float **matrix34;
// 	matrix34 = new float*[minimum];
//   for(int i30=0;i30 <minimum; i30++){
//     matrix34 [i30] = new float[2];}
// 
// 
//   float **matrix35;
// 	matrix35 = new float*[minimum];
//   for(int i30=0;i30 <minimum; i30++){
//     matrix35 [i30] = new float[2];}
// 
//   float **matrix36;
// 	matrix36 = new float*[minimum];
//   for(int i30=0;i30 <minimum; i30++){
//     matrix36 [i30] = new float[2];}
// 
// 
//   float **matrix37;
// 	matrix37 = new float*[minimum];
//   for(int i30=0;i30 <minimum; i30++){
//     matrix37 [i30] = new float[2];}
// 
// 
//   std::fstream file1("cmatrix34.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <minimum; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file1>> matrix34[i31][j31];
// 	
// 	}}
// file1.close();
// 
// 
// std::fstream file2("cmatrix35.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <minimum; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file2>> matrix35[i31][j31];
// 		
// 	}}
// file2.close();
// 
// 
// std::fstream file3("cmatrix36.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <minimum; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file3>> matrix36[i31][j31];
// 	
// 	}}
// file3.close();
// 
// 
// std::fstream file4("cmatrix37.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <minimum; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file4>> matrix37[i31][j31];
// 	
// 	}}
// file4.close();
// 
// //////////////////////////////////////////////////////////////
// 
// 	int numLines13 = 0;
// ifstream in5("cmatrix13.txt");
// std::string unused5;
// while ( std::getline(in5, unused5) ){
// 	++numLines13;}
// 
// int numLines23 = 0;
// ifstream in6("cmatrix23.txt");
// std::string unused6;
// while ( std::getline(in6, unused6) ){
// 	++numLines23;}
// 
// int numLines33 = 0;
// ifstream in7("cmatrix33.txt");
// std::string unused7;
// while ( std::getline(in7, unused7) ){
// 	++numLines33;}
// 
// 
// int numLines43 = 0;
// ifstream in8("cmatrix43.txt");
// std::string unused8;
// while ( std::getline(in8, unused8) ){
// 	++numLines43;}
// 
// int numLines53 = 0;
// ifstream in9("cmatrix53.txt");
// std::string unused9;
// while ( std::getline(in9, unused9) ){
// 	++numLines53;}
// 	
// 
// int numLines63 = 0;
// ifstream in10("cmatrix63.txt");
// std::string unused10;
// while ( std::getline(in10, unused10) ){
// 	++numLines63;}
// 
// 
// int numLines73 = 0;
// ifstream in11("cmatrix73.txt");
// std::string unused11;
// while ( std::getline(in11, unused11) ){
// 	++numLines73;}
// 
// 
// int numLines83 = 0;
// ifstream in12("cmatrix83.txt");
// std::string unused12;
// while ( std::getline(in12, unused12) ){
// 	++numLines83;}
// 
// 
// int numLines93 = 0;
// ifstream in13("cmatrix93.txt");
// std::string unused13;
// while ( std::getline(in13, unused13) ){
// 	++numLines93;}
// 
// 
// int numLines103 = 0;
// ifstream in14("cmatrix103.txt");
// std::string unused14;
// while ( std::getline(in14, unused14) ){
// 	++numLines103;}
// 	
// 
// int numLines113 = 0;
// ifstream in15("cmatrix113.txt");
// std::string unused15;
// while ( std::getline(in15, unused15) ){
// 	++numLines113;}
// 
// 
// int numLines123 = 0;
// ifstream in16("cmatrix123.txt");
// std::string unused16;
// while ( std::getline(in16, unused16) ){
// 	++numLines123;}
// 
// 
// int numLines133 = 0;
// ifstream in117("cmatrix133.txt");
// std::string unused117;
// while ( std::getline(in117, unused117) ){
// 	++numLines133;}
// 
// int numLines143 = 0;
// ifstream in138("cmatrix143.txt");
// std::string unused138;
// while ( std::getline(in138, unused138) ){
// 	++numLines143;}
// 
// int numLines153 = 0;
// ifstream in148("cmatrix153.txt");
// std::string unused148;
// while ( std::getline(in148, unused148) ){
// 	++numLines153;}
// 
// 
//   float **matrix13;
// 	matrix13 = new float*[numLines13];
//   for(int i30=0;i30 <numLines13; i30++){
//     matrix13 [i30] = new float[2];}
// 
// 
//   float **matrix23;
// 	matrix23 = new float*[numLines23];
//   for(int i30=0;i30 <numLines23; i30++){
//     matrix23 [i30] = new float[2];}
// 
//   float **matrix33;
// 	matrix33 = new float*[numLines33];
//   for(int i30=0;i30 <numLines33; i30++){
//     matrix33 [i30] = new float[2];}
// 
// 
//   float **matrix43;
// 	matrix43= new float*[numLines43];
//   for(int i30=0;i30 <numLines43; i30++){
//     matrix43 [i30] = new float[2];}
// 
//   
//   float **matrix53;
// 	matrix53 = new float*[numLines53];
//   for(int i30=0;i30 <numLines53; i30++){
//     matrix53 [i30] = new float[2];}
// 	
// 
//   float **matrix63;
// 	matrix63 = new float*[numLines63];
//   for(int i30=0;i30 <numLines63; i30++){
//     matrix63 [i30] = new float[2];}
// 
//   float **matrix73;
// 	matrix73 = new float*[numLines73];
//   for(int i30=0;i30 <numLines73; i30++){
//     matrix73 [i30] = new float[2];}
// 
//   float **matrix83;
// 	matrix83 = new float*[numLines83];
//   for(int i30=0;i30 <numLines83; i30++){
//     matrix83 [i30] = new float[2];}
// 
//   float **matrix93;
// 	matrix93 = new float*[numLines93];
//   for(int i30=0;i30 <numLines93; i30++){
//     matrix93 [i30] = new float[2];}
//   
//   float **matrix103;
// 	matrix103 = new float*[numLines103];
//   for(int i30=0;i30 <numLines103; i30++){
//     matrix103 [i30] = new float[2];}
// 	
// 
//   float **matrix113;
// 	matrix113 = new float*[numLines113];
//   for(int i30=0;i30 <numLines113; i30++){
//     matrix113 [i30] = new float[2];}
// 
// 
//   float **matrix123;
// 	matrix123 = new float*[numLines123];
//   for(int i30=0;i30 <numLines123; i30++){
//     matrix123 [i30] = new float[2];}
// 
// 
//   float **matrix133;
// 	matrix133 = new float*[numLines133];
//   for(int i30=0;i30 <numLines133; i30++){
//     matrix133 [i30] = new float[2];}
// 
//   float **matrix143;
// 	matrix143 = new float*[numLines143];
//   for(int i30=0;i30 <numLines143; i30++){
//     matrix143 [i30] = new float[2];}
//   
//   float **matrix153;
// 	matrix153 = new float*[numLines153];
//   for(int i30=0;i30 <numLines153; i30++){
//     matrix153 [i30] = new float[2];}
// 
// 
//   std::fstream file5("cmatrix13.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines13; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file5>> matrix13[i31][j31];
// 	
// 	}}
// file5.close();
// 
// 
// std::fstream file6("cmatrix23.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines23; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file6>> matrix23[i31][j31];
// 		
// 	}}
// file6.close();
// 
// 
// std::fstream file7("cmatrix33.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines33; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file7>> matrix33[i31][j31];
// 	
// 	}}
// file7.close();
// 
// 
// std::fstream file8("cmatrix43.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines43; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file8>> matrix43[i31][j31];
// 	
// 	}}
// file8.close();
// 
// 
//  std::fstream file9("cmatrix53.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines53; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file9>> matrix53[i31][j31];
// 	
// 	}}
// file9.close();
// 
// 
//  std::fstream file10("cmatrix63.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines63; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file10>> matrix63[i31][j31];
// 	
// 	}}
// file10.close();
// 
// 
//  std::fstream file11("cmatrix73.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines73; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file11>> matrix73[i31][j31];
// 	
// 	}}
// file11.close();
// 
// 
//  std::fstream file12("cmatrix83.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines83; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file12>> matrix83[i31][j31];
// 	
// 	}}
// file12.close();
// 
// 
//  std::fstream file13("cmatrix93.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines93; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file13>> matrix93[i31][j31];
// 	
// 	}}
// file13.close();
// 
// 
//  std::fstream file14("cmatrix103.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines103; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file14>> matrix103[i31][j31];
// 	
// 	}}
// file14.close();
// 
// 
//  std::fstream file15("cmatrix113.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines113; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file15>> matrix113[i31][j31];
// 	
// 	}}
// file15.close();
// 
// 
// std::fstream file315("cmatrix123.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines123; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file315>> matrix123[i31][j31];
// 	
// 	}}
// file315.close();
// 
// std::fstream file415("cmatrix133.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines133; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file415>> matrix133[i31][j31];
// 	
// 	}}
// file415.close();
// 
// 
// std::fstream file515("cmatrix143.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines143; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file515>> matrix143[i31][j31];
// 	
// 	}}
// file515.close();
// 
// 
// std::fstream file615("cmatrix153.txt", std::ios_base::in);
//   for (int i31 = 0; i31 <numLines153; i31++) {
//     for ( int j31 = 0; j31 <2; j31++) {
//         file615>> matrix153[i31][j31];
// 	
// 	}}
// file615.close();
// 
//  
//  float fjee4=0;
//  float fjee5=0;
//  float fjee6=0;
//  float fjee7=0;
// 
// 
//  float **jee4;
// 	jee4 = new float*[minimum];
//   for(int i30=0;i30 <minimum; i30++){
//     jee4 [i30] = new float[1];}
//   for(int kk=0;kk<minimum;kk++) {
// 	  jee4[kk][0]=0.42;}
// 
//   float **jee5;
// 	jee5 = new float*[minimum];
//   for(int i30=0;i30 <minimum; i30++){
//     jee5 [i30] = new float[1];}
//   for(int kk=0;kk<minimum;kk++) {
// 	  jee5[kk][0]=0.42;}
// 
// 
//   float **jee6;
// 	jee6 = new float*[minimum];
//   for(int i30=0;i30 <minimum; i30++){
//     jee6 [i30] = new float[1];}
//   for(int kk=0;kk<minimum;kk++) {
// 	  jee6[kk][0]=0.42;}
// 
// 
// 
//   float **jee7;
// 	jee7 = new float*[minimum];
//   for(int i30=0;i30 <minimum; i30++){
//     jee7 [i30] = new float[1];}
//   for(int kk=0;kk<minimum;kk++) {
// 	  jee7[kk][0]=0.42;}
// 
// 
// //////
// 
// 	int nazar4=0;
// 	int nazar5=0;
// 	int nazar6=0;
// 	int nazar7=0;
// 
// 	float **firing;
// 	firing= new float*[40];
//   for(int ie30=0;ie30 <40; ie30++){
//     firing[ie30] = new float[1];
//   for(int je30=0;je30 <1; je30++){
// 	  firing[ie30][je30]=0;
//   }}
// 
//   int temp_perc=0;
// int counter_percentage=0;
// 
// 	for(int qq=0;qq<4;qq++){
// 	for(int uu=0;uu<trail;uu++){
// 
// 	  
// 
// 	for(in=0;in<fNE+fNI;in++) {
// 	  for(ip=0;ip<CYCSIZE;ip++) {
// 	    
// 	    fhrece3[in][ip]=0.;
// 		fhreci3[in][ip]=0.;
// 	      }
// 	      fhi3[in]=0.;
// 	  }
// 	  
// 	      
// 	
// 
// 	  fhrece4=0.;
//       fhreci4=0.;
// 	  fhrece5=0.;
//       fhreci5=0.;
// 	  fhrece6=0.;
//       fhreci6=0.;
// 	  fhrece7=0.;
//       fhreci7=0.;
// 	
// 	
// 	fhi4=0.;
//     fhi5=0.;
// 	fhi6=0.;
// 	fhi7=0.;
// 
// 	ftspki4=-1;
// 	ftspki5=-1;
// 	ftspki6=-1;
// 	ftspki7=-1;
// 	
// 
// 	 for (in=0; in<fNE+fNI; in++){
// 
//     ftspki3[in]=-1;
//    
//     fxAMPA3[in]=0;
// 	fxAMPAk13[in]=0;
// 	fxAMPAk23[in]=0;
// 	fxAMPArk3[in]=0;
// 	
// 	
// 
//     fsAMPA3[in]=0;
// 	fsAMPAk13[in]=0;
// 	fsAMPAk23[in]=0;
// 	fsAMPArk3[in]=0;
// 	
// 	
// 
//     fsAMPATH311[in]=0;
//     fxAMPATH311[in]=0;
// 	fsAMPATHk1311[in]=0;
//     fxAMPATHk1311[in]=0;
// 	fsAMPATHk2311[in]=0;
//     fxAMPATHk2311[in]=0;
// 	fsAMPATHrk311[in]=0;
//     fxAMPATHrk311[in]=0;
// 
// 	fsAMPATH312[in]=0;
//     fxAMPATH312[in]=0;
// 	fsAMPATHk1312[in]=0;
//     fxAMPATHk1312[in]=0;
// 	fsAMPATHk2312[in]=0;
//     fxAMPATHk2312[in]=0;
// 	fsAMPATHrk312[in]=0;
//     fxAMPATHrk312[in]=0;
// 
// 	fsAMPATH313[in]=0;
//     fxAMPATH313[in]=0;
// 	fsAMPATHk1313[in]=0;
//     fxAMPATHk1313[in]=0;
// 	fsAMPATHk2313[in]=0;
//     fxAMPATHk2313[in]=0;
// 	fsAMPATHrk313[in]=0;
//     fxAMPATHrk313[in]=0;
// 
// 	fsAMPATH314[in]=0;
//     fxAMPATH314[in]=0;
// 	fsAMPATHk1314[in]=0;
//     fxAMPATHk1314[in]=0;
// 	fsAMPATHk2314[in]=0;
//     fxAMPATHk2314[in]=0;
// 	fsAMPATHrk314[in]=0;
//     fxAMPATHrk314[in]=0;
// 
// 	fsAMPATH315[in]=0;
//     fxAMPATH315[in]=0;
// 	fsAMPATHk1315[in]=0;
//     fxAMPATHk1315[in]=0;
// 	fsAMPATHk2315[in]=0;
//     fxAMPATHk2315[in]=0;
// 	fsAMPATHrk315[in]=0;
//     fxAMPATHrk315[in]=0;
// 	
// 	fsAMPATH316[in]=0;
//     fxAMPATH316[in]=0;
// 	fsAMPATHk1316[in]=0;
//     fxAMPATHk1316[in]=0;
// 	fsAMPATHk2316[in]=0;
//     fxAMPATHk2316[in]=0;
// 	fsAMPATHrk316[in]=0;
//     fxAMPATHrk316[in]=0;
// 
// 	fsAMPATH317[in]=0;
//     fxAMPATH317[in]=0;
// 	fsAMPATHk1317[in]=0;
//     fxAMPATHk1317[in]=0;
// 	fsAMPATHk2317[in]=0;
//     fxAMPATHk2317[in]=0;
// 	fsAMPATHrk317[in]=0;
//     fxAMPATHrk317[in]=0;
// 
// 	fsAMPATH318[in]=0;
//     fxAMPATH318[in]=0;
// 	fsAMPATHk1318[in]=0;
//     fxAMPATHk1318[in]=0;
// 	fsAMPATHk2318[in]=0;
//     fxAMPATHk2318[in]=0;
// 	fsAMPATHrk318[in]=0;
//     fxAMPATHrk318[in]=0;
// 
// 	fsAMPATH319[in]=0;
//     fxAMPATH319[in]=0;
// 	fsAMPATHk1319[in]=0;
//     fxAMPATHk1319[in]=0;
// 	fsAMPATHk2319[in]=0;
//     fxAMPATHk2319[in]=0;
// 	fsAMPATHrk319[in]=0;
//     fxAMPATHrk319[in]=0;
// 	
// 	fsAMPATH3110[in]=0;
//     fxAMPATH3110[in]=0;
// 	fsAMPATHk13110[in]=0;
//     fxAMPATHk13110[in]=0;
// 	fsAMPATHk23110[in]=0;
//     fxAMPATHk23110[in]=0;
// 	fsAMPATHrk3110[in]=0;
//     fxAMPATHrk3110[in]=0;
// 	
// 	fsAMPATH3111[in]=0;
//     fxAMPATH3111[in]=0;
// 	fsAMPATHk13111[in]=0;
//     fxAMPATHk13111[in]=0;
// 	fsAMPATHk23111[in]=0;
//     fxAMPATHk23111[in]=0;
// 	fsAMPATHrk3111[in]=0;
//     fxAMPATHrk3111[in]=0;
// 	
// 	fsAMPATH3112[in]=0;
//     fxAMPATH3112[in]=0;
// 	fsAMPATHk13112[in]=0;
//     fxAMPATHk13112[in]=0;
// 	fsAMPATHk23112[in]=0;
//     fxAMPATHk23112[in]=0;
// 	fsAMPATHrk3112[in]=0;
//     fxAMPATHrk3112[in]=0;
// 
// 
// 	fsAMPATH3113[in]=0;
//     fxAMPATH3113[in]=0;
// 	fsAMPATHk13113[in]=0;
//     fxAMPATHk13113[in]=0;
// 	fsAMPATHk23113[in]=0;
//     fxAMPATHk23113[in]=0;
// 	fsAMPATHrk3113[in]=0;
//     fxAMPATHrk3113[in]=0;
// 
// 	fsAMPATH3114[in]=0;
//     fxAMPATH3114[in]=0;
// 	fsAMPATHk13114[in]=0;
//     fxAMPATHk13114[in]=0;
// 	fsAMPATHk23114[in]=0;
//     fxAMPATHk23114[in]=0;
// 	fsAMPATHrk3114[in]=0;
//     fxAMPATHrk3114[in]=0;
// 
// 	fsAMPATH3115[in]=0;
//     fxAMPATH3115[in]=0;
// 	fsAMPATHk13115[in]=0;
//     fxAMPATHk13115[in]=0;
// 	fsAMPATHk23115[in]=0;
//     fxAMPATHk23115[in]=0;
// 	fsAMPATHrk3115[in]=0;
//     fxAMPATHrk3115[in]=0;
// 
// 	fsAMPATH3116[in]=0;
//     fxAMPATH3116[in]=0;
// 	fsAMPATHk13116[in]=0;
//     fxAMPATHk13116[in]=0;
// 	fsAMPATHk23116[in]=0;
//     fxAMPATHk23116[in]=0;
// 	fsAMPATHrk3116[in]=0;
//     fxAMPATHrk3116[in]=0;
// 	
// 	fsAMPATH3117[in]=0;
//     fxAMPATH3117[in]=0;
// 	fsAMPATHk13117[in]=0;
//     fxAMPATHk13117[in]=0;
// 	fsAMPATHk23117[in]=0;
//     fxAMPATHk23117[in]=0;
// 	fsAMPATHrk3117[in]=0;
//     fxAMPATHrk3117[in]=0;
// 
// 
// 	isAMPATH[in]=0;
//     ixAMPATH[in]=0;
// 	isAMPATHk1[in]=0;
//     ixAMPATHk1[in]=0;
// 	isAMPATHk2[in]=0;
//     ixAMPATHk2[in]=0;
// 	isAMPATHrk[in]=0;
//     ixAMPATHrk[in]=0;
// 	
// 
// 	xAMPACC[in]=0;
// 	xAMPACCk1[in]=0;
// 	xAMPACCk2[in]=0;
// 	xAMPACCrk[in]=0;
//     sAMPACC[in]=0;
// 	sAMPACCk1[in]=0;
// 	sAMPACCk2[in]=0;
// 	sAMPACCrk[in]=0;
// 
//     fxGABA3[in]=0;
// 	fxGABAk13[in]=0;
// 	fxGABAk23[in]=0;
// 	fxGABArk3[in]=0;
// 	
// 
//     fsGABA3[in]=0;
// 	fsGABAk13[in]=0;
// 	fsGABAk23[in]=0;
// 	fsGABArk3[in]=0;
// 	
// 	 }
// 
// 	fxAMPA34=0;
// 	fxAMPA35=0;
// 	fxAMPAk134=0;
// 	fxAMPAk135=0;
// 	fxAMPAk234=0;
// 	fxAMPAk235=0;
// 	fxAMPArk34=0;
// 	fxAMPArk35=0;
// 
// 	fsAMPA34=0;
// 	fsAMPA35=0;
// 	fsAMPAk134=0;
// 	fsAMPAk135=0;
// 	fsAMPAk234=0;
// 	fsAMPAk235=0;
// 	fsAMPArk34=0;
// 	fsAMPArk35=0;
// 
// 	fxGABA34=0;
// 	fxGABA35=0;
// 	fxGABAk134=0;
// 	fsGABAk134=0;
// 	fxGABAk135=0;
// 	fsGABAk135=0;
// 	fxGABAk234=0;
// 	fsGABAk234=0;
// 	fxGABAk235=0;
// 	fsGABAk235=0;
// 	fxGABArk34=0;
// 	fsGABArk34=0;
// 	fxGABArk35=0;
// 	fsGABArk35=0;
// 	
// 	fsGABA34=0;
// 	fsGABA35=0;
// 
// 
// 	fxAMPA36=0;
// 	fxAMPA37=0;
// 	fxAMPAk136=0;
// 	fxAMPAk137=0;
// 	fxAMPAk236=0;
// 	fxAMPAk237=0;
// 	fxAMPArk36=0;
// 	fxAMPArk37=0;
// 
// 	fsAMPA36=0;
// 	fsAMPA37=0;
// 	fsAMPAk136=0;
// 	fsAMPAk137=0;
// 	fsAMPAk236=0;
// 	fsAMPAk237=0;
// 	fsAMPArk36=0;
// 	fsAMPArk37=0;
// 
// 	fxGABA36=0;
// 	fxGABA37=0;
// 	fxGABAk136=0;
// 	fsGABAk136=0;
// 	fxGABAk137=0;
// 	fsGABAk137=0;
// 	fxGABAk236=0;
// 	fsGABAk236=0;
// 	fxGABAk237=0;
// 	fsGABAk237=0;
// 	fxGABArk36=0;
// 	fsGABArk36=0;
// 	fxGABArk37=0;
// 	fsGABArk37=0;
// 	
// 	fsGABA36=0;
// 	fsGABA37=0;
// 
// 
// 
//     iIsyn3=0;
// 	fIsyn31=0;
// 	fIsyn32=0;
// 	fIsyn33=0;
// 	fIsyn34=0;
//     fIsyn4=0;
// 	fIsyn5=0;
// 	fIsyn6=0;
// 	fIsyn7=0;
// 	
// 
//     iIsynk13=0;
// 	fIsynk131=0;
// 	fIsynk132=0;
// 	fIsynk133=0;
// 	fIsynk134=0;
//     fIsynk14=0;
// 	fIsynk15=0;
// 	fIsynk16=0;
// 	fIsynk17=0;
// 
// 
// 	int counter=0;
// 	
// 	
// 	for(icycle=0;icycle<sub*time;icycle++){
// 
// 	  
// 	 counter_percentage++;
// 	 if(((counter_percentage*100/(sub*time*trail*4))%5==0) && ((counter_percentage*100/(sub*time*trail*4))>temp_perc) ){
// 	    temp_perc=counter_percentage*100/(sub*time*trail*4);
// 	    printf("Calibration in progress %d%%...\n",temp_perc);
// 	  }
// 
// 		if (icycle>0 && icycle%CYCSIZE==0){
// 			counter=counter+1;}
// 
// 
// 		if (icycle>stimbin*10){
//       frnoise+=-frnoise*lamb+munoise*lamb+sigmanoise*sqrt(2*lamb)*gasdev(&idum);
//       stimbin++;
//     }
// 		frspont=(fromcortex*(frnoise))/200;
// 		if (frspont<0) {frspont=0;}
// 
// 
// 		int xx=10;
// 
// 		ffrstim11=inputtrain[counter][uu][0][qq]*xx;
// 		ffrstim12=inputtrain[counter][uu][1][qq]*xx;
// 		ffrstim13=inputtrain[counter][uu][2][qq]*xx;
// 		ffrstim14=inputtrain[counter][uu][3][qq]*xx;
// 		ffrstim21=inputtrain[counter][uu][4][qq]*xx;
// 		ffrstim22=inputtrain[counter][uu][5][qq]*xx;
// 		ffrstim23=inputtrain[counter][uu][6][qq]*xx;
// 		ffrstim24=inputtrain[counter][uu][7][qq]*xx;
// 		ffrstim31=inputtrain[counter][uu][8][qq]*xx;
// 		ffrstim32=inputtrain[counter][uu][9][qq]*xx;
// 		ffrstim33=inputtrain[counter][uu][10][qq]*xx;
// 		ffrstim41=inputtrain[counter][uu][11][qq]*xx;
// 		ffrstim42=inputtrain[counter][uu][12][qq]*xx;
// 		ffrstim43=inputtrain[counter][uu][13][qq]*xx;
// 		ffrstim44=inputtrain[counter][uu][14][qq]*xx;
// 
// 		ifrstim=(5+fromth)/200;
// 
// 		nazar4=0;
// 		nazar5=0;
// 		nazar6=0;
// 		nazar7=0;
// 
// 
// 	  for(ineur=0;ineur<fNE;ineur++) {
// 
// 
// 		  tminx=icycle%CYCSIZE;
// 
// 	  fstim11=poidev(ffrstim11,&idum);
// 	  fstim12=poidev(ffrstim12,&idum);
// 	  fstim13=poidev(ffrstim13,&idum);
// 	  fstim14=poidev(ffrstim14,&idum);
// 	  fstim21=poidev(ffrstim21,&idum);
// 	  fstim22=poidev(ffrstim22,&idum);
// 	  fstim23=poidev(ffrstim23,&idum);
// 	  fstim24=poidev(ffrstim24,&idum);
// 	  fstim31=poidev(ffrstim31,&idum);
// 	  fstim32=poidev(ffrstim32,&idum);
// 	  fstim33=poidev(ffrstim33,&idum);
// 	  fstim41=poidev(ffrstim41,&idum);
// 	  fstim42=poidev(ffrstim42,&idum);
// 	  fstim43=poidev(ffrstim43,&idum);
// 	  fstim44=poidev(ffrstim44,&idum);
// 
// 
// 	  noise=poidev(frspont,&idum);
// 	  istim=poidev(ifrstim,&idum);
// 	  
// 	  fIsyn31=0;
// 	  for(int qq=0;qq<numLines13;qq++) {
// 		if(ineur==matrix13[qq][1]){
// 			fIsyn31=fIsyn31+fsAMPATH311[ineur];}}
// 
// 	   for(int qq=0;qq<numLines23;qq++) {
// 		if(ineur==matrix23[qq][1]){
// 			fIsyn31=fIsyn31+fsAMPATH312[ineur];}}
// 
// 	    for(int qq=0;qq<numLines33;qq++) {
// 		if(ineur==matrix33[qq][1]){
// 			fIsyn31=fIsyn31+fsAMPATH313[ineur];}}
// 
// 		 for(int qq=0;qq<numLines43;qq++) {
// 		if(ineur==matrix43[qq][1]){
// 			fIsyn31=fIsyn31+fsAMPATH314[ineur];}}
// 		
// 	  
// 		   for(int qq=0;qq<numLines53;qq++) {
// 		if(ineur==matrix53[qq][1]){
// 			fIsyn31=fIsyn31+fsAMPATH316[ineur];}}
// 
// 
// 		    for(int qq=0;qq<numLines63;qq++) {
// 		if(ineur==matrix63[qq][1]){
// 			fIsyn31=fIsyn31+fsAMPATH317[ineur];}}
// 
// 
// 			 for(int qq=0;qq<numLines73;qq++) {
// 		if(ineur==matrix73[qq][1]){
// 			fIsyn31=fIsyn31+fsAMPATH318[ineur];}}
// 
// 
// 			  for(int qq=0;qq<numLines83;qq++) {
// 		if(ineur==matrix83[qq][1]){
// 			fIsyn31=fIsyn31+fsAMPATH319[ineur];}}
// 
// 	  
// 			    for(int qq=0;qq<numLines93;qq++) {
// 		if(ineur==matrix93[qq][1]){
// 			fIsyn31=fIsyn31+fsAMPATH3111[ineur];}}
// 
// 
// 				 for(int qq=0;qq<numLines103;qq++) {
// 		if(ineur==matrix103[qq][1]){
// 			fIsyn31=fIsyn31+fsAMPATH3112[ineur];}}
// 
// 
// 				  for(int qq=0;qq<numLines113;qq++) {
// 		if(ineur==matrix113[qq][1]){
// 			fIsyn31=fIsyn31+fsAMPATH3113[ineur];}}
// 
//     
// 	    fIsyn31=fIsyn31+fsAMPA3[ineur]-fsGABA3[ineur]+isAMPATH[ineur];
// 
// 
// 	/* ///////////////////////////////// E-->E ////////////////////////// */
// 
//     ffspk3=fhrece3[ineur][tminx];
//   
//     fxAMPAk13[ineur]=inriseEE*taumE*(jee*(ffspk3))-dtriseEE*fxAMPA3[ineur];
// 	fsAMPAk13[ineur]=dtdecayEE*(fxAMPA3[ineur] - fsAMPA3[ineur]);
// 	fsAMPArk3[ineur]=fsAMPA3[ineur]+0.5*fsAMPAk13[ineur];
// 	fxAMPAk23[ineur]=inriseEE*taumE*(jee*(ffspk3))- dtriseEE*(fxAMPA3[ineur]+0.5*fxAMPAk13[ineur]);
// 	fsAMPAk23[ineur]=dtdecayEE*((fxAMPA3[ineur]+0.5*fxAMPAk13[ineur]) - fsAMPArk3[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPA3[ineur]+=fxAMPAk23[ineur]; /* value = value0 + increment*/
// 	fsAMPA3[ineur]+=fsAMPAk23[ineur];
// 
// 
// 	ixAMPATHk1[ineur]=inriseEE*taumE*(jestim*(istim)) -dtriseEE*ixAMPATH[ineur];
// 	isAMPATHk1[ineur]=dtdecayEE*(ixAMPATH[ineur] - isAMPATH[ineur]);
// 	isAMPATHrk[ineur]=isAMPATH[ineur]+0.5*isAMPATHk1[ineur];
// 	ixAMPATHk2[ineur]=inriseEE*taumE*(jestim*(istim)) - dtriseEE*(ixAMPATH[ineur]+0.5*ixAMPATHk1[ineur]);
// 	isAMPATHk2[ineur]=dtdecayEE*((ixAMPATH[ineur]+0.5*ixAMPATHk1[ineur]) - isAMPATHrk[ineur]); /*increment computed with runge-kutta*/
// 	ixAMPATH[ineur]+=ixAMPATHk2[ineur]; /* value = value0 + increment*/
// 	isAMPATH[ineur]+=isAMPATHk2[ineur];
// 
// 
// 	for(int pp=0;pp<numLines13;pp++) {		
// 
// 		if(ineur==matrix13[pp][1]){
// 
// 	fxAMPATHk1311[ineur]=inriseEE*taumE*(jestim*(fstim11)) -dtriseEE*fxAMPATH311[ineur];
// 	fsAMPATHk1311[ineur]=dtdecayEE*(fxAMPATH311[ineur] - fsAMPATH311[ineur]);
// 	fsAMPATHrk311[ineur]=fsAMPATH311[ineur]+0.5*fsAMPATHk1311[ineur];
// 	fxAMPATHk2311[ineur]=inriseEE*taumE*(jestim*(fstim11)) - dtriseEE*(fxAMPATH311[ineur]+0.5*fxAMPATHk1311[ineur]);
// 	fsAMPATHk2311[ineur]=dtdecayEE*((fxAMPATH311[ineur]+0.5*fxAMPATHk1311[ineur]) - fsAMPATHrk311[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH311[ineur]+=fxAMPATHk2311[ineur]; /* value = value0 + increment*/
// 	fsAMPATH311[ineur]+=fsAMPATHk2311[ineur];
// 
// 	if (fstim11>0){
// 		  fprintf(input1,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input1);}
// 		  
// 		}
// 
// 	
// 	}
// 
// 
// 	for(int pp=0;pp<numLines23;pp++) {
// 		if(ineur==matrix23[pp][1]){
// 
// 	fxAMPATHk1312[ineur]=inriseEE*taumE*(jestim*(fstim12)) -dtriseEE*fxAMPATH312[ineur];
// 	fsAMPATHk1312[ineur]=dtdecayEE*(fxAMPATH312[ineur] - fsAMPATH312[ineur]);
// 	fsAMPATHrk312[ineur]=fsAMPATH312[ineur]+0.5*fsAMPATHk1312[ineur];
// 	fxAMPATHk2312[ineur]=inriseEE*taumE*(jestim*(fstim12)) - dtriseEE*(fxAMPATH312[ineur]+0.5*fxAMPATHk1312[ineur]);
// 	fsAMPATHk2312[ineur]=dtdecayEE*((fxAMPATH312[ineur]+0.5*fxAMPATHk1312[ineur]) - fsAMPATHrk312[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH312[ineur]+=fxAMPATHk2312[ineur]; /* value = value0 + increment*/
// 	fsAMPATH312[ineur]+=fsAMPATHk2312[ineur];
// 
// 	if (fstim12>0){
// 		  fprintf(input2,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input2);}
// 
// 		}
// 	
// 	}
// 
// 
// 
// 	for(int pp=0;pp<numLines33;pp++) {
// 
// 	
// 		if(ineur==matrix33[pp][1]){
// 
// 	fxAMPATHk1313[ineur]=inriseEE*taumE*(jestim*(fstim13)) -dtriseEE*fxAMPATH313[ineur];
// 	fsAMPATHk1313[ineur]=dtdecayEE*(fxAMPATH313[ineur] - fsAMPATH313[ineur]);
// 	fsAMPATHrk313[ineur]=fsAMPATH313[ineur]+0.5*fsAMPATHk1313[ineur];
// 	fxAMPATHk2313[ineur]=inriseEE*taumE*(jestim*(fstim13)) - dtriseEE*(fxAMPATH313[ineur]+0.5*fxAMPATHk1313[ineur]);
// 	fsAMPATHk2313[ineur]=dtdecayEE*((fxAMPATH313[ineur]+0.5*fxAMPATHk1313[ineur]) - fsAMPATHrk313[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH313[ineur]+=fxAMPATHk2313[ineur]; /* value = value0 + increment*/
// 	fsAMPATH313[ineur]+=fsAMPATHk2313[ineur];
// 
// 	if (fstim13>0){
// 		  fprintf(input3,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input3);}
// 
// 		}
// 
// 	
// 	}
// 
// 	for(int pp=0;pp<numLines43;pp++) {
// 
// 
// 		if(ineur==matrix43[pp][1]){
// 
// 	fxAMPATHk1314[ineur]=inriseEE*taumE*(jestim*(fstim14)) -dtriseEE*fxAMPATH314[ineur];
// 	fsAMPATHk1314[ineur]=dtdecayEE*(fxAMPATH314[ineur] - fsAMPATH314[ineur]);
// 	fsAMPATHrk314[ineur]=fsAMPATH314[ineur]+0.5*fsAMPATHk1314[ineur];
// 	fxAMPATHk2314[ineur]=inriseEE*taumE*(jestim*(fstim14)) - dtriseEE*(fxAMPATH314[ineur]+0.5*fxAMPATHk1314[ineur]);
// 	fsAMPATHk2314[ineur]=dtdecayEE*((fxAMPATH314[ineur]+0.5*fxAMPATHk1314[ineur]) - fsAMPATHrk314[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH314[ineur]+=fxAMPATHk2314[ineur]; /* value = value0 + increment*/
// 	fsAMPATH314[ineur]+=fsAMPATHk2314[ineur];
// 
// 	if (fstim14>0){
// 		  fprintf(input4,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input4);}
// 
// 		}
// 	
// 	
// 	}
// 	
// 	for(int pp=0;pp<numLines53;pp++) {
// 
// 		if(ineur==matrix53[pp][1]){
// 
// 	fxAMPATHk1316[ineur]=inriseEE*taumE*(jestim*(fstim21)) -dtriseEE*fxAMPATH316[ineur];
// 	fsAMPATHk1316[ineur]=dtdecayEE*(fxAMPATH316[ineur] - fsAMPATH316[ineur]);
// 	fsAMPATHrk316[ineur]=fsAMPATH316[ineur]+0.5*fsAMPATHk1316[ineur];
// 	fxAMPATHk2316[ineur]=inriseEE*taumE*(jestim*(fstim21)) - dtriseEE*(fxAMPATH316[ineur]+0.5*fxAMPATHk1316[ineur]);
// 	fsAMPATHk2316[ineur]=dtdecayEE*((fxAMPATH316[ineur]+0.5*fxAMPATHk1316[ineur]) - fsAMPATHrk316[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH316[ineur]+=fxAMPATHk2316[ineur]; /* value = value0 + increment*/
// 	fsAMPATH316[ineur]+=fsAMPATHk2316[ineur];
// 
// 	if (fstim21>0){
// 		  fprintf(input5,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input5);}
// 
// 		}
// 	
// 	
// 	
// 	}
// 
// 
// 	for(int pp=0;pp<numLines63;pp++) {
// 
// 
// 		if(ineur==matrix63[pp][1]){
// 
// 	fxAMPATHk1317[ineur]=inriseEE*taumE*(jestim*(fstim22)) -dtriseEE*fxAMPATH317[ineur];
// 	fsAMPATHk1317[ineur]=dtdecayEE*(fxAMPATH317[ineur] - fsAMPATH317[ineur]);
// 	fsAMPATHrk317[ineur]=fsAMPATH317[ineur]+0.5*fsAMPATHk1317[ineur];
// 	fxAMPATHk2317[ineur]=inriseEE*taumE*(jestim*(fstim22)) - dtriseEE*(fxAMPATH317[ineur]+0.5*fxAMPATHk1317[ineur]);
// 	fsAMPATHk2317[ineur]=dtdecayEE*((fxAMPATH317[ineur]+0.5*fxAMPATHk1317[ineur]) - fsAMPATHrk317[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH317[ineur]+=fxAMPATHk2317[ineur]; /* value = value0 + increment*/
// 	fsAMPATH317[ineur]+=fsAMPATHk2317[ineur];
// 
// 	if (fstim22>0){
// 		  fprintf(input6,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input6);}
// 
// 		}
// 	
// 	
// 	}
// 
// 	for(int pp=0;pp<numLines73;pp++) {
// 
// 
// 		if(ineur==matrix73[pp][1]){
// 
// 	fxAMPATHk1318[ineur]=inriseEE*taumE*(jestim*(fstim23)) -dtriseEE*fxAMPATH318[ineur];
// 	fsAMPATHk1318[ineur]=dtdecayEE*(fxAMPATH318[ineur] - fsAMPATH318[ineur]);
// 	fsAMPATHrk318[ineur]=fsAMPATH318[ineur]+0.5*fsAMPATHk1318[ineur];
// 	fxAMPATHk2318[ineur]=inriseEE*taumE*(jestim*(fstim23)) - dtriseEE*(fxAMPATH318[ineur]+0.5*fxAMPATHk1318[ineur]);
// 	fsAMPATHk2318[ineur]=dtdecayEE*((fxAMPATH318[ineur]+0.5*fxAMPATHk1318[ineur]) - fsAMPATHrk318[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH318[ineur]+=fxAMPATHk2318[ineur]; /* value = value0 + increment*/
// 	fsAMPATH318[ineur]+=fsAMPATHk2318[ineur];
// 
// 	if (fstim23>0){
// 		  fprintf(input7,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input7);}
// 
// 		}
// 
// 	
// 	}
// 
// 	for(int pp=0;pp<numLines83;pp++) {
// 
// 		if(ineur==matrix83[pp][1]){
// 
// 	fxAMPATHk1319[ineur]=inriseEE*taumE*(jestim*(fstim24)) -dtriseEE*fxAMPATH319[ineur];
// 	fsAMPATHk1319[ineur]=dtdecayEE*(fxAMPATH319[ineur] - fsAMPATH319[ineur]);
// 	fsAMPATHrk319[ineur]=fsAMPATH319[ineur]+0.5*fsAMPATHk1319[ineur];
// 	fxAMPATHk2319[ineur]=inriseEE*taumE*(jestim*(fstim24)) - dtriseEE*(fxAMPATH319[ineur]+0.5*fxAMPATHk1319[ineur]);
// 	fsAMPATHk2319[ineur]=dtdecayEE*((fxAMPATH319[ineur]+0.5*fxAMPATHk1319[ineur]) - fsAMPATHrk319[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH319[ineur]+=fxAMPATHk2319[ineur]; /* value = value0 + increment*/
// 	fsAMPATH319[ineur]+=fsAMPATHk2319[ineur];
// 
// 	if (fstim24>0){
// 		  fprintf(input8,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input8);}
// 
// 		}
// 	
// 	
// 	}
// 
// 	
// 
// 	for(int pp=0;pp<numLines93;pp++) {
// 
// 
// 		if(ineur==matrix93[pp][1]){
// 
// 	fxAMPATHk13111[ineur]=inriseEE*taumE*(jestim*(fstim31)) -dtriseEE*fxAMPATH3111[ineur];
// 	fsAMPATHk13111[ineur]=dtdecayEE*(fxAMPATH3111[ineur] - fsAMPATH3111[ineur]);
// 	fsAMPATHrk3111[ineur]=fsAMPATH3111[ineur]+0.5*fsAMPATHk13111[ineur];
// 	fxAMPATHk23111[ineur]=inriseEE*taumE*(jestim*(fstim31)) - dtriseEE*(fxAMPATH3111[ineur]+0.5*fxAMPATHk13111[ineur]);
// 	fsAMPATHk23111[ineur]=dtdecayEE*((fxAMPATH3111[ineur]+0.5*fxAMPATHk13111[ineur]) - fsAMPATHrk3111[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH3111[ineur]+=fxAMPATHk23111[ineur]; /* value = value0 + increment*/
// 	fsAMPATH3111[ineur]+=fsAMPATHk23111[ineur];
// 
// 	if (fstim31>0){
// 		  fprintf(input9,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input9);}
// 
// 		}
// 	
// 
// 	}
// 
// 
// 	for(int pp=0;pp<numLines103;pp++) {
// 
// 		if(ineur==matrix103[pp][1]){
// 
// 	fxAMPATHk13112[ineur]=inriseEE*taumE*(jestim*(fstim32)) -dtriseEE*fxAMPATH3112[ineur];
// 	fsAMPATHk13112[ineur]=dtdecayEE*(fxAMPATH3112[ineur] - fsAMPATH3112[ineur]);
// 	fsAMPATHrk3112[ineur]=fsAMPATH3112[ineur]+0.5*fsAMPATHk13112[ineur];
// 	fxAMPATHk23112[ineur]=inriseEE*taumE*(jestim*(fstim32)) - dtriseEE*(fxAMPATH3112[ineur]+0.5*fxAMPATHk13112[ineur]);
// 	fsAMPATHk23112[ineur]=dtdecayEE*((fxAMPATH3112[ineur]+0.5*fxAMPATHk13112[ineur]) - fsAMPATHrk3112[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH3112[ineur]+=fxAMPATHk23112[ineur]; /* value = value0 + increment*/
// 	fsAMPATH3112[ineur]+=fsAMPATHk23112[ineur];
// 
// 	if (fstim32>0){
// 		  fprintf(input10,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input10);}
// 
// 		}
// 
// 
// 	
// 	}
// 
// 
// 	for(int pp=0;pp<numLines113;pp++) {
// 
// 
// 		if(ineur==matrix113[pp][1]){
// 
// 	fxAMPATHk13113[ineur]=inriseEE*taumE*(jestim*(fstim33)) -dtriseEE*fxAMPATH3113[ineur];
// 	fsAMPATHk13113[ineur]=dtdecayEE*(fxAMPATH3113[ineur] - fsAMPATH3113[ineur]);
// 	fsAMPATHrk3113[ineur]=fsAMPATH3113[ineur]+0.5*fsAMPATHk13113[ineur];
// 	fxAMPATHk23113[ineur]=inriseEE*taumE*(jestim*(fstim33)) - dtriseEE*(fxAMPATH3113[ineur]+0.5*fxAMPATHk13113[ineur]);
// 	fsAMPATHk23113[ineur]=dtdecayEE*((fxAMPATH3113[ineur]+0.5*fxAMPATHk13113[ineur]) - fsAMPATHrk3113[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH3113[ineur]+=fxAMPATHk23113[ineur]; /* value = value0 + increment*/
// 	fsAMPATH3113[ineur]+=fsAMPATHk23113[ineur];
// 
// 	if (fstim33>0){
// 		  fprintf(input11,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input11);}
// 
// 		}
// 	
// 	}
// 
// 
// 	for(int pp=0;pp<numLines123;pp++) {
// 	
// 		if(ineur==matrix123[pp][1]){
// 
// 	fxAMPATHk13114[ineur]=inriseEE*taumE*(jestim*(fstim41)) -dtriseEE*fxAMPATH3114[ineur];
// 	fsAMPATHk13114[ineur]=dtdecayEE*(fxAMPATH3114[ineur] - fsAMPATH3114[ineur]);
// 	fsAMPATHrk3114[ineur]=fsAMPATH3114[ineur]+0.5*fsAMPATHk13114[ineur];
// 	fxAMPATHk23114[ineur]=inriseEE*taumE*(jestim*(fstim41)) - dtriseEE*(fxAMPATH3114[ineur]+0.5*fxAMPATHk13114[ineur]);
// 	fsAMPATHk23114[ineur]=dtdecayEE*((fxAMPATH3114[ineur]+0.5*fxAMPATHk13114[ineur]) - fsAMPATHrk3114[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH3114[ineur]+=fxAMPATHk23114[ineur]; /* value = value0 + increment*/
// 	fsAMPATH3114[ineur]+=fsAMPATHk23114[ineur];
// 
// 	if (fstim41>0){
// 		  fprintf(input12,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input12);}
// 		}
// 	}
// 
// 
// 	for(int pp=0;pp<numLines133;pp++) {
// 	
// 		if(ineur==matrix133[pp][1]){
// 
// 	fxAMPATHk13115[ineur]=inriseEE*taumE*(jestim*(fstim42)) -dtriseEE*fxAMPATH3115[ineur];
// 	fsAMPATHk13115[ineur]=dtdecayEE*(fxAMPATH3115[ineur] - fsAMPATH3115[ineur]);
// 	fsAMPATHrk3115[ineur]=fsAMPATH3115[ineur]+0.5*fsAMPATHk13115[ineur];
// 	fxAMPATHk23115[ineur]=inriseEE*taumE*(jestim*(fstim42)) - dtriseEE*(fxAMPATH3115[ineur]+0.5*fxAMPATHk13115[ineur]);
// 	fsAMPATHk23115[ineur]=dtdecayEE*((fxAMPATH3115[ineur]+0.5*fxAMPATHk13115[ineur]) - fsAMPATHrk3115[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH3115[ineur]+=fxAMPATHk23115[ineur]; /* value = value0 + increment*/
// 	fsAMPATH3115[ineur]+=fsAMPATHk23115[ineur];
// 
// 	if (fstim42>0){
// 		  fprintf(input13,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input13);}
// 		}
// 	}
// 
// 
// 	for(int pp=0;pp<numLines143;pp++) {
// 	
// 		if(ineur==matrix143[pp][1]){
// 
// 	fxAMPATHk13116[ineur]=inriseEE*taumE*(jestim*(fstim43)) -dtriseEE*fxAMPATH3116[ineur];
// 	fsAMPATHk13116[ineur]=dtdecayEE*(fxAMPATH3116[ineur] - fsAMPATH3116[ineur]);
// 	fsAMPATHrk3116[ineur]=fsAMPATH3116[ineur]+0.5*fsAMPATHk13116[ineur];
// 	fxAMPATHk23116[ineur]=inriseEE*taumE*(jestim*(fstim43)) - dtriseEE*(fxAMPATH3116[ineur]+0.5*fxAMPATHk13116[ineur]);
// 	fsAMPATHk23116[ineur]=dtdecayEE*((fxAMPATH3116[ineur]+0.5*fxAMPATHk13116[ineur]) - fsAMPATHrk3116[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH3116[ineur]+=fxAMPATHk23116[ineur]; /* value = value0 + increment*/
// 	fsAMPATH3116[ineur]+=fsAMPATHk23116[ineur];
// 
// 	if (fstim43>0){
// 		  fprintf(input14,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input14);}
// 		}
// 	}
// 
// 	for(int pp=0;pp<numLines153;pp++) {
// 	
// 		if(ineur==matrix153[pp][1]){
// 
// 	fxAMPATHk13117[ineur]=inriseEE*taumE*(jestim*(fstim44)) -dtriseEE*fxAMPATH3117[ineur];
// 	fsAMPATHk13117[ineur]=dtdecayEE*(fxAMPATH3117[ineur] - fsAMPATH3117[ineur]);
// 	fsAMPATHrk3117[ineur]=fsAMPATH3117[ineur]+0.5*fsAMPATHk13117[ineur];
// 	fxAMPATHk23117[ineur]=inriseEE*taumE*(jestim*(fstim44)) - dtriseEE*(fxAMPATH3117[ineur]+0.5*fxAMPATHk13117[ineur]);
// 	fsAMPATHk23117[ineur]=dtdecayEE*((fxAMPATH3117[ineur]+0.5*fxAMPATHk13117[ineur]) - fsAMPATHrk3117[ineur]); /*increment computed with runge-kutta*/
// 	fxAMPATH3117[ineur]+=fxAMPATHk23117[ineur]; /* value = value0 + increment*/
// 	fsAMPATH3117[ineur]+=fsAMPATHk23117[ineur];
// 
// 	if (fstim44>0){
// 		  fprintf(input15,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);fflush(input15);}
// 		}
// 	}
// 	 
// 	////////////////////////////////// I --> E ///////////////////////
//    ffspk3=fhreci3[ineur][tminx];
//     
// 
// 
//     fxGABAk13[ineur]=inriseI*taumE*jei*ffspk3-dtriseI*fxGABA3[ineur];
// 	fsGABAk13[ineur]=dtdecayI*(fxGABA3[ineur] - fsGABA3[ineur]);
// 	fsGABArk3[ineur]=fsGABA3[ineur]+0.5*fsGABAk13[ineur];
// 	fxGABAk23[ineur]=inriseI*taumE*jei*ffspk3- dtriseI*(fxGABA3[ineur]+0.5*fxGABAk13[ineur]);
// 	fsGABAk23[ineur]=dtdecayI*((fxGABA3[ineur]+0.5*fxGABAk13[ineur]) - fsGABArk3[ineur]);
// 	fxGABA3[ineur]+=fxGABAk23[ineur];
// 	fsGABA3[ineur]+=fsGABAk23[ineur];
// 
// 	  fIsynk131=0;
// 	  for(int qq=0;qq<numLines13;qq++) {
// 		if(ineur==matrix13[qq][1]){
// 			fIsynk131= fIsynk131+fsAMPATHk1311[ineur];
// 		}}
// 
// 	   
// 	  for(int qq=0;qq<numLines23;qq++) {
// 		if(ineur==matrix23[qq][1]){
// 			fIsynk131= fIsynk131+fsAMPATHk1312[ineur];
// 		}}
// 
// 
// 	    for(int qq=0;qq<numLines33;qq++) {
// 		if(ineur==matrix33[qq][1]){
// 			fIsynk131= fIsynk131+fsAMPATHk1313[ineur];
// 		}}
// 
// 
// 		 for(int qq=0;qq<numLines43;qq++) {
// 		if(ineur==matrix43[qq][1]){
// 			fIsynk131= fIsynk131+fsAMPATHk1314[ineur];
// 		}}
// 		
// 	  
// 		   for(int qq=0;qq<numLines53;qq++) {
// 		if(ineur==matrix53[qq][1]){
// 			fIsynk131= fIsynk131+fsAMPATHk1316[ineur];
// 		}}
// 
// 
// 		    for(int qq=0;qq<numLines63;qq++) {
// 		if(ineur==matrix63[qq][1]){
// 			fIsynk131= fIsynk131+fsAMPATHk1317[ineur];
// 		}}
// 
// 
// 			 for(int qq=0;qq<numLines73;qq++) {
// 		if(ineur==matrix73[qq][1]){
// 			fIsynk131= fIsynk131+fsAMPATHk1318[ineur];
// 		}}
// 
// 
// 			  for(int qq=0;qq<numLines83;qq++) {
// 		if(ineur==matrix83[qq][1]){
// 			fIsynk131= fIsynk131+fsAMPATHk1319[ineur];
// 		}}
// 
// 	  
// 			    for(int qq=0;qq<numLines93;qq++) {
// 		if(ineur==matrix93[qq][1]){
// 			fIsynk131= fIsynk131+fsAMPATHk13111[ineur];
// 		}}
// 
// 
// 				 for(int qq=0;qq<numLines103;qq++) {
// 		if(ineur==matrix103[qq][1]){
// 			fIsynk131= fIsynk131+fsAMPATHk13112[ineur];
// 		}}
// 
// 
// 				  for(int qq=0;qq<numLines113;qq++) {
// 		if(ineur==matrix113[qq][1]){
// 			fIsynk131= fIsynk131+fsAMPATHk13113[ineur];
// 		}}
// 				  
// 
//         fIsynk131=fIsynk131+fsAMPAk13[ineur]-fsGABAk13[ineur]+isAMPATHk1[ineur];
// 				   
// 
// 	// taum(dV/dt)=-V+Vinteractions+Vext
// 
// 	fFE13=inmE*(fIsyn31 - fhi3[ineur]);
// 	fFE23=inmE*((fIsyn31+fIsynk131) - (fhi3[ineur]+dt*fFE13));
// 	fFE3=0.5*dt*(fFE13+fFE23);
// 	fhi3[ineur]+=fFE3;
// 
// 	 
// 	   /****** Is neuron refractory? *******/
// 
// 	   if (ineur<NE1 && ftspki3[ineur]>=0 && (icycle-ftspki3[ineur]<taurpE*sub)) {
// 	fvi3[ineur]=0;
// 	fhi3[ineur]=resetE;
//       }
// 
// 		 /****** Is neuron above threshold? ******/
// 
//      if (fhi3[ineur]>threshold) {fvi3[ineur]=1;}
//       else {fvi3[ineur]=0;}
// 
// 	
// 
// 	if (fvi3[ineur]==1) {
// 
// 	ftspki3[ineur]=icycle;
// 
// 	if(ineur<fNE) {fhi3[ineur]=resetE;}
// 
// 	else {fhi3[ineur]=resetI;}
// 
// 	for(fzz3=0; fzz3<fNcon3[ineur]; fzz3++) {
// 
// 	  fjn3=fA3[fzz3][ineur];
// 
// 	  tminx=(icycle+delaysub)%CYCSIZE;/* spike is arriving after delay */
// 
// 	  if(ineur<fNE){
// 	    fhrece3[fjn3][tminx]++;
// 	  }
// 	  else{
// 	    if (ineur<fNE+fNI){
// 	      fhreci3[fjn3][tminx]++;
// 	   }
// 	}
// 	  }}
// 
// 
// 
// 	  
// 	 
// 
// 	  tminx=icycle%CYCSIZE;
// 	
// 	  fhrece3[ineur][tminx]=0;
//       fhreci3[ineur][tminx]=0;
// 	  
// 
// 
// 	   if (fvi3[ineur]==1 && ineur<NE1){
// 	fprintf(testspiketimesE3, "%.2f %i\n", (float)(icycle)/(float)(sub), ineur);
// 	fflush(testspiketimesE3);
//       }
// 
// 
// 
// 	    nazar4=0;
// 		nazar5=0;
// 		nazar6=0;
// 		nazar7=0;
// 
// 	    for(int hh=0;hh<minimum;hh++) {
// 
// 		   if (ineur==matrix34[hh][1]){
// 			   if ( fvi3[ineur]==1){
// 				   fhrece4++;
// 				   fjee4=fjee4+jee4[nazar4][0];}
// 		   }
// 			       nazar4++;
// 		   }
// 
// 
// 		 for(int hh=0;hh<minimum;hh++) {
// 
// 		   if (ineur==matrix35[hh][1]){
// 			   if ( fvi3[ineur]==1){
// 				   fhrece5++;
// 				   fjee5=fjee5+jee5[nazar5][0];}
// 		   }
// 			       nazar5++;
// 		   }
// 
// 
// 
// 		  for(int hh=0;hh<minimum;hh++) {
// 
// 		   if (ineur==matrix36[hh][1]){
// 			   if ( fvi3[ineur]==1){
// 				   fhrece6++;
// 				   fjee6=fjee6+jee6[nazar6][0];}
// 		   }
// 			       nazar6++;
// 		   }
// 
// 
// 
// 		   for(int hh=0;hh<minimum;hh++) {
// 
// 		   if (ineur==matrix37[hh][1]){
// 			   if ( fvi3[ineur]==1){
// 				   fhrece7++;
// 				   fjee7=fjee7+jee7[nazar7][0];}
// 		   }
// 			       nazar7++;
// 		   }
// 
// 
// 		   if ( fvi3[ineur]==1){
// 			   firing[ineur][0]=1;}
// 
// 
// 	    } // end PY loop on neurons
// 
// ///////////////////////////////////////////////////////////////////////////////////
// 
// 		for(ineur=fNE;ineur<fNE+fNI;ineur++) {
// 
//       tminx=icycle%CYCSIZE;
//       istim=poidev(ifrstim,&idum);
// 
// 
// 	  iIsyn3=fsAMPA3[ineur]-fsGABA3[ineur]+isAMPATH[ineur]+sAMPACC[ineur];
// 	  
// 
// 	 ffspk3=fhrece3[ineur][tminx];
//    
//     fxAMPAk13[ineur]=inriseEI*taumI*(jie*(ffspk3))-dtriseEI*fxAMPA3[ineur];
// 	fsAMPAk13[ineur]=dtdecayEI*(fxAMPA3[ineur] - fsAMPA3[ineur]);
// 	fsAMPArk3[ineur]=fsAMPA3[ineur]+0.5*fsAMPAk13[ineur];
// 	fxAMPAk23[ineur]=inriseEI*taumI*(jie*(ffspk3))- dtriseEI*(fxAMPA3[ineur]+0.5*fxAMPAk13[ineur]);
// 	fsAMPAk23[ineur]=dtdecayEI*((fxAMPA3[ineur]+0.5*fxAMPAk13[ineur]) - fsAMPArk3[ineur]);
// 	fxAMPA3[ineur]+=fxAMPAk23[ineur];
// 	fsAMPA3[ineur]+=fsAMPAk23[ineur];
// 
// 
// 	ixAMPATHk1[ineur]=inriseEE*taumE*(jestim*(istim)) -dtriseEE*ixAMPATH[ineur];
// 	isAMPATHk1[ineur]=dtdecayEE*(ixAMPATH[ineur] - isAMPATH[ineur]);
// 	isAMPATHrk[ineur]=isAMPATH[ineur]+0.5*isAMPATHk1[ineur];
// 	ixAMPATHk2[ineur]=inriseEE*taumE*(jestim*(istim)) - dtriseEE*(ixAMPATH[ineur]+0.5*ixAMPATHk1[ineur]);
// 	isAMPATHk2[ineur]=dtdecayEE*((ixAMPATH[ineur]+0.5*ixAMPATHk1[ineur]) - isAMPATHrk[ineur]); /*increment computed with runge-kutta*/
// 	ixAMPATH[ineur]+=ixAMPATHk2[ineur]; /* value = value0 + increment*/
// 	isAMPATH[ineur]+=isAMPATHk2[ineur];
// 
// 	xAMPACCk1[ineur]=inriseEE*taumE*(jee*(noise)) -dtriseEE*xAMPACC[ineur];
// 	sAMPACCk1[ineur]=dtdecayEE*(xAMPACC[ineur] - sAMPACC[ineur]);
// 	sAMPACCrk[ineur]=sAMPACC[ineur]+0.5*sAMPACCk1[ineur];
// 	xAMPACCk2[ineur]=inriseEE*taumE*(jee*(noise)) - dtriseEE*(xAMPACC[ineur]+0.5*xAMPACCk1[ineur]);
// 	sAMPACCk2[ineur]=dtdecayEE*((xAMPACC[ineur]+0.5*xAMPACCk1[ineur]) - sAMPACCrk[ineur]); /*increment computed with runge-kutta*/
// 	xAMPACC[ineur]+=xAMPACCk2[ineur]; /* value = value0 + increment*/
// 	sAMPACC[ineur]+=sAMPACCk2[ineur];
// 
// 	////////////////////////////////// I --> E ///////////////////////
//    
// 
//    ffspk3=fhreci3[ineur][tminx];
//   
// 
//     fxGABAk13[ineur]=inriseI*taumI*jii*ffspk3-dtriseI*fxGABA3[ineur];
// 	fsGABAk13[ineur]=dtdecayI*(fxGABA3[ineur] - fsGABA3[ineur]);
// 	fsGABArk3[ineur]=fsGABA3[ineur]+0.5*fsGABAk13[ineur];
// 	fxGABAk23[ineur]=inriseI*taumI*jii*ffspk3- dtriseI*(fxGABA3[ineur]+0.5*fxGABAk13[ineur]);
// 	fsGABAk23[ineur]=dtdecayI*((fxGABA3[ineur]+0.5*fxGABAk13[ineur]) - fsGABArk3[ineur]);
// 	fxGABA3[ineur]+=fxGABAk23[ineur];
// 	fsGABA3[ineur]+=fsGABAk23[ineur];
// 
// 
// 	iIsynk13=fsAMPAk13[ineur]-fsGABAk13[ineur]+isAMPATHk1[ineur]+sAMPACCk1[ineur];
// 
// 
// 	// taum(dV/dt)=-V+Vinteractions+Vext
// 
// 	fFI13=inmI*(iIsyn3 - fhi3[ineur]);
// 	fFI23=inmI*((iIsyn3+iIsynk13) - (fhi3[ineur]+dt*fFI13));
// 	fFI3=0.5*dt*(fFI13+fFI23);
// 	fhi3[ineur]+=fFI3;
// 
// 	   /****** Is neuron refractory? *******/
// 
// 	   
// 		 if (ineur>=NE1 && ftspki3[ineur]>=0 && (icycle-ftspki3[ineur]<taurpI*sub)) {
// 	fvi3[ineur]=0;
// 	fhi3[ineur]=resetI;
//       }
// 
// 
// 
// 		 /****** Is neuron above threshold? ******/
// 
//      if (fhi3[ineur]>threshold) {fvi3[ineur]=1;}
//       else {fvi3[ineur]=0;}
// 
// 	
// 
// 	  if (fvi3[ineur]==1) {
// 
// 	ftspki3[ineur]=icycle;
// 
// 	if(ineur<fNE) {fhi3[ineur]=resetE;}
// 
// 	else {fhi3[ineur]=resetI;}
// 
// 	for(fzz3=0; fzz3<fNcon3[ineur]; fzz3++) {
// 
// 	  fjn3=fA3[fzz3][ineur];
// 
// 	  tminx=(icycle+delaysub)%CYCSIZE;/* spike is arriving after delay */
// 
// 	  if(ineur<fNE){
// 	    fhrece3[fjn3][tminx]++;
// 	  }
// 	  else{
// 	    if (ineur<fNE+fNI){
// 	      fhreci3[fjn3][tminx]++;
// 	   }
// 	}}}
// 
// 	  
// 	 
// 
// 	  tminx=icycle%CYCSIZE;
// 	
// 
// 
// 	   fhrece3[ineur][tminx]=0;
//       fhreci3[ineur][tminx]=0;
// 	      
// 
// 	    } // end IN loop on neurons
// 
// ////////////////////////////////////////////////////////////////////////////////////////
// 
// 	
// 	fxAMPAk134=inriseEE*taumE*((fjee4)*(1))-dtriseEE*fxAMPA34;
// 	fsAMPAk134=dtdecayEE*(fxAMPA34- fsAMPA34);
// 	fsAMPArk34=fsAMPA34+0.5*fsAMPAk134;
// 	fxAMPAk234=inriseEE*taumE*((fjee4)*(1))- dtriseEE*(fxAMPA34+0.5*fxAMPAk134);
// 	fsAMPAk234=dtdecayEE*((fxAMPA34+0.5*fxAMPAk134) - fsAMPArk34); 
// 	fxAMPA34+=fxAMPAk234; 
// 	fsAMPA34+=fsAMPAk234;
// 
// 	fxAMPAk135=inriseEE*taumE*((fjee5)*(1))-dtriseEE*fxAMPA35;
// 	fsAMPAk135=dtdecayEE*(fxAMPA35- fsAMPA35);
// 	fsAMPArk35=fsAMPA35+0.5*fsAMPAk135;
// 	fxAMPAk235=inriseEE*taumE*((fjee5)*(1))- dtriseEE*(fxAMPA35+0.5*fxAMPAk135);
// 	fsAMPAk235=dtdecayEE*((fxAMPA35+0.5*fxAMPAk135) - fsAMPArk35); 
// 	fxAMPA35+=fxAMPAk235; 
// 	fsAMPA35+=fsAMPAk235;
// 
// 	fxAMPAk136=inriseEE*taumE*((fjee6)*(1))-dtriseEE*fxAMPA36;
// 	fsAMPAk136=dtdecayEE*(fxAMPA36- fsAMPA36);
// 	fsAMPArk36=fsAMPA36+0.5*fsAMPAk136;
// 	fxAMPAk236=inriseEE*taumE*((fjee6)*(1))- dtriseEE*(fxAMPA36+0.5*fxAMPAk136);
// 	fsAMPAk236=dtdecayEE*((fxAMPA36+0.5*fxAMPAk136) - fsAMPArk36); 
// 	fxAMPA36+=fxAMPAk236; 
// 	fsAMPA36+=fsAMPAk236;
// 
// 
// 	fxAMPAk137=inriseEE*taumE*((fjee7)*(1))-dtriseEE*fxAMPA37;
// 	fsAMPAk137=dtdecayEE*(fxAMPA37- fsAMPA37);
// 	fsAMPArk37=fsAMPA37+0.5*fsAMPAk137;
// 	fxAMPAk237=inriseEE*taumE*((fjee7)*(1))- dtriseEE*(fxAMPA37+0.5*fxAMPAk137);
// 	fsAMPAk237=dtdecayEE*((fxAMPA37+0.5*fxAMPAk137) - fsAMPArk37); 
// 	fxAMPA37+=fxAMPAk237; 
// 	fsAMPA37+=fsAMPAk237;
// 
// 
//       fhrece4=0.;
//       fhreci4=0.;
// 	  fhrece5=0.;
//       fhreci5=0.;
// 	  fhrece6=0.;
//       fhreci6=0.;
// 	  fhrece7=0.;
//       fhreci7=0.;
// 	  fjee4=0;
// 	  fjee5=0;
// 	  fjee6=0;
// 	  fjee7=0;
// 
// 
// 	 fIsyn4=fsAMPA34;
// 	 fIsynk14=fsAMPAk134;
// 
// 	 fIsyn5=fsAMPA35;
// 	 fIsynk15=fsAMPAk135;
// 
// 	 fIsyn6=fsAMPA36;
// 	 fIsynk16=fsAMPAk136;
// 
// 	 fIsyn7=fsAMPA37;
// 	 fIsynk17=fsAMPAk137;
// 
// 
// 
// 	fFE14=inmE*(fIsyn4 - fhi4);
// 	fFE24=inmE*((fIsyn4+fIsynk14) - (fhi4+dt*fFE14));
// 	fFE4=0.5*dt*(fFE14+fFE24);
// 	fhi4+=fFE4;
// 
// 
// 	fFE15=inmE*(fIsyn5 - fhi5);
// 	fFE25=inmE*((fIsyn5+fIsynk15) - (fhi5+dt*fFE15));
// 	fFE5=0.5*dt*(fFE15+fFE25);
// 	fhi5+=fFE5;
// 
// 	fFE16=inmE*(fIsyn6- fhi6);
// 	fFE26=inmE*((fIsyn6+fIsynk16) - (fhi6+dt*fFE16));
// 	fFE6=0.5*dt*(fFE16+fFE26);
// 	fhi6+=fFE6;
// 
// 
// 	fFE17=inmE*(fIsyn7 - fhi7);
// 	fFE27=inmE*((fIsyn7+fIsynk17) - (fhi7+dt*fFE17));
// 	fFE7=0.5*dt*(fFE17+fFE27);
// 	fhi7+=fFE7;
// 
// 
// 	 if (ftspki4>=0 && (icycle-ftspki4<taurpE*sub)) {
// 	fvi4=0;
// 	fhi4=resetE;
//       }
// 
// 
// 		 if (ftspki5>=0 && (icycle-ftspki5<taurpE*sub)) {
// 	fvi5=0;
// 	fhi5=resetE;
//       }
// 
// 		  if (ftspki6>=0 && (icycle-ftspki6<taurpE*sub)) {
// 	fvi6=0;
// 	fhi6=resetE;
//       }
// 
// 		   if (ftspki7>=0 && (icycle-ftspki7<taurpE*sub)) {
// 	fvi7=0;
// 	fhi7=resetE;
//       }
// 	  
// 
// 	  if (fhi4>threshold) {fvi4=1;}
//       else {fvi4=0;}
// 
// 	  if (fhi5>threshold) {fvi5=1;}
//       else {fvi5=0;}
// 
// 	   if (fhi6>threshold) {fvi6=1;}
//       else {fvi6=0;}
// 
// 	   if (fhi7>threshold) {fvi7=1;}
//       else {fvi7=0;}
// 
// 
// 	  if (fvi4==1) {
// 	ftspki4=icycle;
// 	fhi4=resetE;}
// 
// 	  if (fvi5==1) {
// 	ftspki5=icycle;
// 	fhi5=resetE;}
// 
// 	   if (fvi6==1) {
// 	ftspki6=icycle;
// 	fhi6=resetE;}
// 
// 	    if (fvi7==1) {
// 	ftspki7=icycle;
// 	fhi7=resetE;}
// 
// 
// 		if (qq==0){
// 		if (fvi4==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee4[ss][0]=jee4[ss][0]+deltaw1;
// 			}}}
// 
// 		if (fvi4==0 && fvi5==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee5[ss][0]=jee5[ss][0]-deltaw2;
// 				if(jee5[ss][0]<0){
//                  jee5[ss][0]=0;
// 				}
// 			}}}
// 
// 		if (fvi4==0 && fvi6==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee6[ss][0]=jee6[ss][0]-deltaw2;
// 				if(jee6[ss][0]<0){
//                  jee6[ss][0]=0;
// 				}
// 
// 			}}}
// 
// 
// 		if (fvi4==0 && fvi7==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee7[ss][0]=jee7[ss][0]-deltaw2;
// 				if(jee7[ss][0]<0){
//                  jee7[ss][0]=0;
// 				}
// 			}}}
// 		}
// 
// 
// 		if (qq==1){
// 		if (fvi5==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee5[ss][0]=jee5[ss][0]+deltaw1;
// 			}}}
// 
// 		if (fvi5==0 && fvi4==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee4[ss][0]=jee4[ss][0]-deltaw2;
// 				if(jee4[ss][0]<0){
//                  jee4[ss][0]=0;
// 				}
// 			}}}
// 
// 		if (fvi5==0 && fvi6==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee6[ss][0]=jee6[ss][0]-deltaw2;
// 				if(jee6[ss][0]<0){
//                  jee6[ss][0]=0;
// 				}
// 			}}}
// 
// 
// 		if (fvi5==0 && fvi7==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee7[ss][0]=jee7[ss][0]-deltaw2;
// 				if(jee7[ss][0]<0){
//                  jee7[ss][0]=0;
// 				}
// 			}}}
// 		}
// 
// 
// 
// 		if (qq==2){
// 		if (fvi6==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee6[ss][0]=jee6[ss][0]+deltaw1;
// 			}}}
// 
// 		if (fvi6==0 && fvi5==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee5[ss][0]=jee5[ss][0]-deltaw2;
// 				if(jee5[ss][0]<0){
//                  jee5[ss][0]=0;
// 				}
// 			}}}
// 
// 		if (fvi6==0 && fvi4==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee4[ss][0]=jee4[ss][0]-deltaw2;
// 				if(jee4[ss][0]<0){
//                  jee4[ss][0]=0;
// 				}
// 			}}}
// 
// 
// 		if (fvi6==0 && fvi7==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee7[ss][0]=jee7[ss][0]-deltaw2;
// 				if(jee7[ss][0]<0){
//                  jee7[ss][0]=0;
// 				}
// 			}}}
// 		}
// 
// 
// 
// 		if (qq==3){
// 		if (fvi7==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee7[ss][0]=jee7[ss][0]+deltaw1;
// 			}}}
// 
// 		if (fvi7==0 && fvi5==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee5[ss][0]=jee5[ss][0]-deltaw2;
// 				if(jee5[ss][0]<0){
//                  jee5[ss][0]=0;
// 				}
// 			}}}
// 
// 		if (fvi7==0 && fvi6==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee6[ss][0]=jee6[ss][0]-deltaw2;
// 				if(jee6[ss][0]<0){
//                  jee6[ss][0]=0;
// 				}
// 			}}}
// 
// 
// 		if (fvi7==0 && fvi4==1){
// 		for(int ss=0;ss<40;ss++) {
// 			if(firing[ss][0]==1){
// 				jee4[ss][0]=jee4[ss][0]-deltaw2;
// 				if(jee4[ss][0]<0){
//                  jee4[ss][0]=0;
// 				}
// 			}}}
// 		}
// 
// 
// 		for(int sp1=0;sp1<40;sp1++){
// 			for(int sp2=0;sp2<40;sp2++){
// 				if (firing[sp1][0]==1){
// 					if (firing[sp2][0]==1){
// 						hjee[sp1][sp2]=hjee[sp1][sp2]+deltaw3;
// 						if (hjee[sp1][sp2]<0){
// 							hjee[sp1][sp2]=0;
// 						}
// 					}}}}
// 
// 		for(int sp1=0;sp1<40;sp1++){
// 			for(int sp2=0;sp2<40;sp2++){
// 				if (firing[sp1][0]==0){
// 					if (firing[sp2][0]==0){
// 						hjee[sp1][sp2]=hjee[sp1][sp2]-deltaw4;
// 						if (hjee[sp1][sp2]<0){
// 							hjee[sp1][sp2]=0;
// 						}
// 					}}}}
//                          
// 
// 
// 
// 		for(int ss1=0;ss1<40;ss1++){
// 			firing[ss1][0]=0;}
// 		
// 
// 		if (icycle==sub*time-1){
// 	     	fprintf(testspiketimesE3, "%i\n", 123456);
// 		fflush(testspiketimesE3);
// 			fprintf(testspiketimesE4, "%i\n", 123456);
// 			fflush(testspiketimesE4);
// 			fprintf(testspiketimesE5, "%i\n", 123456);
// 			fflush(testspiketimesE5);
// 			fprintf(testspiketimesE6, "%i\n", 123456);
// 			fflush(testspiketimesE6);
// 			fprintf(testspiketimesE7, "%i\n", 123456);
// 			fflush(testspiketimesE7);
//       }
// 
// 
// 	   if (fvi4==1){
// 	fprintf(testspiketimesE4, "%.2f\n", (float)(icycle)/(float)(sub));fflush(testspiketimesE4);
//       }
// 
// 	    if (fvi5==1){
// 	fprintf(testspiketimesE5, "%.2f\n", (float)(icycle)/(float)(sub));fflush(testspiketimesE5);
//       }
// 
// 		 if (fvi6==1){
// 	fprintf(testspiketimesE6, "%.2f\n", (float)(icycle)/(float)(sub));fflush(testspiketimesE6);
//       }
// 
// 		  if (fvi7==1){
// 	fprintf(testspiketimesE7, "%.2f\n", (float)(icycle)/(float)(sub));fflush(testspiketimesE7);
//       }
// 
// 		  for(ipr=0;ipr<NE1;ipr++) {
// 
// 		if(fvi3[ipr]==1) {ffrE3++;}}
// 
// 		if(fvi4==1) {ffrE4++;}
// 		if(fvi5==1) {ffrE5++;}
// 		if(fvi6==1) {ffrE6++;}
// 		if(fvi7==1) {ffrE7++;}
// 
// 	
// 
//   } //end loop on time
//   }//end loop on trail
//   }//end loop on qq
// 
// 
//   
//   for(int ww1=0;ww1<fNE+fNI;ww1++) {
//     for(int ww2=0;ww2<fNE+fNI;ww2++) {
//      fprintf(conect3,"%.3f \n",hjee[ww1][ww2]);
//       fflush(conect3);
//     }}
// 
//   for(int dd4=0;dd4<minimum;dd4++) {
// 	   fprintf(conect4,"%.3f \n",jee4[dd4][0]);
//     fflush(conect4);
//   }
// 
// 
//    for(int dd5=0;dd5<minimum;dd5++) {
// 	   fprintf(conect5,"%.3f \n",jee5[dd5][0]);
//      fflush(conect5);
//   }
// 
// 
//    for(int dd6=0;dd6<minimum;dd6++) {
// 	   fprintf(conect6,"%.3f \n",jee6[dd6][0]);
//      fflush(conect6);
//   }
// 
// 
//    for(int dd7=0;dd7<minimum;dd7++) {
// 	   fprintf(conect7,"%.3f \n",jee7[dd7][0]);
//      fflush(conect7);
//   }
// 
// 
// 
//   fclose(testspiketimesE3);
//   fclose(testspiketimesE4);
//   fclose(testspiketimesE5);
//   fclose(testspiketimesE6);
//   fclose(testspiketimesE7);
// 
//  
//   
//  
//   fclose(input1);
//   fclose(input2);
//   fclose(input3);
//   fclose(input4);
//   fclose(input5);
//   fclose(input6);
//   fclose(input7);
//   fclose(input8);
//   fclose(input9);
//   fclose(input10);
//   fclose(input11);
//   fclose(input12);
//   fclose(input13);
//   fclose(input14);
//   fclose(input15);
//   
//   fclose(conect3);
//   fclose(conect4);
//   fclose(conect5);
//   fclose(conect6);
//   fclose(conect7);
//   
//   //fake look-up table (instead of this we need the real LSM algorithm)
// //   for( it = LSMlut->begin(); it != LSMlut->end(); ++it )
// //   {
// //     for(int i=0;i<rand()%20;i++)
// //     {
// //       brainNode n(rand()%LSMlut->size(),rand()%LSMlut->size(),rand()%1000 );
// //       it->resize(it->size());
// //       it->push_back(n);
// //     }
// //   }  
//   
//   //end of process
//   printf("End of calibration!\n");
// 
// }*/

// /*
// void LSMRunning(int curr_stim, int curr_trial, LSMParameters param, std::vector<std::vector<float> >* outputLayer,dataset bmiData)//,int s, sockaddr_in si_me, sockaddr_in si_other)
// {
//   std::vector<std::vector<float> >::iterator it;
//   
//   //runs LSM and readout the output neuron layer
// //   printf("\nRun in progress...\n");
//   //here there's the LSM code that produce a vector of time stamp for each neuron in the output layer
//   
//   
//   /************* Output file names ***************/
//   
//   // input spike train from input nodes to hidden layer(first column is time of spike train and second column is neuron number that recive spike from input)
//   #define inp1 "input1.txt" 
//   #define inp2 "input2.txt"
//   #define inp3 "input3.txt"
//   #define inp4 "input4.txt"
//   #define inp5 "input5.txt"
//   #define inp6 "input6.txt"
//   #define inp7 "input7.txt"
//   #define inp8 "input8.txt"
//   #define inp9 "input9.txt"
//   #define inp10 "input10.txt"
//   #define inp11 "input11.txt"
//   #define inp12 "input12.txt"
//   #define inp13 "input13.txt"
//   #define inp14 "input14.txt"
//   #define inp15 "input15.txt"
//   
//   // "3" symbols for hidden and "4"-"7" for output neurons
//   //in testspiketimesE3 first column is time of spike and second column is neuron number that have firing activity in hidden layer
//   //in testspiketimesE4-7 first column is time of spike
//   //in testspiketimesE3-7 Separating trials with "123456" phrase 
//   #define testSTE3 "testspiketimesE3.txt"  //output file to show firing activity in hidden layer ("3" is a symbole for hidden layer) 
//   #define testSTE4 "testspiketimesE4.txt"  //output file to show firing activity in the first output neuron("4" is a symbole for the first neuron in the output layer) 
//   #define testSTE5 "testspiketimesE5.txt"  //output file to show firing activity in the second output neuron ("5" is a symbole for the second neuron in the output layer) 
//   #define testSTE6 "testspiketimesE6.txt"  //output file to show firing activity in the third output neuron("6" is a symbole for the third neuron in the output layer) 
//   #define testSTE7 "testspiketimesE7.txt"  //output file to show firing activity in the forth output neuron("7" is a symbole for the forth neuron in output layer)
// 
//   //in connectivity matrix first column is number of input electrode and second column is number of neuron in hidden layer 
//   #define cm13 "cmatrix13.txt"//connectiviry matrix between first input and hidden layer
//   #define cm23 "cmatrix23.txt"//connectiviry matrix between second input and hidden layer
//   #define cm33 "cmatrix33.txt"//connectiviry matrix between third input and hidden layer
//   #define cm43 "cmatrix43.txt"//connectiviry matrix between forth input and hidden layer
//   #define cm53 "cmatrix53.txt"//connectiviry matrix between fifth input and hidden layer
//   #define cm63 "cmatrix63.txt"
//   #define cm73 "cmatrix73.txt"
//   #define cm83 "cmatrix83.txt"
//   #define cm93 "cmatrix93.txt"
//   #define cm103 "cmatrix103.txt"
//   #define cm113 "cmatrix113.txt"
//   #define cm123 "cmatrix123.txt"
//   #define cm133 "cmatrix133.txt"
//   #define cm143 "cmatrix143.txt"
//   #define cm153 "cmatrix153.txt"//connectiviry matrix between Fifteenth input and hidden layer
//   
//   
//   #define cm3 "cmatrix3.txt"//connectiviry matrix in hidden layer(first column and second column are number of neuron in hiden layer)
//   #define cm34 "cmatrix34.txt"//connectiviry matrix between hidden layer and first output(first column is 1(first output) and second column is number of neuron in hidden layer )
//   #define cm35 "cmatrix35.txt"//connectiviry matrix between hidden layer and second output(first column is 2(second output) and second column is number of neuron in hidden layer )
//   #define cm36 "cmatrix36.txt"//connectiviry matrix between hidden layer and third output(first column is 3(third output) and second column is number of neuron in hidden layer )
//   #define cm37 "cmatrix37.txt"//connectiviry matrix between hidden layer and forth output(first column is 4(forth output) and second column is number of neuron in hidden layer )
//   
//   //excitatory weights
//   #define jeee3 "conect3.txt"//weight matrix in hidden layer(Fifty first row are excitatory weights between first neuron in hidden layer and Forty-nine other neurons and ....)
//   #define jeee4 "conect4.txt"//weight matrix between hidden layer and first neuron in output layer(excitatory weights between first neuron in output layer and Forty pyramidal neurons in hidden layer)
//   #define jeee5 "conect5.txt"//weight matrix between hidden layer and second neuron in output layer(excitatory weights between second neuron in output layer and Forty pyramidal neurons in hidden layer)
//   #define jeee6 "conect6.txt"//weight matrix between hidden layer and third neuron in output layer(excitatory weights between third neuron in output layer and Forty pyramidal neurons in hidden layer)
//   #define jeee7 "conect7.txt"//weight matrix between hidden layer and forth neuron in output layer(excitatory weights between forth neuron in output layer and Forty pyramidal neurons in hidden layer)
//   
//   /**************Simulation parameters*****************/
// 
//   float dt=param.dt; // timestep (ms)
//   int  tsimul=param.tsimul; // duration (ms)
// 
// 
//   /****************Synaptic parameters*****************/
// 
//   // times (ms)
// 
//   float delay=param.delay;
//   float taurI=param.taurI; /*rise time of i synaptic currents */
//   float taudI=param.taudI;   /*decay time of i synaptic current*/
// 
//   // E==>E
// 
//   float taurEE=param.taurEE;   /*rise time of e synaptic currents */
//   float taudEE=param.taudEE;    /*decay time of e synaptic current */
// 
//   //E==>I
//   float taurEI=param.taurEI;   /*rise time of e synaptic currents */
//   float taudEI=param.taudEI;    /*decay time of e synaptic current */
// 
//   // connection strengths
// 
//   float jie=param.jie;
//   float jii=param.jii;
//   float jistim=param.jistim;
//   float jei=param.jei;
//   float jee=param.jee;
//   float jestim=param.jestim;
//   float jjestim;
// 
// 
// 
//   /*******basic parameters*****/
//   int NE=param.NE;
//   int NE1=param.NE1;
//   int fNE=param.fNE;
//   int NI=param.NI;
//   int NI1=param.NI1;
//   int fNI=param.fNI;
//   int neurtosave=NE+NI;
//   int fromcortex=param.fromcortex;
//   int fromth=param.fromth;
//   
//   //connectivity between input and hidden layer
//   float connect13 = param.connect13;
//   float connect23 = param.connect23 ;
//   float connect33 = param.connect33 ;
//   float connect43 = param.connect43 ;
//   float connect53 = param.connect53 ;
//   float connect63 = param.connect63 ;
//   float connect73 = param.connect73 ;
//   float connect83 = param.connect83 ;
//   float connect93 = param.connect93 ;
//   float connect103 = param.connect103 ;
//   float connect113 = param.connect113 ;
//   float connect123 = param.connect123 ;
//   float connect133 = param.connect133 ;
//   float connect143 = param.connect143 ;
//   float connect153 = param.connect153 ;
//   //connectivity in hidden layer
//   float connect3 = param.connect3;
//   //connectivity between hidden and output layer
//   float connect34 = param.connect34 ;
//   float connect35 = param.connect35 ;
//   float connect36 = param.connect36 ;
//   float connect37 = param.connect37 ;
//   //Weight gain is defined for train weight between hidden layer and output layer
//   float deltaw1=param.deltaw1;
//   float deltaw2=param.deltaw2;
//   //Weight gain is defined for train in hidden layer
//   float deltaw3=param.deltaw3;
//   float deltaw4=param.deltaw4;
//   /*******basic parameters*****/
//   
//   int LOW =0;
//   int HIGH =1000;
//   int taumE=param.taumE;  
//   int taumI=param.taumI;
//   int taurpI=param.taurpI;
//   int taurpE=param.taurpE;
//   int threshold=param.threshold;
//   int resetE=param.resetE;
//   int resetI=param.resetI;
//   int munoise=param.munoise;
//   float sigmanoise=param.sigmanoise;
//   float lamb=param.lamb;
// 
// 
//   int time = param.tsimul;
//   int trail = param.trial;
//   int electrod = param.electrode-1;
// 
// 
//   /********Stimulus variables**************************************/
// 
//   float frnoise, frspont,frstim1,frstim2,frstim4,frstim5,frstim,base,num,frstim1m,frstim2m,frstim4m,frstim5m,frstimm,ffrstim11,ffrstim12,ffrstim13,ffrstim14,ffrstim15,ffrstim21,ffrstim22,ffrstim23,ffrstim24,ffrstim25,ffrstim31,ffrstim32,ffrstim33,ffrstim34,ffrstim35,ffrstim41,ffrstim42,ffrstim43,ffrstim44,ffrstim45,ifrstim;
//   int stimbin, noisebin,seed,stim1,stim2,stim4,stim5,stim, noise,stim1m,stim2m,stim4m,stim5m,stimm,fstim11,fstim12,fstim13,fstim14,fstim15,fstim21,fstim22,fstim23,fstim24,fstim25,fstim31,fstim32,fstim33,fstim34,fstim35,fstim41,fstim42,fstim44,fstim43,fstim45,istim;
//   double connect12,connect14,connect15,connect24,connect25,connect45;
//   double connect12m,connect14m,connect15m,connect24m,connect25m,connect45m;
//   /*************Output variables*************************/
// 
//   FILE *spiketimesE1m,*spiketimesE2m,*spiketimesE4m,*spiketimesE5m,*conect3,*conect4,*conect5,*conect6,*conect7;
//   float lfpt1m,lfpt2m,lfpt4m,lfpt5m,curreccecc1m,curreccecc3m,curreccecc4m,curreccecc5m,curreccecc6m,curreccecc7m,curreccecc8m,curreccecc9m,curreccecc2m, curreccin1m, curreccin2m, curreccin3m, curreccin4m, curreccin5m, curreccin6m, curreccin7m, curreccin8m, curreccin9m, currinecc1m,currinecc2m,currinecc3m,currinecc4m,currinecc5m,currinecc6m,currinecc7m,currinecc8m,currinecc9m, currinin1m,currinin2m,currinin3m,currinin4m,currinin5m,currinin6m,currinin7m,currinin8m,currinin9m,curreccth1m,curreccth2m,curreccth3m,curreccth4m,curreccth5m,curreccth6m,curreccth7m,curreccth8m,curreccth9m, currecclongm, currinth1m, currinth2m, currinth3m, currinth4m, currinth5m, currinth6m, currinth7m, currinth8m, currinth9m, currinlongm;
// 
//   //randomization variables
// 
//   float accaso;
//   long idum;
//   float xm;
//   float gasdev(long *idum);      /** recipes routine for Gaussian */
//   float ran1(long *idum);       /** recipes routine for uniform deviate */
//   float poidev(float xm, long *idum);        /** recipes routine for Poisson */
// 
//   int i,zz1,zz2,zz4,zz5,zz12,zz14,zz25,zz45,zz1m,zz2m,zz4m,zz5m,zz12m,zz14m,zz25m,zz45m,j,zz15,zz24,zz15m,zz24m; //counters
//   int CYCSIZE, tminx, icycle, sub,delaysub;
//   int ineur,nneur,jn1,jn2,jn4,jn5,jn12,jn14,jn25,jn45,jn1m,jn2m,jn4m,jn5m,jn12m,jn14m,jn25m,jn45m,jn15,jn24,jn15m,jn24m,in,ipr,ip;
//   int vi1[NE+NI],vi2[NE+NI],vi4[NE+NI],vi5[NE+NI],vi1m[NE+NI],vi2m[NE+NI],vi4m[NE+NI],vi5m[NE+NI]; 	/* current firing */
//   int tspki1[NE+NI],tspki2[NE+NI],tspki4[NE+NI],tspki5[NE+NI];/* Time of last spike */ 	/* Time of last spike */
//   int tspki1m[NE+NI],tspki2m[NE+NI],tspki4m[NE+NI],tspki5m[NE+NI];
//   int Ncon1[NE+NI],Ncon2[NE+NI],Ncon12[NE+NI],Ncon4[NE+NI],Ncon45[NE+NI],Ncon25[NE+NI],Ncon5[NE+NI],Ncon14[NE+NI],Ncon15[NE+NI],Ncon24[NE+NI];  /* connection number */
//   int Ncon1m[NE+NI],Ncon2m[NE+NI],Ncon12m[NE+NI],Ncon4m[NE+NI],Ncon45m[NE+NI],Ncon25m[NE+NI],Ncon5m[NE+NI],Ncon14m[NE+NI],Ncon15m[NE+NI],Ncon24m[NE+NI]; 
//   int **A1,**A2,**A12,**A4,**A5,**A25,**A45,**A14,**A15,**A24,**A15m,**A24m,**A1m,**A2m,**A12m,**A4m,**A5m,**A25m,**A45m,**A14m;
//   float **hrece1,**hreci1,**hrece2,**hreci2,**hrece12,**hreci12,**hrece4,**hreci4,**hrece5,**hreci5,**hrece15,**hreci15,**hrece24,**hreci24,**hrece45,**hreci45,**hrece25,**hreci25,**hrece14,**hreci14;
//   float **hrece1m,**hreci1m,**hrece2m,**hreci2m,**hrece12m,**hreci12m,**hrece4m,**hreci4m,**hrece5m,**hreci5m,**hrece15m,**hreci15m,**hrece24m,**hreci24m,**hrece45m,**hreci45m,**hrece25m,**hreci25m,**hrece14m,**hreci14m;
//   float hi1[NE+NI],hi4[NE+NI],hi5[NE+NI],hi2[NE+NI]; /*potentials*/
//   float hi1m[NE+NI],hi4m[NE+NI],hi5m[NE+NI],hi2m[NE+NI]; /*potentials*/
//   
// 
//   int fzz3,fzz5,fzz4,fzz6,fzz7; //counters
//   int fjn3,fjn4,fjn5,fjn6,fjn7;
//   int fvi3[NE1+NI1],fvi4,fvi5,fvi6,fvi7; 	/* current firing */
//   int ftspki3[NE1+NI1],ftspki4,ftspki5,ftspki6,ftspki7;/* Time of last spike */ 	/* Time of last spike */
//   int fNcon3[NE1+NI1];  /* connection number */
//   float **fA3;
//   float fhrece4,fhreci4,fhrece5,fhreci5,fhrece6,fhreci6,fhrece7,fhreci7;
//   float **fhrece3,**fhreci3;
//   float fhi3[NE1+NI1],fhi4,fhi5,fhi6,fhi7; /*potentials*/
// 
//   FILE *cmatrix13,*cmatrix23,*cmatrix33,*cmatrix43,*cmatrix53,*cmatrix63,*cmatrix73,*cmatrix83,*cmatrix93,*cmatrix103,*cmatrix113,*cmatrix123,*cmatrix133,*cmatrix143,*cmatrix153,*cmatrix193,*cmatrix3,*cmatrix34,*cmatrix35,*cmatrix36,*cmatrix37;
//   FILE *testspiketimesE3,*testspiketimesE4,*testspiketimesE5,*testspiketimesE6,*testspiketimesE7;
//   FILE *input1,*input2,*input3,*input4,*input5,*input6,*input7,*input8,*input9,*input10,*input11,*input12,*input13,*input14,*input15,*input19;
//   FILE *inputnetwork1,*inputnetwork2;
// 
//   float fsAMPA3[NE1+NI1], fsAMPAk13[NE1+NI1], fsAMPAk23[NE1+NI1], fsAMPArk3[NE1+NI1];
//   float fxAMPA3[NE1+NI1], fxAMPAk13[NE1+NI1], fxAMPAk23[NE1+NI1], fxAMPArk3[NE1+NI1];
//  
//   
//   float fsAMPA34, fsAMPAk134, fsAMPAk234, fsAMPArk34;
//   float fxAMPA34, fxAMPAk134, fxAMPAk234, fxAMPArk34;
//   float fsAMPA35, fsAMPAk135, fsAMPAk235, fsAMPArk35;
//   float fxAMPA35, fxAMPAk135, fxAMPAk235, fxAMPArk35;
//   float fsAMPA36, fsAMPAk136, fsAMPAk236, fsAMPArk36;
//   float fxAMPA36, fxAMPAk136, fxAMPAk236, fxAMPArk36;
//   float fsAMPA37, fsAMPAk137, fsAMPAk237, fsAMPArk37;
//   float fxAMPA37, fxAMPAk137, fxAMPAk237, fxAMPArk37;
//   
//   float fsAMPATH311[NE1+NI1], fsAMPATHk1311[NE1+NI1], fsAMPATHk2311[NE1+NI1], fsAMPATHrk311[NE1+NI1];
//   float fxAMPATH311[NE1+NI1], fxAMPATHk1311[NE1+NI1], fxAMPATHk2311[NE1+NI1], fxAMPATHrk311[NE1+NI1];
// 
//   float fsAMPATH312[NE1+NI1], fsAMPATHk1312[NE1+NI1], fsAMPATHk2312[NE1+NI1], fsAMPATHrk312[NE1+NI1];
//   float fxAMPATH312[NE1+NI1], fxAMPATHk1312[NE1+NI1], fxAMPATHk2312[NE1+NI1], fxAMPATHrk312[NE1+NI1];
// 
//   float fsAMPATH313[NE1+NI1], fsAMPATHk1313[NE1+NI1], fsAMPATHk2313[NE1+NI1], fsAMPATHrk313[NE1+NI1];
//   float fxAMPATH313[NE1+NI1], fxAMPATHk1313[NE1+NI1], fxAMPATHk2313[NE1+NI1], fxAMPATHrk313[NE1+NI1];
// 
//   float fsAMPATH314[NE1+NI1], fsAMPATHk1314[NE1+NI1], fsAMPATHk2314[NE1+NI1], fsAMPATHrk314[NE1+NI1];
//   float fxAMPATH314[NE1+NI1], fxAMPATHk1314[NE1+NI1], fxAMPATHk2314[NE1+NI1], fxAMPATHrk314[NE1+NI1];
// 
//   float fsAMPATH315[NE1+NI1], fsAMPATHk1315[NE1+NI1], fsAMPATHk2315[NE1+NI1], fsAMPATHrk315[NE1+NI1];
//   float fxAMPATH315[NE1+NI1], fxAMPATHk1315[NE1+NI1], fxAMPATHk2315[NE1+NI1], fxAMPATHrk315[NE1+NI1];
// 
//   float fsAMPATH316[NE1+NI1], fsAMPATHk1316[NE1+NI1], fsAMPATHk2316[NE1+NI1], fsAMPATHrk316[NE1+NI1];
//   float fxAMPATH316[NE1+NI1], fxAMPATHk1316[NE1+NI1], fxAMPATHk2316[NE1+NI1], fxAMPATHrk316[NE1+NI1];
// 
//   float fsAMPATH317[NE1+NI1], fsAMPATHk1317[NE1+NI1], fsAMPATHk2317[NE1+NI1], fsAMPATHrk317[NE1+NI1];
//   float fxAMPATH317[NE1+NI1], fxAMPATHk1317[NE1+NI1], fxAMPATHk2317[NE1+NI1], fxAMPATHrk317[NE1+NI1];
// 
// 
//   float fsAMPATH318[NE1+NI1], fsAMPATHk1318[NE1+NI1], fsAMPATHk2318[NE1+NI1], fsAMPATHrk318[NE1+NI1];
//   float fxAMPATH318[NE1+NI1], fxAMPATHk1318[NE1+NI1], fxAMPATHk2318[NE1+NI1], fxAMPATHrk318[NE1+NI1];
// 
//   float fsAMPATH319[NE1+NI1], fsAMPATHk1319[NE1+NI1], fsAMPATHk2319[NE1+NI1], fsAMPATHrk319[NE1+NI1];
//   float fxAMPATH319[NE1+NI1], fxAMPATHk1319[NE1+NI1], fxAMPATHk2319[NE1+NI1], fxAMPATHrk319[NE1+NI1];
// 
// 
//   float fsAMPATH3110[NE1+NI1], fsAMPATHk13110[NE1+NI1], fsAMPATHk23110[NE1+NI1], fsAMPATHrk3110[NE1+NI1];
//   float fxAMPATH3110[NE1+NI1], fxAMPATHk13110[NE1+NI1], fxAMPATHk23110[NE1+NI1], fxAMPATHrk3110[NE1+NI1];
// 
// 
//   float fsAMPATH3111[NE1+NI1], fsAMPATHk13111[NE1+NI1], fsAMPATHk23111[NE1+NI1], fsAMPATHrk3111[NE1+NI1];
//   float fxAMPATH3111[NE1+NI1], fxAMPATHk13111[NE1+NI1], fxAMPATHk23111[NE1+NI1], fxAMPATHrk3111[NE1+NI1];
// 
//   
//   float fsAMPATH3112[NE1+NI1], fsAMPATHk13112[NE1+NI1], fsAMPATHk23112[NE1+NI1], fsAMPATHrk3112[NE1+NI1];
//   float fxAMPATH3112[NE1+NI1], fxAMPATHk13112[NE1+NI1], fxAMPATHk23112[NE1+NI1], fxAMPATHrk3112[NE1+NI1];
// 
// 
//   float fsAMPATH3113[NE1+NI1], fsAMPATHk13113[NE1+NI1], fsAMPATHk23113[NE1+NI1], fsAMPATHrk3113[NE1+NI1];
//   float fxAMPATH3113[NE1+NI1], fxAMPATHk13113[NE1+NI1], fxAMPATHk23113[NE1+NI1], fxAMPATHrk3113[NE1+NI1];
// 
//   float fsAMPATH3114[NE1+NI1], fsAMPATHk13114[NE1+NI1], fsAMPATHk23114[NE1+NI1], fsAMPATHrk3114[NE1+NI1];
//   float fxAMPATH3114[NE1+NI1], fxAMPATHk13114[NE1+NI1], fxAMPATHk23114[NE1+NI1], fxAMPATHrk3114[NE1+NI1];
// 
//   float fsAMPATH3115[NE1+NI1], fsAMPATHk13115[NE1+NI1], fsAMPATHk23115[NE1+NI1], fsAMPATHrk3115[NE1+NI1];
//   float fxAMPATH3115[NE1+NI1], fxAMPATHk13115[NE1+NI1], fxAMPATHk23115[NE1+NI1], fxAMPATHrk3115[NE1+NI1];
// 
//   float fsAMPATH3116[NE1+NI1], fsAMPATHk13116[NE1+NI1], fsAMPATHk23116[NE1+NI1], fsAMPATHrk3116[NE1+NI1];
//   float fxAMPATH3116[NE1+NI1], fxAMPATHk13116[NE1+NI1], fxAMPATHk23116[NE1+NI1], fxAMPATHrk3116[NE1+NI1];
// 
//   float fsAMPATH3117[NE1+NI1], fsAMPATHk13117[NE1+NI1], fsAMPATHk23117[NE1+NI1], fsAMPATHrk3117[NE1+NI1];
//   float fxAMPATH3117[NE1+NI1], fxAMPATHk13117[NE1+NI1], fxAMPATHk23117[NE1+NI1], fxAMPATHrk3117[NE1+NI1];
// 
//   float isAMPATH[NE1+NI1], isAMPATHk1[NE1+NI1], isAMPATHk2[NE1+NI1], isAMPATHrk[NE1+NI1];
//   float ixAMPATH[NE1+NI1], ixAMPATHk1[NE1+NI1], ixAMPATHk2[NE1+NI1], ixAMPATHrk[NE1+NI1];
// 
//   float fsGABA3[NE1+NI1], fsGABAk13[NE1+NI1], fsGABAk23[NE1+NI1], fsGABArk3[NE1+NI1];
//   float fxGABA3[NE1+NI1], fxGABAk13[NE1+NI1], fxGABAk23[NE1+NI1], fxGABArk3[NE1+NI1];
//   
// 
//   float fsGABA34, fsGABAk134, fsGABAk234, fsGABArk34;
//   float fxGABA34, fxGABAk134, fxGABAk234, fxGABArk34;
//   float fsGABA35, fsGABAk135, fsGABAk235, fsGABArk35;
//   float fxGABA35, fxGABAk135, fxGABAk235, fxGABArk35;
//   float fsGABA36, fsGABAk136, fsGABAk236, fsGABArk36;
//   float fxGABA36, fxGABAk136, fxGABAk236, fxGABArk36;
//   float fsGABA37, fsGABAk137, fsGABAk237, fsGABArk37;
//   float fxGABA37, fxGABAk137, fxGABAk237, fxGABArk37;
// 
//   float iIsyn3,fIsyn31,fIsyn32,fIsyn33,fIsyn34,fIsyn4,fIsyn5,fIsyn6,fIsyn7,iIsynk13,fIsynk131,fIsynk132,fIsynk133,fIsynk134,fIsynk14,fIsynk15,fIsynk16,fIsynk17;
//   float ffspk3,ffspk4,ffspk5,ffspk6,ffspk7;
//   float fFE13, fFE23, fFE3,fFE14, fFE24, fFE4,fFE15, fFE25, fFE5,fFE16, fFE26, fFE6,fFE17, fFE27, fFE7;
//   float fFI13, fFI23,fFI3,fFI14, fFI24,fFI4,fFI15, fFI25,fFI5,fFI16, fFI26,fFI6,fFI17, fFI27,fFI7;
//   int ffrE3,ffrE4,ffrE5,ffrE6,ffrE7;
// 
// 
//   
//   float sAMPACC[NE+NI], sAMPACCk1[NE+NI], sAMPACCk2[NE+NI], sAMPACCrk[NE+NI];
//   float xAMPACC[NE+NI], xAMPACCk1[NE+NI], xAMPACCk2[NE+NI], xAMPACCrk[NE+NI];
// 
//   float **hjee,**hjie,**hjei,**hjii;
//   float **fhjee,**fhjie,**fhjei,**fhjii;
// 
// 
//   float Isyn1,Isyn2,Isyn4,Isyn5,Isynk12,Isynk11,Isynk14,Isynk15;
//   float Isyn12,Isyn14,Isyn15,Isyn24,Isyn25,Isyn45;
//   float Isyn1m,Isyn2m,Isyn4m,Isyn5m,Isynk12m,Isynk11m,Isynk14m,Isynk15m;
//   float Isyn12m,Isyn14m,Isyn15m,Isyn24m,Isyn25m,Isyn45m;
//   float Isynk112,Isynk114,Isynk115,Isynk116,Isynk124,Isynk125,Isynk145;
//   float Isynk112m,Isynk114m,Isynk115m,Isynk124m,Isynk125m,Isynk145m;
//   float inriseI, dtriseI, inriseE, inriseEE, inriseEI, dtriseE, dtriseEE, dtriseEI;
//   float indecayI, dtdecayI, indecayE, indecayEE, indecayEI, dtdecayE, dtdecayEE, dtdecayEI;
//   float inmE, inmI,dtmE, dtmI;
//   float fspk1,fspk2,fspk4,fspk5,fspk12,fspk14,fspk25,fspk45,fspk15,fspk24,fh;
//   float fspk15m,fspk24m,fspk1m,fspk2m,fspk4m,fspk5m,fspk12m,fspk14m,fspk25m,fspk45m;
//   float FE11, FE21, FE1,FE12, FE22, FE2,FE14, FE24, FE4,FE15, FE25, FE5;
//   float FI11, FI21,FI1,FI12, FI22,FI2,FI14, FI24,FI4,FI15, FI25,FI5;
//   int   frE1,frE2,frE4,frE5,frEo11,frEo12,frEo13,frEo14,frEo15,frEo21,frEo22,frEo23,frEo24,frEo25,frEo41,frEo42,frEo43,frEo44,frEo45,frEo51,frEo52,frEo53,frEo54,frEo55,fprE1,fprE2,fprE4,fprE5;
//   float FE11m, FE21m, FE1m,FE12m, FE22m, FE2m,FE14m, FE24m, FE4m,FE15m, FE25m, FE5m;
//   float FI11m, FI21m,FI1m,FI12m, FI22m,FI2m,FI14m, FI24m,FI4m,FI15m, FI25m,FI5m;
//   
//   
//   
//   
// //   call experimental data 
//   
//   short ***inputtest1; 
//   inputtest1=new short**[time]; 
//   for(int i32=0;i32<time; i32++)
//   { 	
//     inputtest1[i32]=new short*[trail]; 
//     for(int j32=0;j32<trail; j32++)
//     { 
//       inputtest1[i32][j32]=new short[electrod]; 
//       for(int k32=0;k32<electrod; k32++)
//       { 
// 	inputtest1[i32][j32][k32]=0;
// 	
//       }    
//     }
//   } 
// 	
// 	
// 	
// //    std::string input_string;
//    for (int i = 0; i <time; i++) 
//    { 
//     for (int k = 0; k <electrod; k++) 
//     { 
//      for (int j = 0; j <trail; j++) 
//      { 
//        if(k<param.ref_electrode-1)
//        {
// 	 inputtest1[i][j][k]=bmiData.data[i][curr_trial][k][curr_stim]; // trnasfering data into 3-D matrix    
// // 	 input_string += (static_cast<ostringstream*>( &(ostringstream() << inputtest1[i][j][k] ) )->str() );
// // 	 input_string += ' ';
//        }
//        else
//        {
// 	 inputtest1[i][j][k]=bmiData.data[i][curr_trial][k+1][curr_stim]; // trnasfering data into 3-D matrix
// // 	 input_string += (static_cast<ostringstream*>( &(ostringstream() << inputtest1[i][j][k] ) )->str() );
// // 	 input_string += ' ';
//        }
// //        cout<<"data ["<<i<<","<<j<<","<<k<<"] loaded ->"<<inputtest1[i][j][k]<<endl;
//      }        
//     }
//    }
//       
//       //transmit input trial
// //     std::string ok_string("OK");
// //     sendUDPString( s,si_other,&input_string);
// //     if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ok_string); 
// 
// //   float ***inputtest1; 
// //   //call experimental data 
// //  if(curr_stim==0)
// //  {
// //   std::fstream file200("inputtest1o.txt", std::ios_base::in); // inputtest"1" means "first" stimulation 
// // 
// // 	  inputtest1=new float**[time]; 
// // 	  for(int i32=0;i32<time; i32++){ 
// // 		  inputtest1[i32]=new float*[trail]; 
// //       for(int j32=0;j32<trail; j32++){ 
// // 		  inputtest1[i32][j32]=new float[electrod]; 
// //       for(int k32=0;k32<electrod; k32++){ 
// // 		  inputtest1[i32][j32][k32]=0;}}} 
// //   
// // for (int k31 = 0; k31 <electrod; k31++) { 
// //     for (int i31 = 0; i31 <time; i31++) { 
// // 	    
// //       for (int j31 = 0; j31 <trail; j31++) { 
// // 		  
// // 	  file200 >> inputtest1[i31][j31][k31]; // trnasfering data into 3-D matrix 
// // 		  
// // 		  }}} 
// //   file200.close();  //
// //   }
// //  else if(curr_stim==1)
// //  {
// //    std::fstream file200("inputtest2o.txt", std::ios_base::in); // inputtest"1" means "first" stimulation 
// // 
// // 	  inputtest1=new float**[time]; 
// // 	  for(int i32=0;i32<time; i32++){ 
// // 		  inputtest1[i32]=new float*[trail]; 
// //       for(int j32=0;j32<trail; j32++){ 
// // 		  inputtest1[i32][j32]=new float[electrod]; 
// //       for(int k32=0;k32<electrod; k32++){ 
// // 		  inputtest1[i32][j32][k32]=0;}}} 
// //   
// //  for (int k31 = 0; k31 <electrod; k31++) { 
// //     for (int i31 = 0; i31 <time; i31++) { 
// // 	   
// //       for (int j31 = 0; j31 <trail; j31++) { 
// // 		  
// // 	  file200 >> inputtest1[i31][j31][k31]; // trnasfering data into 3-D matrix 
// // 		  
// // 		  }}} 
// //   file200.close();  //
// //  }
// //  else if(curr_stim==2)
// //  {
// //    std::fstream file200("inputtest3o.txt", std::ios_base::in); // inputtest"1" means "first" stimulation 
// // 
// // 	  inputtest1=new float**[time]; 
// // 	  for(int i32=0;i32<time; i32++){ 
// // 		  inputtest1[i32]=new float*[trail]; 
// //       for(int j32=0;j32<trail; j32++){ 
// // 		  inputtest1[i32][j32]=new float[electrod]; 
// //       for(int k32=0;k32<electrod; k32++){ 
// // 		  inputtest1[i32][j32][k32]=0;}}} 
// //   
// // for (int k31 = 0; k31 <electrod; k31++) { 
// //     for (int i31 = 0; i31 <time; i31++) { 
// // 	    
// //       for (int j31 = 0; j31 <trail; j31++) { 
// // 		  
// // 	  file200 >> inputtest1[i31][j31][k31]; // trnasfering data into 3-D matrix 
// // 		  
// // 		  }}} 
// //   file200.close();  //
// //  }
// //  else if(curr_stim==3)
// //  {
// //    std::fstream file200("inputtest4o.txt", std::ios_base::in); // inputtest"1" means "first" stimulation 
// //    
// // 	  inputtest1=new float**[time]; 
// // 	  for(int i32=0;i32<time; i32++){ 
// // 		  inputtest1[i32]=new float*[trail]; 
// //       for(int j32=0;j32<trail; j32++){ 
// // 		  inputtest1[i32][j32]=new float[electrod]; 
// //       for(int k32=0;k32<electrod; k32++){ 
// // 		  inputtest1[i32][j32][k32]=0;}}} 
// //   
// // for (int k31 = 0; k31 <electrod; k31++) { 
// //     for (int i31 = 0; i31 <time; i31++) { 
// //       for (int j31 = 0; j31 <trail; j31++) { 
// // 		  
// // 	  file200 >> inputtest1[i31][j31][k31]; // trnasfering data into 3-D matrix 
// // 		  
// // 		  }}} 
// //   file200.close();  //
// //  }
// //  else
// //  {
// //    exit(-1);
// //  }
// // 
// 
//  
// //   srand(seed); //  seed for noise 
//  
//  
//   /*    Output random values. */ 
//  
//   accaso=rand()% (HIGH - LOW + 1) + LOW; 
//  
//   //open output file 
//   testspiketimesE3=fopen(testSTE3, "w"); // "3" symbols for hidden and "4"-"7" for output neurons 
//   testspiketimesE4=fopen(testSTE4, "w"); 
//   testspiketimesE5=fopen(testSTE5, "w"); 
//   testspiketimesE6=fopen(testSTE6, "w"); 
//   testspiketimesE7=fopen(testSTE7, "w"); 
//   input1=fopen(inp1,"w"); 
//   input2=fopen(inp2,"w"); 
//   input3=fopen(inp3,"w"); 
//   input4=fopen(inp4,"w"); 
//   input5=fopen(inp5,"w"); 
//   input6=fopen(inp6,"w"); 
//   input7=fopen(inp7,"w"); 
//   input8=fopen(inp8,"w"); 
//   input9=fopen(inp9,"w"); 
//   input10=fopen(inp10,"w"); 
//   input11=fopen(inp11,"w"); 
//   input12=fopen(inp12,"w"); 
//   input13=fopen(inp13,"w"); 
//   input14=fopen(inp14,"w"); 
//   input15=fopen(inp15,"w"); 
//   
//   CYCSIZE=(int)(delay/dt+1); 
//      
//   nneur=NE1+NI1; //number of neurons in hidden layer 
//  
//   sub=(int)(1./dt+0.01); 
//   delaysub=(int)(delay*sub+0.01); 
//  
//   /*convert to time units */ 
//    dtriseEE=dt/taurEE;  
//    dtriseEI=dt/taurEI; 
//    dtdecayEE=dt/taudEE; 
//    dtdecayEI=dt/taudEI; 
//    dtriseI=dt/taurI; 
//    dtdecayI=dt/taudI; 
//    dtmE=dt/taumE; 
//    dtmI=dt/taumI; 
//  
//    // constant parameters 
//    inriseEE=(1./taurEE);  
//    inriseEI=(1./taurEI); 
//    inmE=(1./taumE); 
//    inriseI=(1./taurI); 
//    inmI=(1./taumI); 
//       
//   idum=idum+accaso; 
//  
//    
// //Memory Allocation  
//  
// 	fhrece3 = new float*[fNE+fNI]; // sum of excitatory synaptic weights 
//  
//    for(i=0;i < fNE+fNI; i++){ 
//      
// 	fhrece3[i] = new float[CYCSIZE]; 
//  
//    } 
//  
//     
//    
//   fhreci3 = new float*[fNE+fNI]; // sum of inhibitory synaptic weights 
//  
//   for(i=0;i < fNE+fNI; i++){ 
//      
//     fhreci3[i] = new float[CYCSIZE]; 
//   } 
//  
//  
//   fhjee = new float*[fNE+fNI];  // "h" stands for " hidden" layer 
//    
//    for(i=0;i < fNE+fNI; i++){ 
//      
// 	fhjee[i] = new float[CYCSIZE]; 
//  
//    } 
//  
//  
//    fhjei = new float*[fNE+fNI]; 
//  
//    for(i=0;i < fNE+fNI; i++){ 
//      
// 	fhjei[i] = new float[CYCSIZE]; 
//  
//    } 
//    
//  
//  
//    fhjii = new float*[fNE+fNI]; 
//  
//    for(i=0;i < fNE+fNI; i++){ 
//      
// 	fhjii[i] = new float[CYCSIZE]; 
//  
//    } 
//  
//  
//    fhjie = new float*[fNE+fNI]; 
//  
//    for(i=0;i < fNE+fNI; i++){ 
//      
// 	fhjie[i] = new float[CYCSIZE]; 
//  
//    } 
//  
//  
//  
//    
//   fA3 = new float*[fNE+fNI]; 
//   
//  
//   for(i=0;i < fNE+fNI; i++){ 
//      
// 	  fA3[i] = new float[fNE+fNI]; 
// 	 
//   } 
//  
//  
//   hjee = new float*[fNE+fNI]; 
//   
//  
//   for(i=0;i < fNE+fNI; i++){ 
//      
// 	  hjee[i] = new float[fNE+fNI]; 
// 	 
//   } 
//  
//  
//   hjei = new float*[fNE+fNI]; 
//   
//  
//   for(i=0;i < fNE+fNI; i++){ 
//      
// 	  hjei[i] = new float[fNE+fNI]; 
// 	 
//   } 
//  
//  
//  
//   hjie = new float*[fNE+fNI]; 
//   
//  
//   for(i=0;i < fNE+fNI; i++){ 
//      
// 	  hjie[i] = new float[fNE+fNI]; 
// 	 
//   } 
//  
//  
//   hjii = new float*[fNE+fNI]; 
//   
//  
//   for(i=0;i < fNE+fNI; i++){ 
//      
// 	  hjii[i] = new float[fNE+fNI]; 
// 	 
//   } 
//  
// //initial conditions 
//  
//   for(in=0;in<fNE+fNI;in++) { 
//     for(ip=0;ip<CYCSIZE;ip++) { 
//        
//       fhrece3[in][ip]=0.; 
// 	  fhjee[in][ip]=0.; 
// 	  fhjei[in][ip]=0.; 
// 	  fhjii[in][ip]=0.; 
// 	  fhjie[in][ip]=0.; 
// 	  fhreci3[in][ip]=0.; 
// 	} 
// 	fhi3[in]=0.; 
// 	} 
//  
// 	  fhrece4=0.; 
//       fhreci4=0.; 
// 	  fhrece5=0.; 
//       fhreci5=0.; 
// 	  fhrece6=0.; 
//       fhreci6=0.; 
// 	  fhrece7=0.; 
//       fhreci7=0.; 
// 	 
// 	 
// 	fhi4=0.; 
//     fhi5=0.; 
// 	fhi6=0.; 
// 	fhi7=0.; 
//  
// 	ftspki4=-1; 
// 	ftspki5=-1; 
// 	ftspki6=-1; 
// 	ftspki7=-1; 
// 	  
// 	jjestim=param.jjestim;   
//  
// 	 for (in=0; in<fNE+fNI; in++){ 
//  
//     ftspki3[in]=-1; 
//     
//     fxAMPA3[in]=0; 
// 	fxAMPAk13[in]=0; 
// 	fxAMPAk23[in]=0; 
// 	fxAMPArk3[in]=0; 
// 	 
// 	 
//  
//     fsAMPA3[in]=0; 
// 	fsAMPAk13[in]=0; 
// 	fsAMPAk23[in]=0; 
// 	fsAMPArk3[in]=0; 
// 	 
// 	 
//  
//     fsAMPATH311[in]=0; 
//     fxAMPATH311[in]=0; 
// 	fsAMPATHk1311[in]=0; 
//     fxAMPATHk1311[in]=0; 
// 	fsAMPATHk2311[in]=0; 
//     fxAMPATHk2311[in]=0; 
// 	fsAMPATHrk311[in]=0; 
//     fxAMPATHrk311[in]=0; 
//  
// 	fsAMPATH312[in]=0; 
//     fxAMPATH312[in]=0; 
// 	fsAMPATHk1312[in]=0; 
//     fxAMPATHk1312[in]=0; 
// 	fsAMPATHk2312[in]=0; 
//     fxAMPATHk2312[in]=0; 
// 	fsAMPATHrk312[in]=0; 
//     fxAMPATHrk312[in]=0; 
//  
// 	fsAMPATH313[in]=0; 
//     fxAMPATH313[in]=0; 
// 	fsAMPATHk1313[in]=0; 
//     fxAMPATHk1313[in]=0; 
// 	fsAMPATHk2313[in]=0; 
//     fxAMPATHk2313[in]=0; 
// 	fsAMPATHrk313[in]=0; 
//     fxAMPATHrk313[in]=0; 
//  
// 	fsAMPATH314[in]=0; 
//     fxAMPATH314[in]=0; 
// 	fsAMPATHk1314[in]=0; 
//     fxAMPATHk1314[in]=0; 
// 	fsAMPATHk2314[in]=0; 
//     fxAMPATHk2314[in]=0; 
// 	fsAMPATHrk314[in]=0; 
//     fxAMPATHrk314[in]=0; 
//  
// 	fsAMPATH315[in]=0; 
//     fxAMPATH315[in]=0; 
// 	fsAMPATHk1315[in]=0; 
//     fxAMPATHk1315[in]=0; 
// 	fsAMPATHk2315[in]=0; 
//     fxAMPATHk2315[in]=0; 
// 	fsAMPATHrk315[in]=0; 
//     fxAMPATHrk315[in]=0; 
// 	 
// 	fsAMPATH316[in]=0; 
//     fxAMPATH316[in]=0; 
// 	fsAMPATHk1316[in]=0; 
//     fxAMPATHk1316[in]=0; 
// 	fsAMPATHk2316[in]=0; 
//     fxAMPATHk2316[in]=0; 
// 	fsAMPATHrk316[in]=0; 
//     fxAMPATHrk316[in]=0; 
//  
// 	fsAMPATH317[in]=0; 
//     fxAMPATH317[in]=0; 
// 	fsAMPATHk1317[in]=0; 
//     fxAMPATHk1317[in]=0; 
// 	fsAMPATHk2317[in]=0; 
//     fxAMPATHk2317[in]=0; 
// 	fsAMPATHrk317[in]=0; 
//     fxAMPATHrk317[in]=0; 
//  
// 	fsAMPATH318[in]=0; 
//     fxAMPATH318[in]=0; 
// 	fsAMPATHk1318[in]=0; 
//     fxAMPATHk1318[in]=0; 
// 	fsAMPATHk2318[in]=0; 
//     fxAMPATHk2318[in]=0; 
// 	fsAMPATHrk318[in]=0; 
//     fxAMPATHrk318[in]=0; 
//  
// 	fsAMPATH319[in]=0; 
//     fxAMPATH319[in]=0; 
// 	fsAMPATHk1319[in]=0; 
//     fxAMPATHk1319[in]=0; 
// 	fsAMPATHk2319[in]=0; 
//     fxAMPATHk2319[in]=0; 
// 	fsAMPATHrk319[in]=0; 
//     fxAMPATHrk319[in]=0; 
// 	 
// 	fsAMPATH3110[in]=0; 
//     fxAMPATH3110[in]=0; 
// 	fsAMPATHk13110[in]=0; 
//     fxAMPATHk13110[in]=0; 
// 	fsAMPATHk23110[in]=0; 
//     fxAMPATHk23110[in]=0; 
// 	fsAMPATHrk3110[in]=0; 
//     fxAMPATHrk3110[in]=0; 
// 	 
// 	fsAMPATH3111[in]=0; 
//     fxAMPATH3111[in]=0; 
// 	fsAMPATHk13111[in]=0; 
//     fxAMPATHk13111[in]=0; 
// 	fsAMPATHk23111[in]=0; 
//     fxAMPATHk23111[in]=0; 
// 	fsAMPATHrk3111[in]=0; 
//     fxAMPATHrk3111[in]=0; 
// 	 
// 	fsAMPATH3112[in]=0; 
//     fxAMPATH3112[in]=0; 
// 	fsAMPATHk13112[in]=0; 
//     fxAMPATHk13112[in]=0; 
// 	fsAMPATHk23112[in]=0; 
//     fxAMPATHk23112[in]=0; 
// 	fsAMPATHrk3112[in]=0; 
//     fxAMPATHrk3112[in]=0; 
//  
//  
// 	fsAMPATH3113[in]=0; 
//     fxAMPATH3113[in]=0; 
// 	fsAMPATHk13113[in]=0; 
//     fxAMPATHk13113[in]=0; 
// 	fsAMPATHk23113[in]=0; 
//     fxAMPATHk23113[in]=0; 
// 	fsAMPATHrk3113[in]=0; 
//     fxAMPATHrk3113[in]=0; 
// 	 
// 	fsAMPATH3114[in]=0; 
//     fxAMPATH3114[in]=0; 
// 	fsAMPATHk13114[in]=0; 
//     fxAMPATHk13114[in]=0; 
// 	fsAMPATHk23114[in]=0; 
//     fxAMPATHk23114[in]=0; 
// 	fsAMPATHrk3114[in]=0; 
//     fxAMPATHrk3114[in]=0; 
//  
// 	fsAMPATH3115[in]=0; 
//     fxAMPATH3115[in]=0; 
// 	fsAMPATHk13115[in]=0; 
//     fxAMPATHk13115[in]=0; 
// 	fsAMPATHk23115[in]=0; 
//     fxAMPATHk23115[in]=0; 
// 	fsAMPATHrk3115[in]=0; 
//     fxAMPATHrk3115[in]=0; 
//  
// 	fsAMPATH3116[in]=0; 
//     fxAMPATH3116[in]=0; 
// 	fsAMPATHk13116[in]=0; 
//     fxAMPATHk13116[in]=0; 
// 	fsAMPATHk23116[in]=0; 
//     fxAMPATHk23116[in]=0; 
// 	fsAMPATHrk3116[in]=0; 
//     fxAMPATHrk3116[in]=0; 
// 	 
// 	fsAMPATH3117[in]=0; 
//     fxAMPATH3117[in]=0; 
// 	fsAMPATHk13117[in]=0; 
//     fxAMPATHk13117[in]=0; 
// 	fsAMPATHk23117[in]=0; 
//     fxAMPATHk23117[in]=0; 
// 	fsAMPATHrk3117[in]=0; 
//     fxAMPATHrk3117[in]=0; 
//  
// 	isAMPATH[in]=0; 
//     ixAMPATH[in]=0; 
// 	isAMPATHk1[in]=0; 
//     ixAMPATHk1[in]=0; 
// 	isAMPATHk2[in]=0; 
//     ixAMPATHk2[in]=0; 
// 	isAMPATHrk[in]=0; 
//     ixAMPATHrk[in]=0; 
// 	 
//  
// 	xAMPACC[in]=0; 
// 	xAMPACCk1[in]=0; 
// 	xAMPACCk2[in]=0; 
// 	xAMPACCrk[in]=0; 
//     sAMPACC[in]=0; 
// 	sAMPACCk1[in]=0; 
// 	sAMPACCk2[in]=0; 
// 	sAMPACCrk[in]=0; 
//  
//     fxGABA3[in]=0; 
// 	fxGABAk13[in]=0; 
// 	fxGABAk23[in]=0; 
// 	fxGABArk3[in]=0; 
// 	 
//  
//     fsGABA3[in]=0; 
// 	fsGABAk13[in]=0; 
// 	fsGABAk23[in]=0; 
// 	fsGABArk3[in]=0; 
// 	 
// 	 } 
//  
// 	fxAMPA34=0; 
// 	fxAMPA35=0; 
// 	fxAMPAk134=0; 
// 	fxAMPAk135=0; 
// 	fxAMPAk234=0; 
// 	fxAMPAk235=0; 
// 	fxAMPArk34=0; 
// 	fxAMPArk35=0; 
//  
// 	fsAMPA34=0; 
// 	fsAMPA35=0; 
// 	fsAMPAk134=0; 
// 	fsAMPAk135=0; 
// 	fsAMPAk234=0; 
// 	fsAMPAk235=0; 
// 	fsAMPArk34=0; 
// 	fsAMPArk35=0; 
//  
// 	fxGABA34=0; 
// 	fxGABA35=0; 
// 	fxGABAk134=0; 
// 	fsGABAk134=0; 
// 	fxGABAk135=0; 
// 	fsGABAk135=0; 
// 	fxGABAk234=0; 
// 	fsGABAk234=0; 
// 	fxGABAk235=0; 
// 	fsGABAk235=0; 
// 	fxGABArk34=0; 
// 	fsGABArk34=0; 
// 	fxGABArk35=0; 
// 	fsGABArk35=0; 
// 	 
// 	fsGABA34=0; 
// 	fsGABA35=0; 
//  
//  
// 	fxAMPA36=0; 
// 	fxAMPA37=0; 
// 	fxAMPAk136=0; 
// 	fxAMPAk137=0; 
// 	fxAMPAk236=0; 
// 	fxAMPAk237=0; 
// 	fxAMPArk36=0; 
// 	fxAMPArk37=0; 
//  
// 	fsAMPA36=0; 
// 	fsAMPA37=0; 
// 	fsAMPAk136=0; 
// 	fsAMPAk137=0; 
// 	fsAMPAk236=0; 
// 	fsAMPAk237=0; 
// 	fsAMPArk36=0; 
// 	fsAMPArk37=0; 
//  
// 	fxGABA36=0; 
// 	fxGABA37=0; 
// 	fxGABAk136=0; 
// 	fsGABAk136=0; 
// 	fxGABAk137=0; 
// 	fsGABAk137=0; 
// 	fxGABAk236=0; 
// 	fsGABAk236=0; 
// 	fxGABAk237=0; 
// 	fsGABAk237=0; 
// 	fxGABArk36=0; 
// 	fsGABArk36=0; 
// 	fxGABArk37=0; 
// 	fsGABArk37=0; 
// 	 
// 	fsGABA36=0; 
// 	fsGABA37=0; 
//  
//  
//  
//     iIsyn3=0; 
// 	fIsyn31=0; 
// 	fIsyn32=0; 
// 	fIsyn33=0; 
// 	fIsyn34=0; 
//     fIsyn4=0; 
// 	fIsyn5=0; 
// 	fIsyn6=0; 
// 	fIsyn7=0; 
// 	 
//  
//     iIsynk13=0; 
// 	fIsynk131=0; 
// 	fIsynk132=0; 
// 	fIsynk133=0; 
// 	fIsynk134=0; 
//     fIsynk14=0; 
// 	fIsynk15=0; 
// 	fIsynk16=0; 
// 	fIsynk17=0; 
//  
//  
// 	for(j=0;j< fNE+fNI;j++) { 
//      
//     fNcon3[j]=0; 
//      
//   } 
//  
//  
//   for(i=0;i<fNE+fNI;i++){ 
//  
//     for(j=0;j<fNE+fNI;j++){ 
//  
// 		fA3[i][j]=0; 
// 		hjee[i][j]=0; 
// 		hjei[i][j]=0; 
// 		hjie[i][j]=0; 
// 		hjii[i][j]=0; 
//  
// 	}} 
//  
//  
// //initialization weight matrix of the hidden layer 
//   
//   for(i=0;i<fNE+fNI;i++){ 
//  
//     for(j=0;j<fNE+fNI;j++){ 
//  
//       if(ran1(&idum)< connect3) { 
//  
// 	fA3[fNcon3[j]][j]=i; 
// 	if (i<fNE && j<fNE){ 
// 		hjee[fNcon3[j]][j]=jee;} 
// 	if (i>fNE && j<fNE){ 
// 		hjei[fNcon3[j]][j]=jei;} 
// 	if (i<fNE && j>fNE){ 
// 		hjie[fNcon3[j]][j]=jie;} 
// 	if (i>fNE && j>fNE){ 
// 		hjii[fNcon3[j]][j]=jii;} 
// 	fNcon3[j]++; 
// 	  }}} 
//  
//   //cout<<"parameters initilized"<<endl;
//  
// // the number of connection between hidden and output layer   
// // "4"-"7" symboles for output neuron and "3" for hidden layer 
//  
// int numLines34 = 0; 
// ifstream in50("cmatrix34.txt"); 
// std::string unused; 
// while ( std::getline(in50, unused) ){ 
// 	++numLines34;} 
//  
// int numLines35 = 0; 
// ifstream in60("cmatrix35.txt"); 
// std::string unused2; 
// while ( std::getline(in60, unused2) ){ 
// 	++numLines35;} 
//  
// int numLines36 = 0; 
// ifstream in30("cmatrix36.txt"); 
// std::string unused3; 
// while ( std::getline(in30, unused3) ){ 
// 	++numLines36;} 
//  
//  
// int numLines37 = 0; 
// ifstream in40("cmatrix37.txt"); 
// std::string unused4; 
// while ( std::getline(in40, unused4) ){ 
// 	++numLines37;} 
//  
//  
// int result[4][1];  // define a 2D array  
// result[0][0]=numLines34; 
// result[1][0]=numLines35; 
// result[2][0]=numLines36; 
// result[3][0]=numLines37; 
//  
// //connecting all 40 pyramidals in hidden layer to the all 4 output neurons 
//  
// int minimum=result[0][0]; 
// for (int yy=0;yy<4;yy++){ 
// 	if (result[yy][0]<minimum){ 
// 		minimum=result[yy][0];}} 
//  
//  
//  
//   float **matrix34; 
// 	matrix34 = new float*[minimum]; 
//   for(int i30=0;i30 <minimum; i30++){ 
//     matrix34 [i30] = new float[2];} 
//  
//  
//   float **matrix35; 
// 	matrix35 = new float*[minimum]; 
//   for(int i30=0;i30 <minimum; i30++){ 
//     matrix35 [i30] = new float[2];} 
//  
//   float **matrix36; 
// 	matrix36 = new float*[minimum]; 
//   for(int i30=0;i30 <minimum; i30++){ 
//     matrix36 [i30] = new float[2];} 
//  
//  
//   float **matrix37; 
// 	matrix37 = new float*[minimum]; 
//   for(int i30=0;i30 <minimum; i30++){ 
//     matrix37 [i30] = new float[2];} 
// ////////////////////////////////////////////// 
//  
// //Making connectivity matrix for output layer  
// // "cmatrixAB.txt" was already created when the netword was trained 
//  
//  
//   std::fstream file1("cmatrix34.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <minimum; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file1>> matrix34[i31][j31]; 
// 	 
// 	}} 
// file1.close(); 
//  
//  
// std::fstream file2("cmatrix35.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <minimum; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file2>> matrix35[i31][j31]; 
// 		 
// 	}} 
// file2.close(); 
//  
//  
// std::fstream file3("cmatrix36.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <minimum; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file3>> matrix36[i31][j31]; 
// 	 
// 	}} 
// file3.close(); 
//  
//  
// std::fstream file4("cmatrix37.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <minimum; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file4>> matrix37[i31][j31]; 
// 	 
// 	}} 
// file4.close(); 
//  
//   //cout<<"output connectivity matrix imported"<<endl;
// ////////////////////////////////////////////////////////////// 
//  
// // connecting input nodes to hidden layer (only pyramidals). 
// // finding the number of connections by "getline" command 
//  
// 	int numLines13 = 0; 
// ifstream in5("cmatrix13.txt"); 
// std::string unused5; 
// while ( std::getline(in5, unused5) ){ 
// 	++numLines13;} 
//  
// int numLines23 = 0; 
// ifstream in6("cmatrix23.txt"); 
// std::string unused6; 
// while ( std::getline(in6, unused6) ){ 
// 	++numLines23;} 
//  
// int numLines33 = 0; 
// ifstream in7("cmatrix33.txt"); 
// std::string unused7; 
// while ( std::getline(in7, unused7) ){ 
// 	++numLines33;} 
//  
//  
// int numLines43 = 0; 
// ifstream in8("cmatrix43.txt"); 
// std::string unused8; 
// while ( std::getline(in8, unused8) ){ 
// 	++numLines43;} 
//  
// int numLines53 = 0; 
// ifstream in9("cmatrix53.txt"); 
// std::string unused9; 
// while ( std::getline(in9, unused9) ){ 
// 	++numLines53;} 
// 	 
//  
// int numLines63 = 0; 
// ifstream in10("cmatrix63.txt"); 
// std::string unused10; 
// while ( std::getline(in10, unused10) ){ 
// 	++numLines63;} 
//  
//  
// int numLines73 = 0; 
// ifstream in11("cmatrix73.txt"); 
// std::string unused11; 
// while ( std::getline(in11, unused11) ){ 
// 	++numLines73;} 
//  
//  
// int numLines83 = 0; 
// ifstream in12("cmatrix83.txt"); 
// std::string unused12; 
// while ( std::getline(in12, unused12) ){ 
// 	++numLines83;} 
//  
//  
// int numLines93 = 0; 
// ifstream in13("cmatrix93.txt"); 
// std::string unused13; 
// while ( std::getline(in13, unused13) ){ 
// 	++numLines93;} 
//  
//  
// int numLines103 = 0; 
// ifstream in14("cmatrix103.txt"); 
// std::string unused14; 
// while ( std::getline(in14, unused14) ){ 
// 	++numLines103;} 
// 	 
//  
// int numLines113 = 0; 
// ifstream in15("cmatrix113.txt"); 
// std::string unused15; 
// while ( std::getline(in15, unused15) ){ 
// 	++numLines113;} 
//  
// int numLines123 = 0; 
// ifstream in215("cmatrix123.txt"); 
// std::string unused215; 
// while ( std::getline(in215, unused215) ){ 
// 	++numLines123;} 
//  
//  
// int numLines133 = 0; 
// ifstream in315("cmatrix133.txt"); 
// std::string unused315; 
// while ( std::getline(in315, unused315) ){ 
// 	++numLines133;} 
//  
// int numLines143 = 0; 
// ifstream in415("cmatrix143.txt"); 
// std::string unused415; 
// while ( std::getline(in415, unused415) ){ 
// 	++numLines143;} 
//  
// int numLines153 = 0; 
// ifstream in515("cmatrix153.txt"); 
// std::string unused515; 
// while ( std::getline(in515, unused515) ){ 
// 	++numLines153;} 
//  
// 
// //////////////////////////////////////////////////////////// 
//  
// int result2[11][1]; 
// result2[0][0]=numLines13; 
// result2[1][0]=numLines23; 
// result2[2][0]=numLines33; 
// result2[3][0]=numLines43; 
// result2[4][0]=numLines53; 
// result2[5][0]=numLines63; 
// result2[6][0]=numLines73; 
// result2[7][0]=numLines83; 
// result2[8][0]=numLines93; 
// result2[9][0]=numLines103; 
// result2[10][0]=numLines113; 
// result2[11][0]=numLines123; 
// result2[12][0]=numLines133; 
// result2[13][0]=numLines143; 
// result2[14][0]=numLines153; 
//  
//  
// int minimum2=result2[0][0]; 
// for (int yy=0;yy<15;yy++){ 
// 	if (result2[yy][0]<minimum2){ 
// 		minimum2=result2[yy][0];}} 
//  
//   float **matrix13; 
// 	matrix13 = new float*[numLines13]; 
//   for(int i30=0;i30 <numLines13; i30++){ 
//     matrix13 [i30] = new float[2];} 
//  
//  
//   float **matrix23; 
// 	matrix23 = new float*[numLines23]; 
//   for(int i30=0;i30 <numLines23; i30++){ 
//     matrix23 [i30] = new float[2];} 
//  
//   float **matrix33; 
// 	matrix33 = new float*[numLines33]; 
//   for(int i30=0;i30 <numLines33; i30++){ 
//     matrix33 [i30] = new float[2];} 
//  
//  
//   float **matrix43; 
// 	matrix43= new float*[numLines43]; 
//   for(int i30=0;i30 <numLines43; i30++){ 
//     matrix43 [i30] = new float[2];} 
//  
//    
//   float **matrix53; 
// 	matrix53 = new float*[numLines53]; 
//   for(int i30=0;i30 <numLines53; i30++){ 
//     matrix53 [i30] = new float[2];} 
// 	 
//  
//   float **matrix63; 
// 	matrix63 = new float*[numLines63]; 
//   for(int i30=0;i30 <numLines63; i30++){ 
//     matrix63 [i30] = new float[2];} 
//  
//   float **matrix73; 
// 	matrix73 = new float*[numLines73]; 
//   for(int i30=0;i30 <numLines73; i30++){ 
//     matrix73 [i30] = new float[2];} 
//  
//   float **matrix83; 
// 	matrix83 = new float*[numLines83]; 
//   for(int i30=0;i30 <numLines83; i30++){ 
//     matrix83 [i30] = new float[2];} 
//  
//   float **matrix93; 
// 	matrix93 = new float*[numLines93]; 
//   for(int i30=0;i30 <numLines93; i30++){ 
//     matrix93 [i30] = new float[2];} 
//    
//   float **matrix103; 
// 	matrix103 = new float*[numLines103]; 
//   for(int i30=0;i30 <numLines103; i30++){ 
//     matrix103 [i30] = new float[2];} 
// 	 
//  
//   float **matrix113; 
// 	matrix113 = new float*[numLines113]; 
//   for(int i30=0;i30 <numLines113; i30++){ 
//     matrix113 [i30] = new float[2];} 
//    
//   float **matrix123; 
// 	matrix123 = new float*[numLines123]; 
//   for(int i30=0;i30 <numLines123; i30++){ 
//     matrix123 [i30] = new float[2];} 
//  
//   float **matrix133; 
// 	matrix133 = new float*[numLines133]; 
//   for(int i30=0;i30 <numLines133; i30++){ 
//     matrix133 [i30] = new float[2];} 
//  
//   float **matrix143; 
// 	matrix143 = new float*[numLines143]; 
//   for(int i30=0;i30 <numLines143; i30++){ 
//     matrix143 [i30] = new float[2];} 
//    
//   float **matrix153; 
// 	matrix153 = new float*[numLines153]; 
//   for(int i30=0;i30 <numLines153; i30++){ 
//     matrix153 [i30] = new float[2];} 
//  
// //////////////////////////////////////////////////////////// 
//  
//  // connecting input nodes to hidden layer (only pyramidals). 
//  // creating a 2-D matrix of connectivity 
//  // "cmatrixA3.txt" was already created to connect the A-th input to the payramidas in the hidden layer when the network was trained. 
//  
//   std::fstream file5("cmatrix13.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines13; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file5>> matrix13[i31][j31]; 
// 	 
// 	}} 
// file5.close(); 
//  
//  
// std::fstream file6("cmatrix23.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines23; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file6>> matrix23[i31][j31]; 
// 		 
// 	}} 
// file6.close(); 
//  
//  
// std::fstream file7("cmatrix33.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines33; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file7>> matrix33[i31][j31]; 
// 	 
// 	}} 
// file7.close(); 
//  
//  
// std::fstream file8("cmatrix43.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines43; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file8>> matrix43[i31][j31]; 
// 	 
// 	}} 
// file8.close(); 
//  
//  
//  std::fstream file9("cmatrix53.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines53; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file9>> matrix53[i31][j31]; 
// 	 
// 	}} 
// file9.close(); 
//  
//  
//  std::fstream file10("cmatrix63.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines63; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file10>> matrix63[i31][j31]; 
// 	 
// 	}} 
// file10.close(); 
//  
//  
//  std::fstream file11("cmatrix73.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines73; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file11>> matrix73[i31][j31]; 
// 	 
// 	}} 
// file11.close(); 
//  
//  
//  std::fstream file12("cmatrix83.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines83; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file12>> matrix83[i31][j31]; 
// 	 
// 	}} 
// file12.close(); 
//  
//  
//  std::fstream file13("cmatrix93.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines93; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file13>> matrix93[i31][j31]; 
// 	 
// 	}} 
// file13.close(); 
//  
//  
//  std::fstream file14("cmatrix103.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines103; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file14>> matrix103[i31][j31]; 
// 	 
// 	}} 
// file14.close(); 
//  
//  
//  std::fstream file15("cmatrix113.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines113; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file15>> matrix113[i31][j31]; 
// 	 
// 	}} 
// file15.close(); 
//  
// std::fstream file165("cmatrix123.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines123; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file165>> matrix123[i31][j31]; 
// 	 
// 	}} 
// file165.close(); 
//  
//  
// std::fstream file175("cmatrix133.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines133; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file175>> matrix133[i31][j31]; 
// 	 
// 	}} 
// file175.close(); 
//  
//  
// std::fstream file185("cmatrix143.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines143; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file185>> matrix143[i31][j31]; 
// 	 
// 	}} 
// file185.close(); 
//  
// std::fstream file195("cmatrix153.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLines153; i31++) { 
//     for ( int j31 = 0; j31 <2; j31++) { 
//         file195>> matrix153[i31][j31]; 
// 	 
// 	}} 
// file195.close(); 
//    //cout<<"input connectivity matrix imported"<<endl;
//  ////////////////////////////////////////////// 
//  
//  
//  float fjee4=0; 
//  float fjee5=0; 
//  float fjee6=0; 
//  float fjee7=0; 
//  
//  
//  float **jee4; 
// 	jee4 = new float*[minimum]; 
//   for(int i30=0;i30 <minimum; i30++){ 
//     jee4 [i30] = new float[1];} 
//   for(int kk=0;kk<minimum;kk++) { 
// 	  jee4[kk][0]=0.42;} 
//  
//   float **jee5; 
// 	jee5 = new float*[minimum]; 
//   for(int i30=0;i30 <minimum; i30++){ 
//     jee5 [i30] = new float[1];} 
//   for(int kk=0;kk<minimum;kk++) { 
// 	  jee5[kk][0]=0.42;} 
//  
//  
//   float **jee6; 
// 	jee6 = new float*[minimum]; 
//   for(int i30=0;i30 <minimum; i30++){ 
//     jee6 [i30] = new float[1];} 
//   for(int kk=0;kk<minimum;kk++) { 
// 	  jee6[kk][0]=0.42;} 
//  
//  
//  
//   float **jee7; 
// 	jee7 = new float*[minimum]; 
//   for(int i30=0;i30 <minimum; i30++){ 
//     jee7 [i30] = new float[1];} 
//   for(int kk=0;kk<minimum;kk++) { 
// 	  jee7[kk][0]=0.42;} 
//  
//   ////////////////////////////////////////////////////////// 
//  
//  //Creation weight Matrix for output layer  
//  
// 	int numLinesc4 = 0; 
// ifstream in18("conect4.txt"); 
// std::string unused18; 
// while ( std::getline(in18, unused18) ){ 
// 	++numLinesc4;} 
//  
// float **connect4; 
// 	connect4 = new float*[numLinesc4]; 
//   for(int i30=0;i30 <numLinesc4; i30++){ 
//     connect4 [i30] = new float[1];} 
//  
//    std::fstream file18("conect4.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLinesc4; i31++) { 
//     for ( int j31 = 0; j31 <1; j31++) { 
//         file18>> connect4[i31][j31]; 
// 	}} 
// file18.close(); 
//  
//  for(int dd4=0;dd4<numLinesc4;dd4++) { 
// 	   jee4[dd4][0]=connect4[dd4][0]; 
//  } 
//  
//  
//  int numLinesc5 = 0; 
// ifstream in185("conect5.txt"); 
// std::string unused185; 
// while ( std::getline(in185, unused185) ){ 
// 	++numLinesc5;} 
//  
// float **connect5; 
// 	connect5= new float*[numLinesc5]; 
//   for(int i30=0;i30 <numLinesc5; i30++){ 
//     connect5[i30] = new float[1];} 
//  
//    std::fstream file285("conect5.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLinesc5; i31++) { 
//     for ( int j31 = 0; j31 <1; j31++) { 
//         file285>> connect5[i31][j31]; 
// 	}} 
// file285.close(); 
//  
//  for(int dd5=0;dd5<numLinesc5;dd5++) { 
// 	   jee5[dd5][0]=connect5[dd5][0]; 
//  } 
//  
//  
//  int numLinesc6 = 0; 
// ifstream in186("conect6.txt"); 
// std::string unused186; 
// while ( std::getline(in186, unused186) ){ 
// 	++numLinesc6;} 
//  
// float **connect6; 
// 	connect6 = new float*[numLinesc6]; 
//   for(int i30=0;i30 <numLinesc6; i30++){ 
//     connect6 [i30] = new float[1];} 
//  
//    std::fstream file186("conect6.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLinesc6; i31++) { 
//     for ( int j31 = 0; j31 <1; j31++) { 
//         file186>> connect6[i31][j31]; 
// 	}} 
// file186.close(); 
//  
//  for(int dd6=0;dd6<numLinesc6;dd6++) { 
// 	   jee6[dd6][0]=connect6[dd6][0]; 
//  } 
//  
//  
//  int numLinesc7 = 0; 
// ifstream in187("conect7.txt"); 
// std::string unused187; 
// while ( std::getline(in187, unused187) ){ 
// 	++numLinesc7;} 
//  
// float **connect7; 
// 	connect7 = new float*[numLinesc7]; 
//   for(int i30=0;i30 <numLinesc7; i30++){ 
//     connect7 [i30] = new float[1];} 
//  
//    std::fstream file187("conect7.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLinesc7; i31++) { 
//     for ( int j31 = 0; j31 <1; j31++) { 
//         file187>> connect7[i31][j31]; 
// 	}} 
// file187.close(); 
//  
//  for(int dd7=0;dd7<numLinesc7;dd7++) { 
// 	   jee7[dd7][0]=connect7[dd7][0]; 
//  } 
//  
//  // connecting input nodes to hidden layer (only pyramidals). 
// // finding the number of connections by "getline" command 
//  // weight matrix for hidden layer 
//  
//  int numLinesc3 = 0; 
// ifstream in183("conect3.txt"); 
// std::string unused183; 
// while ( std::getline(in183, unused183) ){ 
// 	++numLinesc3;} 
//  
// float **connnect3; 
// 	connnect3 = new float*[numLinesc3]; 
//   for(int i30=0;i30 <numLinesc3; i30++){ 
//     connnect3 [i30] = new float[1];} 
//  
//    std::fstream file183("conect3.txt", std::ios_base::in); 
//   for (int i31 = 0; i31 <numLinesc3; i31++) { 
//     for ( int j31 = 0; j31 <1; j31++) { 
//         file183>> connnect3[i31][j31]; 
// 	}} 
// file183.close(); 
//  
// 
// int cc=0; 
// for(int ww1=0;ww1<fNE+fNI;ww1++) { 
// 	    for(int ww2=0;ww2<fNE+fNI;ww2++) { 
// 			hjee[ww1][ww2]=connnect3[cc][0]; 
// 			cc=cc+1; 
// 		}} 
//  
//  
// 	int nazar4=0; 
// 	int nazar5=0; 
// 	int nazar6=0; 
// 	int nazar7=0; 
//  
// 	int counter_percentage=0;
// 	
//   for(int uu=0;uu<trail;uu++){  // begin on trial loop (10 test trials) 
//      
//    //initialization 
//     
//    for(in=0;in<fNE+fNI;in++) { 
//     for(ip=0;ip<CYCSIZE;ip++) { 
//        
//       fhrece3[in][ip]=0.; 
// 	  fhreci3[in][ip]=0.; 
// 	} 
// 	fhi3[in]=0.; 
// 	} 
//  
//   
// 	 
// 	  fhrece4=0.; 
//       fhreci4=0.; 
// 	  fhrece5=0.; 
//       fhreci5=0.; 
// 	  fhrece6=0.; 
//       fhreci6=0.; 
// 	  fhrece7=0.; 
//       fhreci7=0.; 
// 	 
// 	 
// 	fhi4=0.; 
//     fhi5=0.; 
// 	fhi6=0.; 
// 	fhi7=0.; 
//  
// 	ftspki4=-1; 
// 	ftspki5=-1; 
// 	ftspki6=-1; 
// 	ftspki7=-1; 
// 	 
//  
// 	 for (in=0; in<fNE+fNI; in++){ 
//  
//     ftspki3[in]=-1; 
//     
//     fxAMPA3[in]=0; 
// 	fxAMPAk13[in]=0; 
// 	fxAMPAk23[in]=0; 
// 	fxAMPArk3[in]=0; 
// 	 
// 	 
//  
//     fsAMPA3[in]=0; 
// 	fsAMPAk13[in]=0; 
// 	fsAMPAk23[in]=0; 
// 	fsAMPArk3[in]=0; 
// 	 
// 	 
//  
//     fsAMPATH311[in]=0; 
//     fxAMPATH311[in]=0; 
// 	fsAMPATHk1311[in]=0; 
//     fxAMPATHk1311[in]=0; 
// 	fsAMPATHk2311[in]=0; 
//     fxAMPATHk2311[in]=0; 
// 	fsAMPATHrk311[in]=0; 
//     fxAMPATHrk311[in]=0; 
//  
// 	fsAMPATH312[in]=0; 
//     fxAMPATH312[in]=0; 
// 	fsAMPATHk1312[in]=0; 
//     fxAMPATHk1312[in]=0; 
// 	fsAMPATHk2312[in]=0; 
//     fxAMPATHk2312[in]=0; 
// 	fsAMPATHrk312[in]=0; 
//     fxAMPATHrk312[in]=0; 
//  
// 	fsAMPATH313[in]=0; 
//     fxAMPATH313[in]=0; 
// 	fsAMPATHk1313[in]=0; 
//     fxAMPATHk1313[in]=0; 
// 	fsAMPATHk2313[in]=0; 
//     fxAMPATHk2313[in]=0; 
// 	fsAMPATHrk313[in]=0; 
//     fxAMPATHrk313[in]=0; 
//  
// 	fsAMPATH314[in]=0; 
//     fxAMPATH314[in]=0; 
// 	fsAMPATHk1314[in]=0; 
//     fxAMPATHk1314[in]=0; 
// 	fsAMPATHk2314[in]=0; 
//     fxAMPATHk2314[in]=0; 
// 	fsAMPATHrk314[in]=0; 
//     fxAMPATHrk314[in]=0; 
//  
// 	fsAMPATH315[in]=0; 
//     fxAMPATH315[in]=0; 
// 	fsAMPATHk1315[in]=0; 
//     fxAMPATHk1315[in]=0; 
// 	fsAMPATHk2315[in]=0; 
//     fxAMPATHk2315[in]=0; 
// 	fsAMPATHrk315[in]=0; 
//     fxAMPATHrk315[in]=0; 
// 	 
// 	fsAMPATH316[in]=0; 
//     fxAMPATH316[in]=0; 
// 	fsAMPATHk1316[in]=0; 
//     fxAMPATHk1316[in]=0; 
// 	fsAMPATHk2316[in]=0; 
//     fxAMPATHk2316[in]=0; 
// 	fsAMPATHrk316[in]=0; 
//     fxAMPATHrk316[in]=0; 
//  
// 	fsAMPATH317[in]=0; 
//     fxAMPATH317[in]=0; 
// 	fsAMPATHk1317[in]=0; 
//     fxAMPATHk1317[in]=0; 
// 	fsAMPATHk2317[in]=0; 
//     fxAMPATHk2317[in]=0; 
// 	fsAMPATHrk317[in]=0; 
//     fxAMPATHrk317[in]=0; 
//  
// 	fsAMPATH318[in]=0; 
//     fxAMPATH318[in]=0; 
// 	fsAMPATHk1318[in]=0; 
//     fxAMPATHk1318[in]=0; 
// 	fsAMPATHk2318[in]=0; 
//     fxAMPATHk2318[in]=0; 
// 	fsAMPATHrk318[in]=0; 
//     fxAMPATHrk318[in]=0; 
//  
// 	fsAMPATH319[in]=0; 
//     fxAMPATH319[in]=0; 
// 	fsAMPATHk1319[in]=0; 
//     fxAMPATHk1319[in]=0; 
// 	fsAMPATHk2319[in]=0; 
//     fxAMPATHk2319[in]=0; 
// 	fsAMPATHrk319[in]=0; 
//     fxAMPATHrk319[in]=0; 
// 	 
// 	fsAMPATH3110[in]=0; 
//     fxAMPATH3110[in]=0; 
// 	fsAMPATHk13110[in]=0; 
//     fxAMPATHk13110[in]=0; 
// 	fsAMPATHk23110[in]=0; 
//     fxAMPATHk23110[in]=0; 
// 	fsAMPATHrk3110[in]=0; 
//     fxAMPATHrk3110[in]=0; 
// 	 
// 	fsAMPATH3111[in]=0; 
//     fxAMPATH3111[in]=0; 
// 	fsAMPATHk13111[in]=0; 
//     fxAMPATHk13111[in]=0; 
// 	fsAMPATHk23111[in]=0; 
//     fxAMPATHk23111[in]=0; 
// 	fsAMPATHrk3111[in]=0; 
//     fxAMPATHrk3111[in]=0; 
// 	 
// 	fsAMPATH3112[in]=0; 
//     fxAMPATH3112[in]=0; 
// 	fsAMPATHk13112[in]=0; 
//     fxAMPATHk13112[in]=0; 
// 	fsAMPATHk23112[in]=0; 
//     fxAMPATHk23112[in]=0; 
// 	fsAMPATHrk3112[in]=0; 
//     fxAMPATHrk3112[in]=0; 
//  
//  
// 	fsAMPATH3113[in]=0; 
//     fxAMPATH3113[in]=0; 
// 	fsAMPATHk13113[in]=0; 
//     fxAMPATHk13113[in]=0; 
// 	fsAMPATHk23113[in]=0; 
//     fxAMPATHk23113[in]=0; 
// 	fsAMPATHrk3113[in]=0; 
//     fxAMPATHrk3113[in]=0; 
// 	 
// 	fsAMPATH3114[in]=0; 
//     fxAMPATH3114[in]=0; 
// 	fsAMPATHk13114[in]=0; 
//     fxAMPATHk13114[in]=0; 
// 	fsAMPATHk23114[in]=0; 
//     fxAMPATHk23114[in]=0; 
// 	fsAMPATHrk3114[in]=0; 
//     fxAMPATHrk3114[in]=0; 
//  
// 	fsAMPATH3115[in]=0; 
//     fxAMPATH3115[in]=0; 
// 	fsAMPATHk13115[in]=0; 
//     fxAMPATHk13115[in]=0; 
// 	fsAMPATHk23115[in]=0; 
//     fxAMPATHk23115[in]=0; 
// 	fsAMPATHrk3115[in]=0; 
//     fxAMPATHrk3115[in]=0; 
//  
// 	fsAMPATH3116[in]=0; 
//     fxAMPATH3116[in]=0; 
// 	fsAMPATHk13116[in]=0; 
//     fxAMPATHk13116[in]=0; 
// 	fsAMPATHk23116[in]=0; 
//     fxAMPATHk23116[in]=0; 
// 	fsAMPATHrk3116[in]=0; 
//     fxAMPATHrk3116[in]=0; 
// 	 
// 	fsAMPATH3117[in]=0; 
//     fxAMPATH3117[in]=0; 
// 	fsAMPATHk13117[in]=0; 
//     fxAMPATHk13117[in]=0; 
// 	fsAMPATHk23117[in]=0; 
//     fxAMPATHk23117[in]=0; 
// 	fsAMPATHrk3117[in]=0; 
//     fxAMPATHrk3117[in]=0; 
//  
// 	isAMPATH[in]=0; 
//     ixAMPATH[in]=0; 
// 	isAMPATHk1[in]=0; 
//     ixAMPATHk1[in]=0; 
// 	isAMPATHk2[in]=0; 
//     ixAMPATHk2[in]=0; 
// 	isAMPATHrk[in]=0; 
//     ixAMPATHrk[in]=0; 
// 	 
//  
// 	xAMPACC[in]=0; 
// 	xAMPACCk1[in]=0; 
// 	xAMPACCk2[in]=0; 
// 	xAMPACCrk[in]=0; 
//     sAMPACC[in]=0; 
// 	sAMPACCk1[in]=0; 
// 	sAMPACCk2[in]=0; 
// 	sAMPACCrk[in]=0; 
//  
//     fxGABA3[in]=0; 
// 	fxGABAk13[in]=0; 
// 	fxGABAk23[in]=0; 
// 	fxGABArk3[in]=0; 
// 	 
//  
//     fsGABA3[in]=0; 
// 	fsGABAk13[in]=0; 
// 	fsGABAk23[in]=0; 
// 	fsGABArk3[in]=0; 
// 	 
// 	 } 
//  
// 	fxAMPA34=0; 
// 	fxAMPA35=0; 
// 	fxAMPAk134=0; 
// 	fxAMPAk135=0; 
// 	fxAMPAk234=0; 
// 	fxAMPAk235=0; 
// 	fxAMPArk34=0; 
// 	fxAMPArk35=0; 
//  
// 	fsAMPA34=0; 
// 	fsAMPA35=0; 
// 	fsAMPAk134=0; 
// 	fsAMPAk135=0; 
// 	fsAMPAk234=0; 
// 	fsAMPAk235=0; 
// 	fsAMPArk34=0; 
// 	fsAMPArk35=0; 
//  
// 	fxGABA34=0; 
// 	fxGABA35=0; 
// 	fxGABAk134=0; 
// 	fsGABAk134=0; 
// 	fxGABAk135=0; 
// 	fsGABAk135=0; 
// 	fxGABAk234=0; 
// 	fsGABAk234=0; 
// 	fxGABAk235=0; 
// 	fsGABAk235=0; 
// 	fxGABArk34=0; 
// 	fsGABArk34=0; 
// 	fxGABArk35=0; 
// 	fsGABArk35=0; 
// 	 
// 	fsGABA34=0; 
// 	fsGABA35=0; 
//  
//  
// 	fxAMPA36=0; 
// 	fxAMPA37=0; 
// 	fxAMPAk136=0; 
// 	fxAMPAk137=0; 
// 	fxAMPAk236=0; 
// 	fxAMPAk237=0; 
// 	fxAMPArk36=0; 
// 	fxAMPArk37=0; 
//  
// 	fsAMPA36=0; 
// 	fsAMPA37=0; 
// 	fsAMPAk136=0; 
// 	fsAMPAk137=0; 
// 	fsAMPAk236=0; 
// 	fsAMPAk237=0; 
// 	fsAMPArk36=0; 
// 	fsAMPArk37=0; 
//  
// 	fxGABA36=0; 
// 	fxGABA37=0; 
// 	fxGABAk136=0; 
// 	fsGABAk136=0; 
// 	fxGABAk137=0; 
// 	fsGABAk137=0; 
// 	fxGABAk236=0; 
// 	fsGABAk236=0; 
// 	fxGABAk237=0; 
// 	fsGABAk237=0; 
// 	fxGABArk36=0; 
// 	fsGABArk36=0; 
// 	fxGABArk37=0; 
// 	fsGABArk37=0; 
// 	 
// 	fsGABA36=0; 
// 	fsGABA37=0; 
//  
//  
//  
//     iIsyn3=0; 
// 	fIsyn31=0; 
// 	fIsyn32=0; 
// 	fIsyn33=0; 
// 	fIsyn34=0; 
//     fIsyn4=0; 
// 	fIsyn5=0; 
// 	fIsyn6=0; 
// 	fIsyn7=0; 
// 	 
//  
//     iIsynk13=0; 
// 	fIsynk131=0; 
// 	fIsynk132=0; 
// 	fIsynk133=0; 
// 	fIsynk134=0; 
//     fIsynk14=0; 
// 	fIsynk15=0; 
// 	fIsynk16=0; 
// 	fIsynk17=0; 
//  
//      
//  
//  
// 	int counter=0; 
// 	int temp_perc=-1;
//    //cout<<"ready to compute ode loop"<<endl;
//  
// 	for(icycle=0;icycle<sub*time;icycle++){    /// begin of time loop for solving diff equ 
//  
// 	  counter_percentage++;
// 	  if(((counter_percentage*100/(sub*time*trail))%10==0) && ((counter_percentage*100/(sub*time*trail))>temp_perc) ){
// 	    temp_perc=counter_percentage*100/(sub*time*trail);
// 	    printf("Run in progress %d%%...\n",temp_perc);
// 	  }
//  
// 		if (icycle>0 && icycle%CYCSIZE==0){ 
// 			counter=counter+1;} 
//  
// 		//noise 
// 		if (icycle>stimbin*10){ 
//       frnoise+=-frnoise*lamb+munoise*lamb+sigmanoise*sqrt(2*lamb)*gasdev(&idum); 
//       stimbin++; 
//     } 
// 		frspont=(fromcortex*(frnoise))/200; 
// 		if (frspont<0) {frspont=0;} 
//  
//  
// 		int xx=10; 
// // 		cout<<"input test" << curr_stim << " trial "<< curr_trial <<" imported!"<<endl;
//         //input to hidden layer 
// 		ffrstim11=inputtest1[counter][uu][0]*xx; 
// 		ffrstim12=inputtest1[counter][uu][1]*xx; 
// 		ffrstim13=inputtest1[counter][uu][2]*xx; 
// 		ffrstim14=inputtest1[counter][uu][3]*xx; 
// 		ffrstim21=inputtest1[counter][uu][4]*xx; 
// 		ffrstim22=inputtest1[counter][uu][5]*xx; 
// 		ffrstim23=inputtest1[counter][uu][6]*xx; 
// 		ffrstim24=inputtest1[counter][uu][7]*xx; 
// 		ffrstim31=inputtest1[counter][uu][8]*xx; 
// 		ffrstim32=inputtest1[counter][uu][9]*xx; 
// 		ffrstim33=inputtest1[counter][uu][10]*xx; 
// 		ffrstim41=inputtest1[counter][uu][11]*xx; 
// 		ffrstim42=inputtest1[counter][uu][12]*xx; 
// 		ffrstim43=inputtest1[counter][uu][13]*xx; 
// 		ffrstim44=inputtest1[counter][uu][14]*xx; 
// // 		ffrstim11=inputtest1[counter][curr_trial][0]*xx; cout<<"0"<<endl;
// // 		ffrstim12=inputtest1[counter][curr_trial][1]*xx; cout<<"1"<<endl;
// // 		ffrstim13=inputtest1[counter][curr_trial][2]*xx; cout<<"2"<<endl;
// // 		ffrstim14=inputtest1[counter][curr_trial][3]*xx; cout<<"3"<<endl;
// // 		ffrstim21=inputtest1[counter][curr_trial][4]*xx; cout<<"4"<<endl;
// // 		ffrstim22=inputtest1[counter][curr_trial][5]*xx; cout<<"5"<<endl;
// // 		ffrstim23=inputtest1[counter][curr_trial][6]*xx; cout<<"6"<<endl;
// // 		ffrstim24=inputtest1[counter][curr_trial][7]*xx; cout<<"7"<<endl;
// // 		ffrstim31=inputtest1[counter][curr_trial][8]*xx; cout<<"8"<<endl;
// // 		ffrstim32=inputtest1[counter][curr_trial][9]*xx; cout<<"9"<<endl;
// // 		ffrstim33=inputtest1[counter][curr_trial][10]*xx; cout<<"10"<<endl;
// // 		ffrstim41=inputtest1[counter][curr_trial][11]*xx; cout<<"11"<<endl;
// // 		ffrstim42=inputtest1[counter][curr_trial][12]*xx; cout<<"12"<<endl;
// // 		ffrstim43=inputtest1[counter][curr_trial][13]*xx; cout<<"13"<<endl;
// // 		ffrstim44=inputtest1[counter][curr_trial][14]*xx; cout<<"14"<<endl;
// // 		ifrstim=(5+fromth)/200; 
//  
//                 
// 		nazar4=0; 
// 		nazar5=0; 
// 		nazar6=0; 
// 		nazar7=0; 
//  
//  
// 	  for(ineur=0;ineur<fNE;ineur++) { // loop for pyramidals (PY) 
//  
//  
// 		  tminx=icycle%CYCSIZE; 
//  
// 	  fstim11=poidev(ffrstim11,&idum); 
// 	  fstim12=poidev(ffrstim12,&idum); 
// 	  fstim13=poidev(ffrstim13,&idum); 
// 	  fstim14=poidev(ffrstim14,&idum); 
// 	  fstim21=poidev(ffrstim21,&idum); 
// 	  fstim22=poidev(ffrstim22,&idum); 
// 	  fstim23=poidev(ffrstim23,&idum); 
// 	  fstim24=poidev(ffrstim24,&idum); 
// 	  fstim31=poidev(ffrstim31,&idum); 
// 	  fstim32=poidev(ffrstim32,&idum); 
// 	  fstim33=poidev(ffrstim33,&idum); 
// 	  fstim41=poidev(ffrstim41,&idum); 
// 	  fstim42=poidev(ffrstim42,&idum); 
// 	  fstim43=poidev(ffrstim43,&idum); 
// 	  fstim44=poidev(ffrstim44,&idum); 
//  
// 	  noise=poidev(frspont,&idum); 
// 	  istim=poidev(ifrstim,&idum); 
// 	 
// 	 /////////////////////////////////////////// 
//  
// 	  //creating excitatory synaptic current 
// 	 
//     	fIsyn31=0; 
// 	  for(int qq=0;qq<numLines13;qq++) { 
// 		if(ineur==matrix13[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH311[ineur];}} 
//  
// 	   for(int qq=0;qq<numLines23;qq++) { 
// 		if(ineur==matrix23[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH312[ineur];}} 
//  
// 	    for(int qq=0;qq<numLines33;qq++) { 
// 		if(ineur==matrix33[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH313[ineur];}} 
//  
// 		 for(int qq=0;qq<numLines43;qq++) { 
// 		if(ineur==matrix43[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH314[ineur];}} 
// 		 
// 	   
// 		   for(int qq=0;qq<numLines53;qq++) { 
// 		if(ineur==matrix53[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH316[ineur];}} 
//  
//  
// 		    for(int qq=0;qq<numLines63;qq++) { 
// 		if(ineur==matrix63[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH317[ineur];}} 
//  
//  
// 			 for(int qq=0;qq<numLines73;qq++) { 
// 		if(ineur==matrix73[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH318[ineur];}} 
//  
//  
// 			  for(int qq=0;qq<numLines83;qq++) { 
// 		if(ineur==matrix83[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH319[ineur];}} 
//  
// 	   
// 			    for(int qq=0;qq<numLines93;qq++) { 
// 		if(ineur==matrix93[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH3111[ineur];}} 
//  
//  
// 				 for(int qq=0;qq<numLines103;qq++) { 
// 		if(ineur==matrix103[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH3112[ineur];}} 
//  
//  
// 				  for(int qq=0;qq<numLines113;qq++) { 
// 		if(ineur==matrix113[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH3113[ineur];}} 
//      
//  
//                for(int qq=0;qq<numLines123;qq++) { 
// 		if(ineur==matrix123[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH3114[ineur];}} 
//  
//  
// 				  for(int qq=0;qq<numLines133;qq++) { 
// 		if(ineur==matrix133[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH3115[ineur];}} 
//      
// 				  for(int qq=0;qq<numLines143;qq++) { 
// 		if(ineur==matrix143[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH3116[ineur];}} 
//  
// 				  for(int qq=0;qq<numLines153;qq++) { 
// 		if(ineur==matrix153[qq][1]){ 
// 			fIsyn31=fIsyn31+fsAMPATH3117[ineur];}} 
//  
//       // synaptic current for PY 
// 	    fIsyn31=fIsyn31+fsAMPA3[ineur]-fsGABA3[ineur]+isAMPATH[ineur]; 
//  
//  
// 	/* ///////////////////////////////// E-->E ////////////////////////// */ 
//     // excitatory synaptic current for PY  
//    // Solving diff-Equ with 2nd order Runge-kutta  
//  
//     ffspk3=fhrece3[ineur][tminx]; 
// 	fh=fhjee[ineur][tminx];   //sigma in Differential Equations 
//   // for 40 payramids in the hidden layer 
//   // "3" symbols for hidden layer,  
//  
//    	fxAMPAk13[ineur]=inriseEE*taumE*(fh)-dtriseEE*fxAMPA3[ineur];  
// 	fsAMPAk13[ineur]=dtdecayEE*(fxAMPA3[ineur] - fsAMPA3[ineur]); 
// 	fsAMPArk3[ineur]=fsAMPA3[ineur]+0.5*fsAMPAk13[ineur]; 
// 	fxAMPAk23[ineur]=inriseEE*taumE*(fh)- dtriseEE*(fxAMPA3[ineur]+0.5*fxAMPAk13[ineur]); 
// 	fsAMPAk23[ineur]=dtdecayEE*((fxAMPA3[ineur]+0.5*fxAMPAk13[ineur]) - fsAMPArk3[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPA3[ineur]+=fxAMPAk23[ineur];  
// 	fsAMPA3[ineur]+=fsAMPAk23[ineur];      
// ////////////////////////////////////////////////// 
// 	//spike train with 1spike/ms for interneurons 
//  
// 	ixAMPATHk1[ineur]=inriseEE*taumE*(jestim*(istim)) -dtriseEE*ixAMPATH[ineur]; 
// 	isAMPATHk1[ineur]=dtdecayEE*(ixAMPATH[ineur] - isAMPATH[ineur]); 
// 	isAMPATHrk[ineur]=isAMPATH[ineur]+0.5*isAMPATHk1[ineur]; 
// 	ixAMPATHk2[ineur]=inriseEE*taumE*(jestim*(istim)) - dtriseEE*(ixAMPATH[ineur]+0.5*ixAMPATHk1[ineur]); 
// 	isAMPATHk2[ineur]=dtdecayEE*((ixAMPATH[ineur]+0.5*ixAMPATHk1[ineur]) - isAMPATHrk[ineur]); /*increment computed with runge-kutta*/ 
// 	ixAMPATH[ineur]+=ixAMPATHk2[ineur];  
// 	isAMPATH[ineur]+=isAMPATHk2[ineur];  
//  
// ///////////////////////////////////////////////// 
// 	 
// 	for(int pp=0;pp<numLines13;pp++) {  // loop for first external current  
//  
// 	// numLines13 means "1"st input to the hidden layer ("3") 
//  
// 		if(ineur==matrix13[pp][1]){ 
//  
// 	fxAMPATHk1311[ineur]=inriseEE*taumE*(jestim*(fstim11)) -dtriseEE*fxAMPATH311[ineur]; 
// 	fsAMPATHk1311[ineur]=dtdecayEE*(fxAMPATH311[ineur] - fsAMPATH311[ineur]); 
// 	fsAMPATHrk311[ineur]=fsAMPATH311[ineur]+0.5*fsAMPATHk1311[ineur]; 
// 	fxAMPATHk2311[ineur]=inriseEE*taumE*(jestim*(fstim11)) - dtriseEE*(fxAMPATH311[ineur]+0.5*fxAMPATHk1311[ineur]); 
// 	fsAMPATHk2311[ineur]=dtdecayEE*((fxAMPATH311[ineur]+0.5*fxAMPATHk1311[ineur]) - fsAMPATHrk311[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH311[ineur]+=fxAMPATHk2311[ineur]; // final output of X_ampa 
// 	fsAMPATH311[ineur]+=fsAMPATHk2311[ineur]; // final output of I_ampa 
//  
// 	if (fstim11>0){ 
// 		  fprintf(input1,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
// 		} 
//  
// 	 
// 	} 
// 	 
// 	for(int pp=0;pp<numLines23;pp++) {  // loop for second external current  
// 	// numLines23 means "2"nd input to the hidden layer ("3") 
// 		if(ineur==matrix23[pp][1]){ 
//  
// 	fxAMPATHk1312[ineur]=inriseEE*taumE*(jestim*(fstim12)) -dtriseEE*fxAMPATH312[ineur]; 
// 	fsAMPATHk1312[ineur]=dtdecayEE*(fxAMPATH312[ineur] - fsAMPATH312[ineur]); 
// 	fsAMPATHrk312[ineur]=fsAMPATH312[ineur]+0.5*fsAMPATHk1312[ineur]; 
// 	fxAMPATHk2312[ineur]=inriseEE*taumE*(jestim*(fstim12)) - dtriseEE*(fxAMPATH312[ineur]+0.5*fxAMPATHk1312[ineur]); 
// 	fsAMPATHk2312[ineur]=dtdecayEE*((fxAMPATH312[ineur]+0.5*fxAMPATHk1312[ineur]) - fsAMPATHrk312[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH312[ineur]+=fxAMPATHk2312[ineur]; // final output of X_ampa 
// 	fsAMPATH312[ineur]+=fsAMPATHk2312[ineur]; // final output of I_ampa 
//  
// 	if (fstim12>0){ 
// 		  fprintf(input2,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
//  
// 		} 
// 	 
// 	} 
//  
//  
// 	for(int pp=0;pp<numLines33;pp++) {    // loop for third external current  
//     	// numLines33 means "3"rd input to the hidden layer ("3") 
// 		if(ineur==matrix33[pp][1]){ 
//  
// 	fxAMPATHk1313[ineur]=inriseEE*taumE*(jestim*(fstim13)) -dtriseEE*fxAMPATH313[ineur]; 
// 	fsAMPATHk1313[ineur]=dtdecayEE*(fxAMPATH313[ineur] - fsAMPATH313[ineur]); 
// 	fsAMPATHrk313[ineur]=fsAMPATH313[ineur]+0.5*fsAMPATHk1313[ineur]; 
// 	fxAMPATHk2313[ineur]=inriseEE*taumE*(jestim*(fstim13)) - dtriseEE*(fxAMPATH313[ineur]+0.5*fxAMPATHk1313[ineur]); 
// 	fsAMPATHk2313[ineur]=dtdecayEE*((fxAMPATH313[ineur]+0.5*fxAMPATHk1313[ineur]) - fsAMPATHrk313[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH313[ineur]+=fxAMPATHk2313[ineur]; // final output of X_ampa 
// 	fsAMPATH313[ineur]+=fsAMPATHk2313[ineur]; // final output of I_ampa 
//  
// 	if (fstim13>0){ 
// 		  fprintf(input3,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
//  
// 		} 
//  
// 		} 
// 	 
// 	for(int pp=0;pp<numLines43;pp++) { 
//    		if(ineur==matrix43[pp][1]){ 
//  
// 	fxAMPATHk1314[ineur]=inriseEE*taumE*(jestim*(fstim14)) -dtriseEE*fxAMPATH314[ineur]; 
// 	fsAMPATHk1314[ineur]=dtdecayEE*(fxAMPATH314[ineur] - fsAMPATH314[ineur]); 
// 	fsAMPATHrk314[ineur]=fsAMPATH314[ineur]+0.5*fsAMPATHk1314[ineur]; 
// 	fxAMPATHk2314[ineur]=inriseEE*taumE*(jestim*(fstim14)) - dtriseEE*(fxAMPATH314[ineur]+0.5*fxAMPATHk1314[ineur]); 
// 	fsAMPATHk2314[ineur]=dtdecayEE*((fxAMPATH314[ineur]+0.5*fxAMPATHk1314[ineur]) - fsAMPATHrk314[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH314[ineur]+=fxAMPATHk2314[ineur]; // final output of X_ampa 
// 	fsAMPATH314[ineur]+=fsAMPATHk2314[ineur]; // final output of I_ampa 
//  
// 	if (fstim14>0){ 
// 		  fprintf(input4,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
//  
// 		} 
// 	 
// 	 
// 	} 
// 	 
// 	for(int pp=0;pp<numLines53;pp++) { 
//     
// 		if(ineur==matrix53[pp][1]){ 
//  
// 	fxAMPATHk1316[ineur]=inriseEE*taumE*(jestim*(fstim21)) -dtriseEE*fxAMPATH316[ineur]; 
// 	fsAMPATHk1316[ineur]=dtdecayEE*(fxAMPATH316[ineur] - fsAMPATH316[ineur]); 
// 	fsAMPATHrk316[ineur]=fsAMPATH316[ineur]+0.5*fsAMPATHk1316[ineur]; 
// 	fxAMPATHk2316[ineur]=inriseEE*taumE*(jestim*(fstim21)) - dtriseEE*(fxAMPATH316[ineur]+0.5*fxAMPATHk1316[ineur]); 
// 	fsAMPATHk2316[ineur]=dtdecayEE*((fxAMPATH316[ineur]+0.5*fxAMPATHk1316[ineur]) - fsAMPATHrk316[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH316[ineur]+=fxAMPATHk2316[ineur];  
// 	fsAMPATH316[ineur]+=fsAMPATHk2316[ineur]; 
//  
// 	if (fstim21>0){ 
// 		  fprintf(input5,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
//  
// 		} 
// 	 
// 	 
// 	 
// 	} 
//  
//  
// 	for(int pp=0;pp<numLines63;pp++) { 
// 	 
// 		if(ineur==matrix63[pp][1]){ 
//  
// 	fxAMPATHk1317[ineur]=inriseEE*taumE*(jestim*(fstim22)) -dtriseEE*fxAMPATH317[ineur]; 
// 	fsAMPATHk1317[ineur]=dtdecayEE*(fxAMPATH317[ineur] - fsAMPATH317[ineur]); 
// 	fsAMPATHrk317[ineur]=fsAMPATH317[ineur]+0.5*fsAMPATHk1317[ineur]; 
// 	fxAMPATHk2317[ineur]=inriseEE*taumE*(jestim*(fstim22)) - dtriseEE*(fxAMPATH317[ineur]+0.5*fxAMPATHk1317[ineur]); 
// 	fsAMPATHk2317[ineur]=dtdecayEE*((fxAMPATH317[ineur]+0.5*fxAMPATHk1317[ineur]) - fsAMPATHrk317[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH317[ineur]+=fxAMPATHk2317[ineur]; // final output of X_ampa 
// 	fsAMPATH317[ineur]+=fsAMPATHk2317[ineur]; // final output of I_ampa 
//  
// 	if (fstim22>0){ 
// 		  fprintf(input6,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
//  
// 		} 
// 	 
// 	 
// 	} 
//  
// 	for(int pp=0;pp<numLines73;pp++) { 
// 	 
//  
// 		if(ineur==matrix73[pp][1]){ 
//  
// 	fxAMPATHk1318[ineur]=inriseEE*taumE*(jestim*(fstim23)) -dtriseEE*fxAMPATH318[ineur]; 
// 	fsAMPATHk1318[ineur]=dtdecayEE*(fxAMPATH318[ineur] - fsAMPATH318[ineur]); 
// 	fsAMPATHrk318[ineur]=fsAMPATH318[ineur]+0.5*fsAMPATHk1318[ineur]; 
// 	fxAMPATHk2318[ineur]=inriseEE*taumE*(jestim*(fstim23)) - dtriseEE*(fxAMPATH318[ineur]+0.5*fxAMPATHk1318[ineur]); 
// 	fsAMPATHk2318[ineur]=dtdecayEE*((fxAMPATH318[ineur]+0.5*fxAMPATHk1318[ineur]) - fsAMPATHrk318[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH318[ineur]+=fxAMPATHk2318[ineur]; // final output of X_ampa 
// 	fsAMPATH318[ineur]+=fsAMPATHk2318[ineur]; // final output of I_ampa 
//  
// 	if (fstim23>0){ 
// 		  fprintf(input7,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
//  
// 		} 
//  
// 	 
// 	} 
//  
// 	for(int pp=0;pp<numLines83;pp++) { 
// 	 
// 		if(ineur==matrix83[pp][1]){ 
//  
// 	fxAMPATHk1319[ineur]=inriseEE*taumE*(jestim*(fstim24)) -dtriseEE*fxAMPATH319[ineur]; 
// 	fsAMPATHk1319[ineur]=dtdecayEE*(fxAMPATH319[ineur] - fsAMPATH319[ineur]); 
// 	fsAMPATHrk319[ineur]=fsAMPATH319[ineur]+0.5*fsAMPATHk1319[ineur]; 
// 	fxAMPATHk2319[ineur]=inriseEE*taumE*(jestim*(fstim24)) - dtriseEE*(fxAMPATH319[ineur]+0.5*fxAMPATHk1319[ineur]); 
// 	fsAMPATHk2319[ineur]=dtdecayEE*((fxAMPATH319[ineur]+0.5*fxAMPATHk1319[ineur]) - fsAMPATHrk319[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH319[ineur]+=fxAMPATHk2319[ineur]; /* value = value0 + increment*/ 
// 	fsAMPATH319[ineur]+=fsAMPATHk2319[ineur]; 
//  
// 	if (fstim24>0){ 
// 		  fprintf(input8,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
//  
// 		} 
// 	 
// 	 
// 	} 
//  
// 	 
//  
// 	for(int pp=0;pp<numLines93;pp++) { 
// 	 
// 		if(ineur==matrix93[pp][1]){ 
//  
// 	fxAMPATHk13111[ineur]=inriseEE*taumE*(jestim*(fstim31)) -dtriseEE*fxAMPATH3111[ineur]; 
// 	fsAMPATHk13111[ineur]=dtdecayEE*(fxAMPATH3111[ineur] - fsAMPATH3111[ineur]); 
// 	fsAMPATHrk3111[ineur]=fsAMPATH3111[ineur]+0.5*fsAMPATHk13111[ineur]; 
// 	fxAMPATHk23111[ineur]=inriseEE*taumE*(jestim*(fstim31)) - dtriseEE*(fxAMPATH3111[ineur]+0.5*fxAMPATHk13111[ineur]); 
// 	fsAMPATHk23111[ineur]=dtdecayEE*((fxAMPATH3111[ineur]+0.5*fxAMPATHk13111[ineur]) - fsAMPATHrk3111[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH3111[ineur]+=fxAMPATHk23111[ineur]; /* value = value0 + increment*/ 
// 	fsAMPATH3111[ineur]+=fsAMPATHk23111[ineur]; 
//  
// 	if (fstim31>0){ 
// 		  fprintf(input9,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
//  
// 		} 
// 	 
//  
// 	} 
//  
//  
// 	for(int pp=0;pp<numLines103;pp++) { 
// 	 
// 		if(ineur==matrix103[pp][1]){ 
//  
// 	fxAMPATHk13112[ineur]=inriseEE*taumE*(jestim*(fstim32)) -dtriseEE*fxAMPATH3112[ineur]; 
// 	fsAMPATHk13112[ineur]=dtdecayEE*(fxAMPATH3112[ineur] - fsAMPATH3112[ineur]); 
// 	fsAMPATHrk3112[ineur]=fsAMPATH3112[ineur]+0.5*fsAMPATHk13112[ineur]; 
// 	fxAMPATHk23112[ineur]=inriseEE*taumE*(jestim*(fstim32)) - dtriseEE*(fxAMPATH3112[ineur]+0.5*fxAMPATHk13112[ineur]); 
// 	fsAMPATHk23112[ineur]=dtdecayEE*((fxAMPATH3112[ineur]+0.5*fxAMPATHk13112[ineur]) - fsAMPATHrk3112[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH3112[ineur]+=fxAMPATHk23112[ineur]; /* value = value0 + increment*/ 
// 	fsAMPATH3112[ineur]+=fsAMPATHk23112[ineur]; 
//  
// 	if (fstim32>0){ 
// 		  fprintf(input10,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
//  
// 		} 
//  
//  
// 	 
// 	} 
//  
//  
// 	for(int pp=0;pp<numLines113;pp++) { 
// 	 
// 		if(ineur==matrix113[pp][1]){ 
//  
// 	fxAMPATHk13113[ineur]=inriseEE*taumE*(jestim*(fstim33)) -dtriseEE*fxAMPATH3113[ineur]; 
// 	fsAMPATHk13113[ineur]=dtdecayEE*(fxAMPATH3113[ineur] - fsAMPATH3113[ineur]); 
// 	fsAMPATHrk3113[ineur]=fsAMPATH3113[ineur]+0.5*fsAMPATHk13113[ineur]; 
// 	fxAMPATHk23113[ineur]=inriseEE*taumE*(jestim*(fstim33)) - dtriseEE*(fxAMPATH3113[ineur]+0.5*fxAMPATHk13113[ineur]); 
// 	fsAMPATHk23113[ineur]=dtdecayEE*((fxAMPATH3113[ineur]+0.5*fxAMPATHk13113[ineur]) - fsAMPATHrk3113[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH3113[ineur]+=fxAMPATHk23113[ineur]; /* value = value0 + increment*/ 
// 	fsAMPATH3113[ineur]+=fsAMPATHk23113[ineur]; 
//  
// 	if (fstim33>0){ 
// 		  fprintf(input11,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
//  
// 		} 
// 	 
// 	} 
//  
// 	 
// 	for(int pp=0;pp<numLines123;pp++) { 
// 	 
// 		if(ineur==matrix123[pp][1]){ 
//  
// 	fxAMPATHk13114[ineur]=inriseEE*taumE*(jjestim*(fstim41)) -dtriseEE*fxAMPATH3114[ineur]; 
// 	fsAMPATHk13114[ineur]=dtdecayEE*(fxAMPATH3114[ineur] - fsAMPATH3114[ineur]); 
// 	fsAMPATHrk3114[ineur]=fsAMPATH3114[ineur]+0.5*fsAMPATHk13114[ineur]; 
// 	fxAMPATHk23114[ineur]=inriseEE*taumE*(jjestim*(fstim41)) - dtriseEE*(fxAMPATH3114[ineur]+0.5*fxAMPATHk13114[ineur]); 
// 	fsAMPATHk23114[ineur]=dtdecayEE*((fxAMPATH3114[ineur]+0.5*fxAMPATHk13114[ineur]) - fsAMPATHrk3114[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH3114[ineur]+=fxAMPATHk23114[ineur]; /* value = value0 + increment*/ 
// 	fsAMPATH3114[ineur]+=fsAMPATHk23114[ineur]; 
//  
// 	if (fstim41>0){ 
// 		  fprintf(input12,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
// 		} 
// 	} 
//  
//  
// 	for(int pp=0;pp<numLines133;pp++) { 
// 	 
// 		if(ineur==matrix133[pp][1]){ 
//  
// 	fxAMPATHk13115[ineur]=inriseEE*taumE*(jjestim*(fstim42)) -dtriseEE*fxAMPATH3115[ineur]; 
// 	fsAMPATHk13115[ineur]=dtdecayEE*(fxAMPATH3115[ineur] - fsAMPATH3115[ineur]); 
// 	fsAMPATHrk3115[ineur]=fsAMPATH3115[ineur]+0.5*fsAMPATHk13115[ineur]; 
// 	fxAMPATHk23115[ineur]=inriseEE*taumE*(jjestim*(fstim42)) - dtriseEE*(fxAMPATH3115[ineur]+0.5*fxAMPATHk13115[ineur]); 
// 	fsAMPATHk23115[ineur]=dtdecayEE*((fxAMPATH3115[ineur]+0.5*fxAMPATHk13115[ineur]) - fsAMPATHrk3115[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH3115[ineur]+=fxAMPATHk23115[ineur]; /* value = value0 + increment*/ 
// 	fsAMPATH3115[ineur]+=fsAMPATHk23115[ineur]; 
//  
// 	if (fstim42>0){ 
// 		  fprintf(input13,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
// 		} 
// 	} 
//  
//  
// 	for(int pp=0;pp<numLines143;pp++) { 
// 	 
// 		if(ineur==matrix143[pp][1]){ 
//  
// 	fxAMPATHk13116[ineur]=inriseEE*taumE*(jjestim*(fstim43)) -dtriseEE*fxAMPATH3116[ineur]; 
// 	fsAMPATHk13116[ineur]=dtdecayEE*(fxAMPATH3116[ineur] - fsAMPATH3116[ineur]); 
// 	fsAMPATHrk3116[ineur]=fsAMPATH3116[ineur]+0.5*fsAMPATHk13116[ineur]; 
// 	fxAMPATHk23116[ineur]=inriseEE*taumE*(jjestim*(fstim43)) - dtriseEE*(fxAMPATH3116[ineur]+0.5*fxAMPATHk13116[ineur]); 
// 	fsAMPATHk23116[ineur]=dtdecayEE*((fxAMPATH3116[ineur]+0.5*fxAMPATHk13116[ineur]) - fsAMPATHrk3116[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH3116[ineur]+=fxAMPATHk23116[ineur]; /* value = value0 + increment*/ 
// 	fsAMPATH3116[ineur]+=fsAMPATHk23116[ineur]; 
//  
// 	if (fstim43>0){ 
// 		  fprintf(input14,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
// 		} 
// 	} 
//  
// 	for(int pp=0;pp<numLines153;pp++) { 
// 	 
// 		if(ineur==matrix153[pp][1]){ 
//  
// 	fxAMPATHk13117[ineur]=inriseEE*taumE*(jjestim*(fstim44)) -dtriseEE*fxAMPATH3117[ineur]; 
// 	fsAMPATHk13117[ineur]=dtdecayEE*(fxAMPATH3117[ineur] - fsAMPATH3117[ineur]); 
// 	fsAMPATHrk3117[ineur]=fsAMPATH3117[ineur]+0.5*fsAMPATHk13117[ineur]; 
// 	fxAMPATHk23117[ineur]=inriseEE*taumE*(jjestim*(fstim44)) - dtriseEE*(fxAMPATH3117[ineur]+0.5*fxAMPATHk13117[ineur]); 
// 	fsAMPATHk23117[ineur]=dtdecayEE*((fxAMPATH3117[ineur]+0.5*fxAMPATHk13117[ineur]) - fsAMPATHrk3117[ineur]); /*increment computed with runge-kutta*/ 
// 	fxAMPATH3117[ineur]+=fxAMPATHk23117[ineur]; /* value = value0 + increment*/ 
// 	fsAMPATH3117[ineur]+=fsAMPATHk23117[ineur]; 
//  
// 	if (fstim44>0){ 
// 		  fprintf(input15,"%.2f %i\n",(float)(icycle)/(float)(sub), ineur);} 
// 		} 
// 	} 
//  
//  
// 	////////////////////////////////// I --> E /////////////////////// 
//    // inhibitory synaptic current for pyramidals 
//    // Solving diff-Equ with 2nd order Runge-kutta  
//  
//     ffspk3=fhreci3[ineur][tminx]; 
//     fh=fhjei[ineur][tminx];    //simulate sigma in Differential Equations 
//  
// 	fxGABAk13[ineur]=inriseI*taumE*fh-dtriseI*fxGABA3[ineur]; 
// 	fsGABAk13[ineur]=dtdecayI*(fxGABA3[ineur] - fsGABA3[ineur]); 
// 	fsGABArk3[ineur]=fsGABA3[ineur]+0.5*fsGABAk13[ineur]; 
// 	fxGABAk23[ineur]=inriseI*taumE*fh- dtriseI*(fxGABA3[ineur]+0.5*fxGABAk13[ineur]); 
// 	fsGABAk23[ineur]=dtdecayI*((fxGABA3[ineur]+0.5*fxGABAk13[ineur]) - fsGABArk3[ineur]); 
// 	fxGABA3[ineur]+=fxGABAk23[ineur]; //final output X_gaba 
// 	fsGABA3[ineur]+=fsGABAk23[ineur]; //final output I_gaba 
//  
// 	 
// 	  fIsynk131=0; 
// 	  for(int qq=0;qq<numLines13;qq++) { 
// 		if(ineur==matrix13[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk1311[ineur]; 
// 		}} 
//  
// 	    
// 	  for(int qq=0;qq<numLines23;qq++) { 
// 		if(ineur==matrix23[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk1312[ineur]; 
// 		}} 
//  
//  
// 	    for(int qq=0;qq<numLines33;qq++) { 
// 		if(ineur==matrix33[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk1313[ineur]; 
// 		}} 
//  
//  
// 		 for(int qq=0;qq<numLines43;qq++) { 
// 		if(ineur==matrix43[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk1314[ineur]; 
// 		}} 
// 		 
// 	   
// 		   for(int qq=0;qq<numLines53;qq++) { 
// 		if(ineur==matrix53[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk1316[ineur]; 
// 		}} 
//  
//  
// 		    for(int qq=0;qq<numLines63;qq++) { 
// 		if(ineur==matrix63[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk1317[ineur]; 
// 		}} 
//  
//  
// 			 for(int qq=0;qq<numLines73;qq++) { 
// 		if(ineur==matrix73[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk1318[ineur]; 
// 		}} 
//  
//  
// 			  for(int qq=0;qq<numLines83;qq++) { 
// 		if(ineur==matrix83[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk1319[ineur]; 
// 		}} 
//  
// 	   
// 			    for(int qq=0;qq<numLines93;qq++) { 
// 		if(ineur==matrix93[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk13111[ineur]; 
// 		}} 
//  
//  
// 				 for(int qq=0;qq<numLines103;qq++) { 
// 		if(ineur==matrix103[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk13112[ineur]; 
// 		}} 
//  
//  
// 				  for(int qq=0;qq<numLines113;qq++) { 
// 		if(ineur==matrix113[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk13113[ineur]; 
// 		}} 
//  
//  
//         for(int qq=0;qq<numLines123;qq++) { 
// 		if(ineur==matrix123[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk13114[ineur]; 
// 		}} 
//  
// 				  for(int qq=0;qq<numLines133;qq++) { 
// 		if(ineur==matrix133[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk13115[ineur]; 
// 		}} 
//  
//  
// 				  for(int qq=0;qq<numLines143;qq++) { 
// 		if(ineur==matrix143[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk13116[ineur]; 
// 		}} 
//  
// 				  for(int qq=0;qq<numLines153;qq++) { 
// 		if(ineur==matrix153[qq][1]){ 
// 			fIsynk131= fIsynk131+fsAMPATHk13117[ineur]; 
// 		}} 
//  
//         // excitatory synaptic current for PY 
//         fIsynk131=fIsynk131+fsAMPAk13[ineur]-fsGABAk13[ineur]+isAMPATHk1[ineur]; 
// 				    
//  
// 	// taum(dV/dt)=-V+Vinteractions+Vext 
//  
// 	fFE13=inmE*(fIsyn31 - fhi3[ineur]); 
// 	fFE23=inmE*((fIsyn31+fIsynk131) - (fhi3[ineur]+dt*fFE13)); 
// 	fFE3=0.5*dt*(fFE13+fFE23); 
// 	fhi3[ineur]+=fFE3; 
//  
// 	  
// 	   /****** Is neuron refractory? *******/ 
//  
// 	   if (ineur<NE1 && ftspki3[ineur]>=0 && (icycle-ftspki3[ineur]<taurpE*sub)) { 
// 	fvi3[ineur]=0; 
// 	fhi3[ineur]=resetE; 
//       } 
//  
// 		 /****** Is neuron above threshold? ******/ 
//  
//      if (fhi3[ineur]>threshold) {fvi3[ineur]=1;} 
//       else {fvi3[ineur]=0;} 
//  
// 	 
// ///////recording pre-synaptic activity 
//  
// 	  if (fvi3[ineur]==1) { 
//  
// 	ftspki3[ineur]=icycle; 
//  
// 	if(ineur<fNE) {fhi3[ineur]=resetE;} 
//  
// 	else {fhi3[ineur]=resetI;} 
//  
// 	for(fzz3=0; fzz3<fNcon3[ineur]; fzz3++) { 
//  
// 	  fjn3=fA3[fzz3][ineur]; 
//  
// 	  tminx=(icycle+delaysub)%CYCSIZE; 
//  
// 	  if(ineur<fNE){ 
// 	    fhrece3[fjn3][tminx]++; 
// 		fhjee[fjn3][tminx]=fhjee[fjn3][tminx]+hjee[ineur][fjn3]; 
// 		fhjie[fjn3][tminx]=fhjie[fjn3][tminx]+hjie[ineur][fjn3]; 
// 	  } 
// 	  else{ 
// 	    if (ineur<fNE+fNI){ 
// 	      fhreci3[fjn3][tminx]++; 
// 		  fhjei[fjn3][tminx]=fhjei[fjn3][tminx]+hjei[ineur][fjn3]; 
// 		  fhjii[fjn3][tminx]=fhjii[fjn3][tminx]+hjii[ineur][fjn3]; 
//  
// 	   } 
// 	} 
// 	  }} 
//  
// 	  tminx=icycle%CYCSIZE; 
// 	 
// 	  fhrece3[ineur][tminx]=0; 
//       fhreci3[ineur][tminx]=0; 
// 	  fhjee[ineur][tminx]=0; 
// 	  fhjei[ineur][tminx]=0; 
// 	  fhjie[ineur][tminx]=0; 
// 	  fhjii[ineur][tminx]=0; 
//  
// //save neural activities of the hidden layer in output files 
// 	   
// 	   if (fvi3[ineur]==1 && ineur<NE1){ 
// 	fprintf(testspiketimesE3, "%.2f %i\n", (float)(icycle)/(float)(sub), ineur); 
//       } 
// 	   // "testspiketimesE"3" " shows the neural activities of the hidden layer 
// 	    nazar4=0; 
// 		nazar5=0; 
// 		nazar6=0; 
// 		nazar7=0; 
//  
// 	    for(int hh=0;hh<minimum;hh++) {   
//  
// 		   if (ineur==matrix34[hh][1]){ 
// 			   if ( fvi3[ineur]==1){ 
// 				   fhrece4++; 
// 				   fjee4=fjee4+jee4[nazar4][0];} 
// 		   } 
// 			       nazar4++; 
// 		   } 
//  
//  
// 		 for(int hh=0;hh<minimum;hh++) { 
//  
// 		   if (ineur==matrix35[hh][1]){ 
// 			   if ( fvi3[ineur]==1){ 
// 				   fhrece5++; 
// 				   fjee5=fjee5+jee5[nazar5][0];} 
// 		   } 
// 			       nazar5++; 
// 		   } 
//  
//  
//  
// 		  for(int hh=0;hh<minimum;hh++) { 
//  
// 		   if (ineur==matrix36[hh][1]){ 
// 			   if ( fvi3[ineur]==1){ 
// 				   fhrece6++; 
// 				   fjee6=fjee6+jee6[nazar6][0];} 
// 		   } 
// 			       nazar6++; 
// 		   } 
//  
//  
//  
// 		   for(int hh=0;hh<minimum;hh++) { 
//  
// 		   if (ineur==matrix37[hh][1]){ 
// 			   if ( fvi3[ineur]==1){ 
// 				   fhrece7++; 
// 				   fjee7=fjee7+jee7[nazar7][0];} 
// 		   } 
// 			       nazar7++; 
// 		   } 
//  
//  
//  
//  
// 	    } // end of PY loop  
//  
// /////////////////////////////////////////////////////////////////////////////////// 
//  
// 		for(ineur=fNE;ineur<fNE+fNI;ineur++) { // begin IN loop 
//  
//       tminx=icycle%CYCSIZE; 
//       istim=poidev(ifrstim,&idum); 
//  
//  
// 	  iIsyn3=fsAMPA3[ineur]-fsGABA3[ineur]+isAMPATH[ineur]+sAMPACC[ineur]; 
// 	   
//  
// 	/* 	///////////////////////////////// E-->I ////////////////////////// */ 
//       // excitatory synaptic current for interneurons (we have 10 IN ) 
// 	  //Solving with 2nd order Runge-Kutta 
//  
//     ffspk3=fhrece3[ineur][tminx]; 
//     fh=fhjie[ineur][tminx];    //sigma in Differential Equations 
//  
// 	fxAMPAk13[ineur]=inriseEI*taumI*(fh)-dtriseEI*fxAMPA3[ineur]; 
// 	fsAMPAk13[ineur]=dtdecayEI*(fxAMPA3[ineur] - fsAMPA3[ineur]); 
// 	fsAMPArk3[ineur]=fsAMPA3[ineur]+0.5*fsAMPAk13[ineur]; 
// 	fxAMPAk23[ineur]=inriseEI*taumI*(fh)- dtriseEI*(fxAMPA3[ineur]+0.5*fxAMPAk13[ineur]); 
// 	fsAMPAk23[ineur]=dtdecayEI*((fxAMPA3[ineur]+0.5*fxAMPAk13[ineur]) - fsAMPArk3[ineur]); 
// 	fxAMPA3[ineur]+=fxAMPAk23[ineur]; //final output X-ampa 
// 	fsAMPA3[ineur]+=fsAMPAk23[ineur]; //final output I-ampa 
//  
// 	// inupt spike train for IN that is 1spike/ms 
// 	ixAMPATHk1[ineur]=inriseEE*taumE*(jestim*(istim)) -dtriseEE*ixAMPATH[ineur]; 
// 	isAMPATHk1[ineur]=dtdecayEE*(ixAMPATH[ineur] - isAMPATH[ineur]); 
// 	isAMPATHrk[ineur]=isAMPATH[ineur]+0.5*isAMPATHk1[ineur]; 
// 	ixAMPATHk2[ineur]=inriseEE*taumE*(jestim*(istim)) - dtriseEE*(ixAMPATH[ineur]+0.5*ixAMPATHk1[ineur]); 
// 	isAMPATHk2[ineur]=dtdecayEE*((ixAMPATH[ineur]+0.5*ixAMPATHk1[ineur]) - isAMPATHrk[ineur]); /*increment computed with runge-kutta*/ 
// 	ixAMPATH[ineur]+=ixAMPATHk2[ineur];  
// 	isAMPATH[ineur]+=isAMPATHk2[ineur];  
// 	// noise component 
// 	xAMPACCk1[ineur]=inriseEE*taumE*(jee*(noise)) -dtriseEE*xAMPACC[ineur]; 
// 	sAMPACCk1[ineur]=dtdecayEE*(xAMPACC[ineur] - sAMPACC[ineur]); 
// 	sAMPACCrk[ineur]=sAMPACC[ineur]+0.5*sAMPACCk1[ineur]; 
// 	xAMPACCk2[ineur]=inriseEE*taumE*(jee*(noise)) - dtriseEE*(xAMPACC[ineur]+0.5*xAMPACCk1[ineur]); 
// 	sAMPACCk2[ineur]=dtdecayEE*((xAMPACC[ineur]+0.5*xAMPACCk1[ineur]) - sAMPACCrk[ineur]); /*increment computed with runge-kutta*/ 
// 	xAMPACC[ineur]+=xAMPACCk2[ineur]; // noise output 
// 	sAMPACC[ineur]+=sAMPACCk2[ineur];  
//  
// 	////////////////////////////////// I --> I /////////////////////// 
//     
// 	  //inhibitory synaptic current for interneurons  
// 	  //Solving with 2nd order Runge-Kutta 
//  
//    ffspk3=fhreci3[ineur][tminx]; 
//    fh=fhjii[ineur][tminx];     //sigma in Differential Equations 
//  
// 	fxGABAk13[ineur]=inriseI*taumI*fh-dtriseI*fxGABA3[ineur]; 
// 	fsGABAk13[ineur]=dtdecayI*(fxGABA3[ineur] - fsGABA3[ineur]); 
// 	fsGABArk3[ineur]=fsGABA3[ineur]+0.5*fsGABAk13[ineur]; 
// 	fxGABAk23[ineur]=inriseI*taumI*fh- dtriseI*(fxGABA3[ineur]+0.5*fxGABAk13[ineur]); 
// 	fsGABAk23[ineur]=dtdecayI*((fxGABA3[ineur]+0.5*fxGABAk13[ineur]) - fsGABArk3[ineur]); 
// 	fxGABA3[ineur]+=fxGABAk23[ineur]; //final output x_gaba 
// 	fsGABA3[ineur]+=fsGABAk23[ineur]; // final output I_gaba 
//  
// 	// synaptic current for IN 
// 	iIsynk13=fsAMPAk13[ineur]-fsGABAk13[ineur]+isAMPATHk1[ineur]+sAMPACCk1[ineur]; 
//  
//  
// 	// taum(dV/dt)=-V+Vinteractions+Vext 
//  
// 	fFI13=inmI*(iIsyn3 - fhi3[ineur]); 
// 	fFI23=inmI*((iIsyn3+iIsynk13) - (fhi3[ineur]+dt*fFI13)); 
// 	fFI3=0.5*dt*(fFI13+fFI23); 
// 	fhi3[ineur]+=fFI3; 
//  
// 	   /****** Is neuron refractory? *******/ 
//  
// 	    
// 		 if (ineur>=NE1 && ftspki3[ineur]>=0 && (icycle-ftspki3[ineur]<taurpI*sub)) { 
// 	fvi3[ineur]=0; 
// 	fhi3[ineur]=resetI; 
//       } 
//  
//  
//  
// 		 /****** Is neuron above threshold? ******/ 
//  
//      if (fhi3[ineur]>threshold) {fvi3[ineur]=1;} 
//       else {fvi3[ineur]=0;} 
//  
// 	 
//       //recording pre-synaptic activity 
// 	  // calculating the SIGMA of diff-Equ 
//  
// 	  if (fvi3[ineur]==1) { 
//  
// 	ftspki3[ineur]=icycle; 
//  
// 	if(ineur<fNE) {fhi3[ineur]=resetE;} 
//  
// 	else {fhi3[ineur]=resetI;} 
//  
// 	for(fzz3=0; fzz3<fNcon3[ineur]; fzz3++) { 
//  
// 	  fjn3=fA3[fzz3][ineur]; 
//  
// 	  tminx=(icycle+delaysub)%CYCSIZE; 
//  
// 	  if(ineur<fNE){ 
// 	    fhrece3[fjn3][tminx]++; 
// 		fhjee[fjn3][tminx]=fhjee[fjn3][tminx]+hjee[fjn3][ineur]; 
// 		fhjei[fjn3][tminx]=fhjei[fjn3][tminx]+hjei[fjn3][ineur]; 
// 	  } 
// 	  else{ 
// 	    if (ineur<fNE+fNI){ 
// 	      fhreci3[fjn3][tminx]++; 
// 		  fhjie[fjn3][tminx]=fhjie[fjn3][tminx]+hjie[fjn3][ineur]; 
// 		  fhjii[fjn3][tminx]=fhjii[fjn3][tminx]+hjii[fjn3][ineur]; 
// 	   } 
// 	}}} 
//  
//  
// 	  tminx=icycle%CYCSIZE; 
// 	 
//  
//  
// 	  fhrece3[ineur][tminx]=0; 
//       fhreci3[ineur][tminx]=0; 
// 	  fhjee[ineur][tminx]=0; 
// 	  fhjei[ineur][tminx]=0; 
// 	  fhjie[ineur][tminx]=0; 
// 	  fhjii[ineur][tminx]=0; 
//  
// 	  
// 	       
//  
// 	    } // end of IN loop  
//  
// //////////////////////////////////////////////////////////////////////////////////////// 
//  
// //solving diff-equations for 4 output PY neurons  
// 	 
// 	fxAMPAk134=inriseEE*taumE*((fjee4)*(1))-dtriseEE*fxAMPA34; 
// 	fsAMPAk134=dtdecayEE*(fxAMPA34- fsAMPA34); 
// 	fsAMPArk34=fsAMPA34+0.5*fsAMPAk134; 
// 	fxAMPAk234=inriseEE*taumE*((fjee4)*(1))- dtriseEE*(fxAMPA34+0.5*fxAMPAk134); 
// 	fsAMPAk234=dtdecayEE*((fxAMPA34+0.5*fxAMPAk134) - fsAMPArk34);  
// 	fxAMPA34+=fxAMPAk234; // hidden ("3") be first output neuron ("4") 
// 	fsAMPA34+=fsAMPAk234; 
//  
// 	fxAMPAk135=inriseEE*taumE*((fjee5)*(1))-dtriseEE*fxAMPA35; 
// 	fsAMPAk135=dtdecayEE*(fxAMPA35- fsAMPA35); 
// 	fsAMPArk35=fsAMPA35+0.5*fsAMPAk135; 
// 	fxAMPAk235=inriseEE*taumE*((fjee5)*(1))- dtriseEE*(fxAMPA35+0.5*fxAMPAk135); 
// 	fsAMPAk235=dtdecayEE*((fxAMPA35+0.5*fxAMPAk135) - fsAMPArk35);  
// 	fxAMPA35+=fxAMPAk235; // hidden ("3") be 2nd output neuron ("5") 
// 	fsAMPA35+=fsAMPAk235; 
//  
// 	fxAMPAk136=inriseEE*taumE*((fjee6)*(1))-dtriseEE*fxAMPA36; 
// 	fsAMPAk136=dtdecayEE*(fxAMPA36- fsAMPA36); 
// 	fsAMPArk36=fsAMPA36+0.5*fsAMPAk136; 
// 	fxAMPAk236=inriseEE*taumE*((fjee6)*(1))- dtriseEE*(fxAMPA36+0.5*fxAMPAk136); 
// 	fsAMPAk236=dtdecayEE*((fxAMPA36+0.5*fxAMPAk136) - fsAMPArk36);  
// 	fxAMPA36+=fxAMPAk236; // hidden ("3") be 3rd output neuron ("6") 
// 	fsAMPA36+=fsAMPAk236; 
//  
//  
// 	fxAMPAk137=inriseEE*taumE*((fjee7)*(1))-dtriseEE*fxAMPA37; 
// 	fsAMPAk137=dtdecayEE*(fxAMPA37- fsAMPA37); 
// 	fsAMPArk37=fsAMPA37+0.5*fsAMPAk137; 
// 	fxAMPAk237=inriseEE*taumE*((fjee7)*(1))- dtriseEE*(fxAMPA37+0.5*fxAMPAk137); 
// 	fsAMPAk237=dtdecayEE*((fxAMPA37+0.5*fxAMPAk137) - fsAMPArk37);  
// 	fxAMPA37+=fxAMPAk237; // hidden ("3") be 4th output neuron ("7") 
// 	fsAMPA37+=fsAMPAk237; 
//  
//  
//       fhrece4=0.; 
//       fhreci4=0.; 
// 	  fhrece5=0.; 
//       fhreci5=0.; 
// 	  fhrece6=0.; 
//       fhreci6=0.; 
// 	  fhrece7=0.; 
//       fhreci7=0.; 
// 	  fjee4=0; 
// 	  fjee5=0; 
// 	  fjee6=0; 
// 	  fjee7=0; 
//  
//  
// 	 fIsyn4=fsAMPA34; 
// 	 fIsynk14=fsAMPAk134; 
//  
// 	 fIsyn5=fsAMPA35; 
// 	 fIsynk15=fsAMPAk135; 
//  
// 	 fIsyn6=fsAMPA36; 
// 	 fIsynk16=fsAMPAk136; 
//  
// 	 fIsyn7=fsAMPA37; 
// 	 fIsynk17=fsAMPAk137; 
//  
// 	fFE14=inmE*(fIsyn4 - fhi4); 
// 	fFE24=inmE*((fIsyn4+fIsynk14) - (fhi4+dt*fFE14)); 
// 	fFE4=0.5*dt*(fFE14+fFE24); 
// 	fhi4+=fFE4; 
//  
//  
// 	fFE15=inmE*(fIsyn5 - fhi5); 
// 	fFE25=inmE*((fIsyn5+fIsynk15) - (fhi5+dt*fFE15)); 
// 	fFE5=0.5*dt*(fFE15+fFE25); 
// 	fhi5+=fFE5; 
//  
// 	fFE16=inmE*(fIsyn6- fhi6); 
// 	fFE26=inmE*((fIsyn6+fIsynk16) - (fhi6+dt*fFE16)); 
// 	fFE6=0.5*dt*(fFE16+fFE26); 
// 	fhi6+=fFE6; 
//  
//  
// 	fFE17=inmE*(fIsyn7 - fhi7); 
// 	fFE27=inmE*((fIsyn7+fIsynk17) - (fhi7+dt*fFE17)); 
// 	fFE7=0.5*dt*(fFE17+fFE27); 
// 	fhi7+=fFE7; 
//  
//  
// 	 if (ftspki4>=0 && (icycle-ftspki4<taurpE*sub)) { 
// 	fvi4=0; 
// 	fhi4=resetE; 
//       } 
//  
//  
// 		 if (ftspki5>=0 && (icycle-ftspki5<taurpE*sub)) { 
// 	fvi5=0; 
// 	fhi5=resetE; 
//       } 
//  
// 		  if (ftspki6>=0 && (icycle-ftspki6<taurpE*sub)) { 
// 	fvi6=0; 
// 	fhi6=resetE; 
//       } 
//  
// 		   if (ftspki7>=0 && (icycle-ftspki7<taurpE*sub)) { 
// 	fvi7=0; 
// 	fhi7=resetE; 
//       } 
// 	   
//  
// 	  if (fhi4>threshold) {fvi4=1;} 
//       else {fvi4=0;} 
//  
// 	  if (fhi5>threshold) {fvi5=1;} 
//       else {fvi5=0;} 
//  
// 	   if (fhi6>threshold) {fvi6=1;} 
//       else {fvi6=0;} 
//  
// 	   if (fhi7>threshold) {fvi7=1;} 
//       else {fvi7=0;} 
//  
//  
// 	  if (fvi4==1) { 
// 	ftspki4=icycle; 
// 	fhi4=resetE;} 
//  
// 	  if (fvi5==1) { 
// 	ftspki5=icycle; 
// 	fhi5=resetE;} 
//  
// 	   if (fvi6==1) { 
// 	ftspki6=icycle; 
// 	fhi6=resetE;} 
//  
// 	    if (fvi7==1) { 
// 	ftspki7=icycle; 
// 	fhi7=resetE;} 
//  
//  
//       
// 	//Separating trials with "123456" phrase  
//     // we used "123456" to recognize the spikes in individual trials 
//  
// 		if (icycle==sub*time-1 && uu<trail-1)
// 		{ 
// 			fprintf(testspiketimesE4, "%i\n", 123456); 
// 			fprintf(testspiketimesE5, "%i\n", 123456); 
// 			fprintf(testspiketimesE6, "%i\n", 123456); 
// 			fprintf(testspiketimesE7, "%i\n", 123456); 
//       } 
//  
//  
// 	  //save result in output file 
// 
// //       cout<<"saving results..."<<endl;
// 	   
//       if (fvi4==1 && fsAMPA34>fsAMPA35 && fsAMPA34>fsAMPA36){ 
// 	fprintf(testspiketimesE4, "%.2f\n", (float)(icycle)/(float)(sub));
// 	it = outputLayer->begin();
// 	it->resize(it->size());
// 	it->push_back((float)(icycle)/(float)(sub));
//   
//       } 
// 	   // testspiketimesE4: output file of 1st output neuron 
// 	    if (fvi5==1 && fsAMPA35>fsAMPA36 && fsAMPA35>fsAMPA37){ 
// 	fprintf(testspiketimesE5, "%.2f\n", (float)(icycle)/(float)(sub)); 
// 	it = outputLayer->begin();
// 	it++;
// 	it->resize(it->size());
// 	it->push_back((float)(icycle)/(float)(sub));
//       } 
// 		// testspiketimesE5: output file of 2nd output neuron 
// 		 if (fvi6==1 && fsAMPA36>fsAMPA34 && fsAMPA36>fsAMPA37){ 
// 	fprintf(testspiketimesE6, "%.2f\n", (float)(icycle)/(float)(sub)); 
// 	it = outputLayer->begin();
// 	it=it+2;
// 	it->resize(it->size());
// 	it->push_back((float)(icycle)/(float)(sub));
//       } 
// 		 // testspiketimesE6: output file of 3rd output neuron 
// 		  if (fvi7==1 && fsAMPA37>fsAMPA35 && fsAMPA37>fsAMPA34){ 
// 	fprintf(testspiketimesE7, "%.2f\n", (float)(icycle)/(float)(sub)); 
// 	it = outputLayer->begin();
// 	it=it+3;
// 	it->resize(it->size());
// 	it->push_back((float)(icycle)/(float)(sub));
//       } 
// 	  // testspiketimesE7: output file of 4th output neuron 
//  
// 	 
// 		  for(ipr=0;ipr<NE1;ipr++) { 
//  
// 		if(fvi3[ipr]==1) {ffrE3++;}} 
//  
// 		if(fvi4==1) {ffrE4++;} 
// 		if(fvi5==1) {ffrE5++;} 
// 		if(fvi6==1) {ffrE6++;} 
// 		if(fvi7==1) {ffrE7++;} 
//  
// 	 
//  
//   } //end of time loop  
//   }//end of trial loop  
//    
//          fclose(testspiketimesE3); 
// 		 fclose(testspiketimesE4); 
// 		 fclose(testspiketimesE5); 
// 		 fclose(testspiketimesE6); 
// 		 fclose(testspiketimesE7); 
//  
//   
//    
//   
//   fclose(input1); 
//   fclose(input2); 
//   fclose(input3); 
//   fclose(input4); 
//   fclose(input5); 
//   fclose(input6); 
//   fclose(input7); 
//   fclose(input8); 
//   fclose(input9); 
//   fclose(input10); 
//   fclose(input11); 
//   fclose(input12); 
//   fclose(input13); 
//   fclose(input14); 
//   fclose(input15); 
//   
//  
// 
//   
// }
// 
// float gammln(float xx)  
// {
// 	double x,y,tmp,ser;
// 	static double cof[6]={76.18009172947146,-86.50532032941677,
// 		24.01409824083091,-1.231739572450155,
// 		0.1208650973866179e-2,-0.5395239384953e-5};
// 	int j;
// 
// 	y=x=xx;
// 	tmp=x+5.5;
// 	tmp -= (x+0.5)*log(tmp);
// 	ser=1.000000000190015;
// 	for (j=0;j<=5;j++) ser += cof[j]/++y;
// 	return -tmp+log(2.5066282746310005*ser/x); // the output of this random function
// }
// 
// 
// float ran1(long *idum)
// {
// 	int j;
// 	long k;
// 	static long iy=0;
// 	static long iv[NTAB];
// 	float temp;
// 
// 	if (*idum <= 0 || !iy) {
// 		if (-(*idum) < 1) *idum=1;
// 		else *idum = -(*idum);
// 		for (j=NTAB+7;j>=0;j--) {
// 			k=(*idum)/IQ;
// 			*idum=IA*(*idum-k*IQ)-IR*k;
// 			if (*idum < 0) *idum += IM;
// 			if (j < NTAB) iv[j] = *idum;
// 		}
// 		iy=iv[0];
// 	}
// 	k=(*idum)/IQ;
// 	*idum=IA*(*idum-k*IQ)-IR*k;
// 	if (*idum < 0) *idum += IM;
// 	j=iy/NDIV;
// 	iy=iv[j];
// 	iv[j] = *idum;
// 	if ((temp=AM*iy) > RNMX) return RNMX;
// 	else return temp;  // output of random function 
// }
// 
// float gasdev(long *idum)
// {
// 	float ran1(long *idum);
// 	static int iset=0;
// 	static float gset;
// 	float fac,rsq,v1,v2;
// 
// 	if  (iset == 0) {
// 		do {
// 			v1=2.0*ran1(idum)-1.0;
// 			v2=2.0*ran1(idum)-1.0;
// 			rsq=v1*v1+v2*v2;
// 		} while (rsq >= 1.0 || rsq == 0.0);
// 		fac=sqrt(-2.0*log(rsq)/rsq);
// 		gset=v1*fac;
// 		iset=1;
// 		return v2*fac;
// 	} else {
// 		iset=0;
// 		return gset;  //output
// 	}
// }
// 
// float poidev(float xm, long *idum)
// {
// 	float gammln(float xx);
// 	float ran1(long *idum);
// 	static float sq,alxm,g,oldm=(-1.0);
// 	float em,t,y;
// 
// 	if (xm < 12.0) {
// 		if (xm != oldm) {
// 			oldm=xm;
// 			g=exp(-xm);
// 		}
// 		em = -1;
// 		t=1.0;
// 		do {
// 			++em;
// 			t *= ran1(idum);
// 		} while (t > g);
// 	} else {
// 		if (xm != oldm) {
// 			oldm=xm;
// 			sq=sqrt(2.0*xm);
// 			alxm=log(xm);
// 			g=xm*alxm-gammln(xm+1.0);
// 		}
// 		do {
// 			do {
// 				y=tan(PI*ran1(idum));
// 				em=sq*y+xm;
// 			} while (em < 0.0);
// 			em=floor(em);
// 			t=0.9*(1.0+y*y)*exp(em*alxm-gammln(em+1.0)-g);
// 		} while (ran1(idum) > t);
// 	}
// 	return em;   // output spike train
// }
// 
// 
// double gaussrand()
// {
// 	static double V1, V2, S;
// 	static int phase = 0;
// 	double X;
// 
// 	if(phase == 0) {
// 		do {
// 			double U1 = (double)rand() / RAND_MAX;
// 			double U2 = (double)rand() / RAND_MAX;
// 
// 			V1 = 2 * U1 - 1;
// 			V2 = 2 * U2 - 1;
// 			S = V1 * V1 + V2 * V2;
// 			} while(S >= 1 || S == 0);
// 
// 		X = V1 * sqrt(-2 * log(S) / S);
// 	} else
// 		X = V2 * sqrt(-2 * log(S) / S);
// 
// 	phase = 1 - phase;
// 
// 	return X;
// }
// */*/

void LSMRunningFake(int curr_stim,std::vector< std::vector< float > >* outputLayer)
{
  std::vector<std::vector<float> >::iterator it;
  float n;
  int stim=0;
  srand(time(NULL));
//fake output layer
  
  for( it = outputLayer->begin(); it != outputLayer->end(); ++it )
  {
    if(stim==curr_stim)
    {
      n = rand() % 200 + 100;
    }
    else
    {
      n = rand() % 50;
    }
    for(int i=0;i<n;i++)
    {
      it->resize(it->size());
      it->push_back((float)(rand() % 600));
    }
    stim++;
    cout<<"out->"<<n<<endl;
  }  

}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

int resetMN256(int handle)
{
  int neurons =NEURONS;
  int plastic_syn =PLASTIC_SYN;
  int nonplastic_syn =NONPLASTIC_SYN;
  
  //reset synapses
  for(int i=0;i<neurons;i++)
  {
    for(int j=0;j<nonplastic_syn;j++)
    {
      setNonPlastic(j,i,RESET_SYN,RECURRENT_NONPLASTIC,handle); //write recurrency
      setNonPlastic(j,i,RESET_SYN,BRD_NONPLASTIC,handle); //write broadcast
      setNonPlastic(j,i,RESET_SYN,W0_NONPLASTIC,handle);//write weight
      setNonPlastic(j,i,RESET_SYN,W1_NONPLASTIC,handle);//write weight
      setNonPlastic(j,i,RESET_SYN,ER_NONPLASTIC,handle);//write if excitatory
    }
    for(int k=0;k<plastic_syn;k++)
    {
      setPlasticLatch(k,i,RESET_SYN,RECURRENT_PLASTIC,handle);//write recurrency
      setPlasticLatch(k,i,RESET_SYN,BRD_PLASTIC,handle);//write broadcast
      setPlasticHL(k,i,LOW_STATE_PLASTIC,handle);
    }
  }
}


int initMN256(int classes,int neuronPerClass,int Input,int handle)
{
  
  
  int res=-1;
  int neurons =NEURONS;
  int synapses =PLASTIC_SYN+NONPLASTIC_SYN;
  int outputNeurons=(classes*neuronPerClass);
  int hiddenNeurons=neurons-outputNeurons;
  int offset_np=PLASTIC_SYN;
  
  int EIvec[] = {0,0,0,1,1,1,1,1,1,1}; //30%inhibiotory, 70%excitatory
  boost::random::mt19937 gen;
  boost::random::uniform_int_distribution<> dist(0, 9);
  
  if(hiddenNeurons>Input)
  {
    res=1;
    //////////////////////////////////////qui bisogna abilitare la plasticità neurale/////////////////////
    // create conection matrices
    matrix2Di R(neurons,synapses); //recurrency matrix
    matrix2Di W(neurons,synapses); //weight matrix
    matrix2Di B(neurons,synapses); //broadcast matrix
    matrix2Di EI(neurons,synapses); //excitatory/inhibitory matrix
    // clear connection matrices
    R.clear();
    W.clear();
    B.clear();
    EI.clear();
    //create non-plastic connection between input and hidden layer
    for (int i=0;i<hiddenNeurons;i++)
    {
      for (int j=0;j<Input;j++)
      {
	B(i,j+offset_np)=1;
	R(i,j+offset_np)=0;
	W(i,j+offset_np)=rand()%2;
	EI(i,j+offset_np)=EIvec[dist(gen)];
	
	//write to nm256
	setNonPlastic(j,i,RESET_SYN,RECURRENT_NONPLASTIC,handle); //write recurrency
	setNonPlastic(j,i,SET_SYN,BRD_NONPLASTIC,handle); //write broadcast
	if(W(i,j+offset_np)==1)//write weight 
	{
	  setNonPlastic(j,i,SET_SYN,W0_NONPLASTIC,handle);
	  setNonPlastic(j,i,SET_SYN,W1_NONPLASTIC,handle);
	}
	else
	{
	  setNonPlastic(j,i,RESET_SYN,W0_NONPLASTIC,handle); 
	  setNonPlastic(j,i,RESET_SYN,W1_NONPLASTIC,handle);
	}
	if(EI(i,j+offset_np)==1)//write if excitatory/inhibitory synapses 
	{
	  setNonPlastic(j,i,SET_SYN,ER_NONPLASTIC,handle);
	}
	else
	{
	  setNonPlastic(j,i,RESET_SYN,ER_NONPLASTIC,handle); 
	}
	
      }
    }
    //create non-plastic connection between teaching signal and output layer
    for(int j=0;j<classes;j++)
    {
      for (int i=0;i<neuronPerClass;i++)
      {
	B(i+hiddenNeurons+neuronPerClass*j,j+offset_np+neurons-classes)=1;
	R(i+hiddenNeurons+neuronPerClass*j,j+offset_np+neurons-classes)=0;
	W(i+hiddenNeurons+neuronPerClass*j,j+offset_np+neurons-classes)=1;
	EI(i+hiddenNeurons+neuronPerClass*j,j+offset_np+neurons-classes)=1;
	
	//write to nm256
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,RESET_SYN,RECURRENT_NONPLASTIC,handle); //write recurrency
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,BRD_NONPLASTIC,handle); //write broadcast
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,W0_NONPLASTIC,handle);//write weight
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,W1_NONPLASTIC,handle);//write weight
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,ER_NONPLASTIC,handle);//write if excitatory

      }
    }
    //create connection between HL and OL
    for(int i=0;i<outputNeurons;i++)
    {
      for(int j=0;j<hiddenNeurons;j++)
      {
	B(i+hiddenNeurons,j)=1;
	R(i+hiddenNeurons,j)=1;
	W(i+hiddenNeurons,j)=rand()%2;
	
	//write to nm256
	setPlasticLatch(j,i+hiddenNeurons,SET_SYN,RECURRENT_PLASTIC,handle);//write recurrency
	setPlasticLatch(j,i+hiddenNeurons,SET_SYN,BRD_PLASTIC,handle);//write broadcast
	
	if(W(i+hiddenNeurons,j)==1)//write state
	{
	  setPlasticHL(j,i+hiddenNeurons,HIGH_STATE_PLASTIC,handle);
	}
	else
	{
	  setPlasticHL(j,i+hiddenNeurons,LOW_STATE_PLASTIC,handle);
	}
	  
      }
    }
    
    //////////printout process
    FILE* fp_w = fopen("WeightMatrix.txt", "w+");
    FILE* fp_r = fopen("RecurrencyMatrix.txt", "w+");
    FILE* fp_b = fopen("BroadcastMatrix.txt", "w+");
    FILE* fp_ei = fopen("EIMatrix.txt", "w+");
    
    for(int i=0;i<neurons;i++)
    {
      for(int j=0;j<synapses;j++)
      {
	fprintf(fp_w, "%d %s", W(i,j)," ");
	fprintf(fp_r, "%d %s", R(i,j)," ");
	fprintf(fp_b, "%d %s", B(i,j)," ");
	fprintf(fp_ei, "%d %s", EI(i,j)," ");
      }
      fprintf(fp_w, "\n" );
      fprintf(fp_r, "\n");
      fprintf(fp_b, "\n");
      fprintf(fp_ei, "\n");
    }
    fclose(fp_w);
    fclose(fp_r);
    fclose(fp_b);
    fclose(fp_ei);
    ////////
  }
  
  return res;
}

int configureMN256(matrix2Di W,matrix2Di EI,int classes,int neuronPerClass,int Input,int handle)
{
  //set the mn256 accordingly to the python code
  int res=-1;
  int neurons =NEURONS;
  int synapses =PLASTIC_SYN+NONPLASTIC_SYN;
  int outputNeurons=(classes*neuronPerClass);
  int hiddenNeurons=neurons-outputNeurons;
  int offset_np=PLASTIC_SYN;
  
  if(W.size1()!=neurons || W.size2()!=synapses)
  {
    cout<<"Wrong size of weight matrix!"<<endl;
  }
  else if(EI.size1()!=neurons || EI.size2()!=synapses)
  {
    cout<<"Wrong size of excitatory matrix!"<<endl;
  }
  else if(hiddenNeurons>Input)
  {
    res=1;
    //////////////////////////////////////qui bisogna disabilitare la plasticità neurale/////////////////////
    // create conection matrices
    matrix2Di R(neurons,synapses); //recurrency matrix
    matrix2Di B(neurons,synapses); //broadcast matrix
    // clear connection matrices
    R.clear();
    B.clear();
    //create non-plastic connection between input and hidden layer
    for (int i=0;i<hiddenNeurons;i++)
    {
      for (int j=0;j<Input;j++)
      {
	B(i,j+offset_np)=1;
	R(i,j+offset_np)=0;
	
	//write to nm256
	setNonPlastic(j,i,RESET_SYN,RECURRENT_NONPLASTIC,handle); //write recurrency
	setNonPlastic(j,i,SET_SYN,BRD_NONPLASTIC,handle); //write broadcast
	if(W(i,j+offset_np)==1)//write weight 
	{
	  setNonPlastic(j,i,SET_SYN,W0_NONPLASTIC,handle);
	  setNonPlastic(j,i,SET_SYN,W1_NONPLASTIC,handle);
	}
	else
	{
	  setNonPlastic(j,i,RESET_SYN,W0_NONPLASTIC,handle); 
	  setNonPlastic(j,i,RESET_SYN,W1_NONPLASTIC,handle);
	}
	if(EI(i,j+offset_np)==1)//write if excitatory/inhibitory synapses 
	{
	  setNonPlastic(j,i,SET_SYN,ER_NONPLASTIC,handle);
	}
	else
	{
	  setNonPlastic(j,i,RESET_SYN,ER_NONPLASTIC,handle); 
	}
	
      }
    }
    //create non-plastic connection between teaching signal and output layer
    for(int j=0;j<classes;j++)
    {
      for (int i=0;i<neuronPerClass;i++)
      {
	B(i+hiddenNeurons+neuronPerClass*j,j+offset_np+neurons-classes)=1;
	R(i+hiddenNeurons+neuronPerClass*j,j+offset_np+neurons-classes)=0;
	
	//write to nm256
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,RESET_SYN,RECURRENT_NONPLASTIC,handle); //write recurrency
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,BRD_NONPLASTIC,handle); //write broadcast
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,W0_NONPLASTIC,handle);//write weight
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,W1_NONPLASTIC,handle);//write weight
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,ER_NONPLASTIC,handle);//write if excitatory

      }
    }
    //create connection between HL and OL
    for(int i=0;i<outputNeurons;i++)
    {
      for(int j=0;j<hiddenNeurons;j++)
      {
	B(i+hiddenNeurons,j)=1;
	R(i+hiddenNeurons,j)=1;
	
	//write to nm256
	setPlasticLatch(j,i+hiddenNeurons,SET_SYN,RECURRENT_PLASTIC,handle);//write recurrency
	setPlasticLatch(j,i+hiddenNeurons,SET_SYN,BRD_PLASTIC,handle);//write broadcast
	
	if(W(i+hiddenNeurons,j)==1)//write state
	{
	  setPlasticHL(j,i+hiddenNeurons,HIGH_STATE_PLASTIC,handle);
	}
	else
	{
	  setPlasticHL(j,i+hiddenNeurons,LOW_STATE_PLASTIC,handle);
	}
	  
      }
    }
    
    //////////printout process
    FILE* fp_w = fopen("WeightMatrixOff.txt", "w+");
    FILE* fp_r = fopen("RecurrencyMatrixOff.txt", "w+");
    FILE* fp_b = fopen("BroadcastMatrixOff.txt", "w+");
    FILE* fp_ei = fopen("EIMatrixOff.txt", "w+");
    
    for(int i=0;i<neurons;i++)
    {
      for(int j=0;j<synapses;j++)
      {
	fprintf(fp_w, "%d %s", W(i,j)," ");
	fprintf(fp_r, "%d %s", R(i,j)," ");
	fprintf(fp_b, "%d %s", B(i,j)," ");
	fprintf(fp_ei, "%d %s", EI(i,j)," ");
      }
      fprintf(fp_w, "\n" );
      fprintf(fp_r, "\n");
      fprintf(fp_b, "\n");
      fprintf(fp_ei, "\n");
    }
    fclose(fp_w);
    fclose(fp_r);
    fclose(fp_b);
    fclose(fp_ei);
    ////////
  }
  
  return res;
}

int runMN256(matrix2Di trial,int binSize,int handle)
{
  //run mn256 accordingly to the input trial coming from electrodes or test dataset
  int cnt_spike=0;
  int pkg_time=0;
  spike timeVector[trial.size1()*trial.size2()];
  
  //train mn256 with the offline training data
  for(int j=0;j<trial.size2();j++) //loop on bins
  {
    for(int i=0;i<trial.size1();i++) //loop on input channel
    {
      if(trial(i,j)==1)
      {
	//collect spike
	if(cnt_spike==0)//first spike
	{
	  timeVector[cnt_spike].dTclock=START_DELAY;
	  timeVector[cnt_spike].command=i+PLASTIC_SYN+OFF_BRD_SPIKE;
	  pkg_time=ms2clock(j*binSize);
	}
	else
	{
	  pkg_time=ms2clock(j*binSize)-pkg_time;
	  timeVector[cnt_spike].dTclock=pkg_time;
	  timeVector[cnt_spike].command=i+PLASTIC_SYN+OFF_BRD_SPIKE;	  
	}
	cnt_spike++;
      }
    }
  }  
  //send spike vector
  write(handle, &timeVector[0], sizeof(spike)*cnt_spike);
}

int trainMN256(matrix2Di trial, int label, int binSize, int classes, int handle)
{
  int cnt_spike=0;
  int pkg_time=0;
  spike timeVector[trial.size1()*(trial.size2()+1)];
  
  //train mn256 with the trial by trial training data
  for(int j=0;j<trial.size2();j++) //loop on bins
  {
    //send teaching signal
    if(cnt_spike==0)//first spike
    {
      timeVector[cnt_spike].dTclock=START_DELAY;
      timeVector[cnt_spike].command=NONPLASTIC_SYN-classes+label+PLASTIC_SYN+OFF_BRD_SPIKE;
      pkg_time=0;
      cnt_spike++;
    }
    else
    {
      pkg_time=ms2clock(j*binSize)-pkg_time;
      timeVector[cnt_spike].dTclock=pkg_time;
      timeVector[cnt_spike].command=NONPLASTIC_SYN-classes+label+PLASTIC_SYN+OFF_BRD_SPIKE;
      cnt_spike++;
    }   
    for(int i=0;i<trial.size1();i++) //loop on input channel
    {
      if(trial(i,j)==1)
      {
	//collect spike
	pkg_time=ms2clock(j*binSize)-pkg_time;
	timeVector[cnt_spike].dTclock=pkg_time;
	timeVector[cnt_spike].command=i+PLASTIC_SYN+OFF_BRD_SPIKE;
	cnt_spike++;
      }
    }
  }  
  //send spike vector
  write(handle, &timeVector[0], sizeof(spike)*cnt_spike);
}

int setNonPlastic(int syn,int neur, int sr,int latch, int handle)
{
  unsigned long pkg=0;
  pkg=neur+(syn<<8)+sr+latch+OFF_SET_NONPLASTIC;
  int res=write(handle, &pkg, sizeof(long));
  return res;
}

int setPlasticLatch(int syn,int neur,int sr,int latch,int handle)
{
  unsigned long pkg=0;
  pkg=neur+(syn<<8)+sr+latch+OFF_SET_PLASTIC_LATCH;
  int res=write(handle, &pkg, sizeof(long));
  return res;
}

int setPlasticHL(int syn, int neur, int hl,int handle)
{
  unsigned long pkg=0;
  pkg=neur+(syn<<8)+hl+OFF_SET_PLASTIC_HL;
  int res=write(handle, &pkg, sizeof(long));
  return res;
}

int sendSpike(int syn, int neur,int handle)
{
  long pkg=0;
  pkg=neur+(syn<<8)+OFF_SINGLE_SPIKE;
  int res=write(handle, &pkg, sizeof(long));
  return res;
}

int sendSpikeBR(int syn,int handle)
{
  long pkg=0;
  pkg=syn+OFF_BRD_SPIKE;
  int res=write(handle, &pkg, sizeof(long));
  return res;
}

int ms2clock(int ms)
{
  return (ms*10^(-3))*MN256_CLOCK_HZ;
}

void sendStimToNM256(int curr_stim,std::vector< std::vector< float > >* outputLayer)
{
  std::vector<std::vector<float> >::iterator it;
  float n;
  int stim=0;
  srand(time(NULL));
//fake output layer
  
  for( it = outputLayer->begin(); it != outputLayer->end(); ++it )
  {
    if(stim==curr_stim)
    {
      n = rand() % 200 + 100;
    }
    else
    {
      n = rand() % 50;
    }
    for(int i=0;i<n;i++)
    {
      it->resize(it->size());
      it->push_back((float)(rand() % 600));
    }
    stim++;
    cout<<"out->"<<n<<endl;
  }  

}

///////////missmatch functions//////////////
/*
void divideDataset(dataset* Dataset,PyObject *pValue, int hiddenNeurons,double train_fraction,double thr,double gain)
{
    PyObject *pName, *pModule, *pDict, *pFunc,*pArgs,*pFuncTrain,*NN,*pArgs2;
    int spikeCount;
    char data[Dataset->trials*Dataset->stim*Dataset->channels];
    char label[Dataset->trials*Dataset->stim];
    
    //create dataset
    for(int l=0;l<Dataset->stim;l++)
    {
      for(int i=0;i<Dataset->trials;i++)
      {
	for(int j=0;j<Dataset->channels;j++)
	{
	  spikeCount=0;
	  for(int k=0;k<Dataset->bins;k++)
	  {
	    spikeCount=spikeCount+Dataset->data[k][i][j][l];
	  }
	  data[j+i*Dataset->channels+l*Dataset->trials*Dataset->channels]=(char)(((int)'0')+spikeCount);
	}
	label[i+l*Dataset->trials]=(char)(((int)'0')+l);
      }
    }
    data[Dataset->trials*Dataset->stim*Dataset->channels]='\0';
    label[Dataset->trials*Dataset->stim]='\0';

//     // Initialize the Python Interpreter
//     Py_Initialize();

    PyRun_SimpleString("import sys");
    PyRun_SimpleString("sys.path.append(\".\")");
    // Build the name object
    pName = PyString_FromString("mn256");
    PyErr_Print();
    // Load the module object
    cout<<"chiamo il modulo mn256.py"<<endl;
    pModule = PyImport_Import(pName);
    PyErr_Print();
    // pDict is a borrowed reference 
    pDict = PyModule_GetDict(pModule);
    PyErr_Print();
    // pFunc is also a borrowed reference 
    cout<<"chiamo la funzione createDataset"<<endl;
    pFunc = PyDict_GetItemString(pDict, "createDataset");
    PyErr_Print();
    //preparing data to pass as python parameter
    pArgs = Py_BuildValue ("(ssiiddd)",data,label,Dataset->channels,hiddenNeurons,train_fraction,thr,gain);
    PyErr_Print();
    
    if (PyCallable_Check(pFunc)) 
    {
        pValue=PyObject_CallObject(pFunc, pArgs);
	
    } else 
    {
        PyErr_Print();
    }
    
 
     if (pValue != NULL) 
    {
        cout<<"Dataset created"<<endl;
    }
    else 
    {
       cout<<"è andata male"<<endl;
        PyErr_Print();
    }
   
//     cout<<"chiamo la funzione train_mn256"<<endl;
//     pFuncTrain = PyDict_GetItemString(pDict, "train_mn256");
//     PyErr_Print();
//     //preparing data to pass as python parameter
//     pArgs2 = Py_BuildValue ("(O)",pValue);
//     PyErr_Print();
//     
//     
//     if (PyCallable_Check(pFuncTrain)) 
//     {
//         NN=PyObject_CallObject(pFuncTrain, pArgs2);
// 	
//     } else 
//     {
//         PyErr_Print();
//     }
    
//       Clean up
      Py_DecRef(pModule);
      Py_DecRef(pName);

//     // Finish the Python Interpreter
//     Py_Finalize();
}


void trainNetwork(PyObject *pValue,PyObject *NN,int neuronsPerClass,int n_epochs)
{
    cout<<"training network..."<<endl;
    
     if (pValue != NULL) 
    {
        cout<<"input data created"<<endl;
        Py_DECREF(pValue);
    }
    else 
    {
       cout<<"è andata male"<<endl;
        PyErr_Print();
    }
    
    PyObject *pName, *pModule, *pDict, *pFuncTrain, *pArgs2;
    
//     Py_Initialize();

    PyRun_SimpleString("import sys");
    PyRun_SimpleString("sys.path.append(\".\")");
    // Build the name object
    pName = PyString_FromString("mn256");
    PyErr_Print();
    // Load the module object
    cout<<"chiamo il modulo mn256.py"<<endl;
    pModule = PyImport_Import(pName);
    PyErr_Print();
    cout<<"modulo chiamato"<<endl;
    // pDict is a borrowed reference 
    pDict = PyModule_GetDict(pModule);
    PyErr_Print();
    //pFunc is also a borrowed reference 
    cout<<"chiamo la funzione train_mn256"<<endl;
    pFuncTrain = PyDict_GetItemString(pDict, "train_mn256");
    PyErr_Print();
    //preparing data to pass as python parameter
    pArgs2 = Py_BuildValue ("(O)",pValue);//,neuronsPerClass,n_epochs);
    PyErr_Print();
    
    
    if (PyCallable_Check(pFuncTrain)) 
    {
        NN=PyObject_CallObject(pFuncTrain, pArgs2);
	
    } else 
    {
        PyErr_Print();
    }
    
    // Clean up
//     Py_DecRef(pModule);
//     Py_DecRef(pName);
// 
//     // Finish the Python Interpreter
//     Py_Finalize();
  
}

void create(int input,PyObject *pValue)
{
   PyObject *pName, *pModule, *pDict, *pFunc, *pArgs;
    
    Py_Initialize();

    PyRun_SimpleString("import sys");
    PyRun_SimpleString("sys.path.append(\".\")");
    // Build the name object
    pName = PyString_FromString("mn256");
    PyErr_Print();
    // Load the module object
    cout<<"chiamo il modulo mn256.py"<<endl;
    pModule = PyImport_Import(pName);
    PyErr_Print();
    cout<<"modulo chiamato"<<endl;
    // pDict is a borrowed reference 
    pDict = PyModule_GetDict(pModule);
    PyErr_Print();
    //pFunc is also a borrowed reference 
    cout<<"chiamo la funzione create"<<endl;
    pFunc = PyDict_GetItemString(pDict, "createStruct");
    PyErr_Print();
    //preparing data to pass as python parameter
    pArgs = Py_BuildValue ("(i)",1);//,neuronsPerClass,n_epochs);
    PyErr_Print();
    
    
    if (PyCallable_Check(pFunc)) 
    {
        pValue=PyObject_CallObject(pFunc, pArgs);
	
    } else 
    {
        PyErr_Print();
    }
}

void read(PyObject *pValue)
{
   PyObject *pName, *pModule, *pDict, *pFunc2, *pArgs2;
  

    PyRun_SimpleString("import sys");
    PyRun_SimpleString("sys.path.append(\".\")");
    // Build the name object
    pName = PyString_FromString("mn256");
    PyErr_Print();
    // Load the module object
    cout<<"chiamo il modulo mn256.py"<<endl;
    pModule = PyImport_Import(pName);
    PyErr_Print();
    cout<<"modulo chiamato"<<endl;
    // pDict is a borrowed reference 
    pDict = PyModule_GetDict(pModule);
    PyErr_Print();
    cout<<"chiamo la funzione read"<<endl;
    pFunc2 = PyDict_GetItemString(pDict, "readData");
    PyErr_Print();
    //preparing data to pass as python parameter
    pArgs2 = Py_BuildValue ("(O)",pValue);//,neuronsPerClass,n_epochs);
    PyErr_Print();
    
    
    if (PyCallable_Check(pFunc2)) 
    {
        PyObject_CallObject(pFunc2, pArgs2);
	
    } else 
    {
        PyErr_Print();
    }
}*/